function xb = homog(xa,H)
% HOMOG projective transofrmation
%   XB = HOMOG(XA,H) function tranforms a matrix of coordinates
%   XA n x 2 (n x 3) using homography given by 3 x 3 matrix X to a matrix 
%   of coordinates XB (n x 2).
    H = H(:);
    if (size(xa,2) == 2)
        xa = [xa,ones(size(xa,1),1)];          % homogeneous coordinates
    end
    xb=[ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ];    
end