/*
 * RaspberryForceTest.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberryForceTest".
 *
 * Model version              : 1.4
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Tue Dec 20 10:51:32 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "RaspberryForceTest.h"
#include "RaspberryForceTest_private.h"
#include "RaspberryForceTest_dt.h"

/* Block signals (auto storage) */
B_RaspberryForceTest_T RaspberryForceTest_B;

/* Block states (auto storage) */
DW_RaspberryForceTest_T RaspberryForceTest_DW;

/* Real-time model */
RT_MODEL_RaspberryForceTest_T RaspberryForceTest_M_;
RT_MODEL_RaspberryForceTest_T *const RaspberryForceTest_M =
  &RaspberryForceTest_M_;
real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void RaspberryForceTest_step(void)
{
  int32_T iy;
  real_T vy;
  int32_T cnt2;
  real_T d_a;
  real_T out_idx_1;
  real_T rtb_F_idx_0;
  real_T rtb_F_idx_1;

  /* Constant: '<Root>/Constant' */
  RaspberryForceTest_B.Constant[0] = RaspberryForceTest_P.Constant_Value[0];
  RaspberryForceTest_B.Constant[1] = RaspberryForceTest_P.Constant_Value[1];

  /* S-Function (sfcn_getFoilCheck): '<S1>/MagMan Foil with error' */
  sfcn_getFoilCheck_Outputs_wrapper
    ( &RaspberryForceTest_B.MagManFoilwitherror_o1,
     &RaspberryForceTest_B.MagManFoilwitherror_o2,
     &RaspberryForceTest_B.MagManFoilwitherror_o3,
     &RaspberryForceTest_B.MagManFoilwitherror_o4,
     &RaspberryForceTest_DW.MagManFoilwitherror_DSTATE);

  /* MATLAB Function: '<S1>/Position transformation' incorporates:
   *  Constant: '<S1>/Sentinel Calibration matrix'
   */
  /* MATLAB Function 'Foil position /Position transformation': '<S8>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S8>:1:4' xa = [x,y]; */
  /* '<S8>:1:5' H = km4(:); */
  /* '<S8>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S8>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S8>:1:9' X=out(1); */
  RaspberryForceTest_B.X = ((RaspberryForceTest_B.MagManFoilwitherror_o1 *
    RaspberryForceTest_P.km4pi[0] + RaspberryForceTest_B.MagManFoilwitherror_o2 *
    RaspberryForceTest_P.km4pi[1]) + RaspberryForceTest_P.km4pi[2]) /
    ((RaspberryForceTest_B.MagManFoilwitherror_o1 * RaspberryForceTest_P.km4pi[6]
      + RaspberryForceTest_B.MagManFoilwitherror_o2 *
      RaspberryForceTest_P.km4pi[7]) + RaspberryForceTest_P.km4pi[8]);

  /* '<S8>:1:10' Y=out(2); */
  RaspberryForceTest_B.Y = ((RaspberryForceTest_B.MagManFoilwitherror_o1 *
    RaspberryForceTest_P.km4pi[3] + RaspberryForceTest_B.MagManFoilwitherror_o2 *
    RaspberryForceTest_P.km4pi[4]) + RaspberryForceTest_P.km4pi[5]) /
    ((RaspberryForceTest_B.MagManFoilwitherror_o1 * RaspberryForceTest_P.km4pi[6]
      + RaspberryForceTest_B.MagManFoilwitherror_o2 *
      RaspberryForceTest_P.km4pi[7]) + RaspberryForceTest_P.km4pi[8]);

  /* MATLAB Function: '<S6>/Embedded MATLAB Function' */
  /* MATLAB Function 'linearization/Embedded MATLAB Function': '<S9>:1' */
  /* '<S9>:1:2' Ao=zeros(2,16); */
  memset(&RaspberryForceTest_B.Ao[0], 0, sizeof(real_T) << 5U);

  /* '<S9>:1:4' for iy=1:4 */
  for (iy = 0; iy < 4; iy++) {
    /* '<S9>:1:5' for ix=1:4 */
    for (cnt2 = 0; cnt2 < 4; cnt2++) {
      /* '<S9>:1:6' [cFx, cFy] = fForce(x, y, ix, iy); */
      /* '<S9>:1:14' d=dist(x,y, ix, iy); */
      /* '<S9>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
      RaspberryForceTest_B.d = RaspberryForceTest_B.X - (1.0 + (real_T)cnt2);
      out_idx_1 = RaspberryForceTest_B.Y - (1.0 + (real_T)iy);
      RaspberryForceTest_B.d = sqrt(RaspberryForceTest_B.d *
        RaspberryForceTest_B.d + out_idx_1 * out_idx_1);

      /* '<S9>:1:15' if d~=0 */
      if (RaspberryForceTest_B.d != 0.0) {
        /* '<S9>:1:16' F=gForce(d); */
        /* '<S9>:1:43' a = 622.06; */
        /* '<S9>:1:44' b = 9.5032; */
        /* '<S9>:1:45' c = 3.1884; */
        /* '<S9>:1:46' F = x.*a./(b.*x.^2+ c).^3; */
        RaspberryForceTest_B.d = RaspberryForceTest_B.d * 622.06 / rt_powd_snf
          (RaspberryForceTest_B.d * RaspberryForceTest_B.d * 9.5032 + 3.1884,
           3.0);

        /* '<S9>:1:17' Fv=F*vector(x,y,ix,iy); */
        /* '<S9>:1:32' vx=ix-x; */
        out_idx_1 = (1.0 + (real_T)cnt2) - RaspberryForceTest_B.X;

        /* '<S9>:1:33' vy=iy-y; */
        vy = (1.0 + (real_T)iy) - RaspberryForceTest_B.Y;

        /* '<S9>:1:35' if(vx==0 && vy ==0) */
        if ((out_idx_1 == 0.0) && (vy == 0.0)) {
          /* '<S9>:1:36' v=[0 0]; */
          rtb_F_idx_0 = 0.0;
          out_idx_1 = 0.0;
        } else {
          /* '<S9>:1:37' else */
          /* '<S9>:1:38' v = [vx vy]/dist(vx, vy, 0 ,0); */
          /* '<S9>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
          d_a = sqrt(out_idx_1 * out_idx_1 + vy * vy);
          rtb_F_idx_0 = out_idx_1 / d_a;
          out_idx_1 = vy / d_a;
        }

        rtb_F_idx_0 *= RaspberryForceTest_B.d;
        out_idx_1 *= RaspberryForceTest_B.d;

        /* '<S9>:1:18' Fx=Fv(1); */
        RaspberryForceTest_B.d = rtb_F_idx_0;

        /* '<S9>:1:19' Fy=Fv(2); */
      } else {
        /* '<S9>:1:20' else */
        /* '<S9>:1:21' Fx=0; */
        RaspberryForceTest_B.d = 0.0;

        /* '<S9>:1:22' Fy=0; */
        out_idx_1 = 0.0;
      }

      /* '<S9>:1:7' Ao(1,(iy-1)*4+ix) = cFx; */
      RaspberryForceTest_B.Ao[((iy << 2) + cnt2) << 1] = RaspberryForceTest_B.d;

      /* '<S9>:1:8' Ao(2,(iy-1)*4+ix) = cFy; */
      RaspberryForceTest_B.Ao[1 + (((iy << 2) + cnt2) << 1)] = out_idx_1;
    }
  }

  /* End of MATLAB Function: '<S6>/Embedded MATLAB Function' */

  /* S-Function (cvxfasd): '<S6>/MagMan linearization' */
  cvxfasd_Outputs_wrapper(&RaspberryForceTest_B.Ao[0],
    &RaspberryForceTest_B.Constant[0], &RaspberryForceTest_B.Constant[1],
    &RaspberryForceTest_B.MagManlinearization_o1[0],
    &RaspberryForceTest_B.MagManlinearization_o2 );

  /* MATLAB Function: '<Root>/MATLAB Function' */
  /* MATLAB Function 'MATLAB Function': '<S2>:1' */
  /* '<S2>:1:3' y =u'; */
  for (iy = 0; iy < 4; iy++) {
    RaspberryForceTest_B.y[iy << 2] =
      RaspberryForceTest_B.MagManlinearization_o1[iy];
    RaspberryForceTest_B.y[1 + (iy << 2)] =
      RaspberryForceTest_B.MagManlinearization_o1[iy + 4];
    RaspberryForceTest_B.y[2 + (iy << 2)] =
      RaspberryForceTest_B.MagManlinearization_o1[iy + 8];
    RaspberryForceTest_B.y[3 + (iy << 2)] =
      RaspberryForceTest_B.MagManlinearization_o1[iy + 12];
  }

  /* End of MATLAB Function: '<Root>/MATLAB Function' */

  /* MATLAB Function: '<Root>/Nonlinearity of  magnetic force' incorporates:
   *  SignalConversion: '<S3>/TmpSignal ConversionAt SFunction Inport2'
   */
  /* MATLAB Function 'Nonlinearity of  magnetic force': '<S3>:1' */
  /*  function F = fcn(u,xmes) */
  /*  Computes vector of magnetic force exerted on the ball in x- and */
  /*  y-direction. Input arguments are excitation factors of coils and measured */
  /*  position of the ball. Contributions of the coils are superposed to get */
  /*  the overall force. */
  /*  Note, that this function only models nonlinearity of the magnetic force, */
  /*  it is not any kind of feedback control. */
  /* '<S3>:1:10' umin = 1; */
  /*  index of the 1st actuator in one dim */
  /* '<S3>:1:11' umax = 4; */
  /*  index of tohe last actuator in one dim */
  /* '<S3>:1:13' F = [0;0]; */
  rtb_F_idx_0 = 0.0;
  rtb_F_idx_1 = 0.0;

  /* '<S3>:1:15' u = abs(u); */
  for (iy = 0; iy < 16; iy++) {
    RaspberryForceTest_B.u[iy] = fabs(RaspberryForceTest_B.y[iy]);
  }

  /* '<S3>:1:16' for cnt = umin:umax */
  for (iy = 0; iy < 4; iy++) {
    /* '<S3>:1:17' for cnt2 = umin:umax */
    for (cnt2 = 0; cnt2 < 4; cnt2++) {
      /* '<S3>:1:18' F = F + [dxfce(cnt,cnt2,xmes(1),xmes(2));... */
      /* '<S3>:1:19'             dyfce(cnt,cnt2,xmes(1),xmes(2))] * u(cnt2-umin+1,cnt-umin+1); */
      /*  Compute x-component of force from coil [m,n] exerted on the ball at */
      /*  position [x,y] */
      /* '<S3>:1:27' out = -48.282*(x-m)./( (x-m).^2 + (y-n).^2 + 0.3303).^3; */
      RaspberryForceTest_B.d = RaspberryForceTest_B.X - (1.0 + (real_T)iy);
      out_idx_1 = RaspberryForceTest_B.Y - (1.0 + (real_T)cnt2);

      /*  Compute y-component of force from coil [m,n] exerted on the ball at */
      /*  position [x,y] */
      /* '<S3>:1:33' out = -48.282*(y-n)./( (x-m).^2 + (y-n).^2 + 0.3303).^3; */
      vy = RaspberryForceTest_B.X - (1.0 + (real_T)iy);
      d_a = RaspberryForceTest_B.Y - (1.0 + (real_T)cnt2);
      rtb_F_idx_0 += (RaspberryForceTest_B.X - (1.0 + (real_T)iy)) * -48.282 /
        rt_powd_snf((RaspberryForceTest_B.d * RaspberryForceTest_B.d + out_idx_1
                     * out_idx_1) + 0.3303, 3.0) * RaspberryForceTest_B.u[(iy <<
        2) + cnt2];
      rtb_F_idx_1 += (RaspberryForceTest_B.Y - (1.0 + (real_T)cnt2)) * -48.282 /
        rt_powd_snf((vy * vy + d_a * d_a) + 0.3303, 3.0) *
        RaspberryForceTest_B.u[(iy << 2) + cnt2];
    }
  }

  /* End of MATLAB Function: '<Root>/Nonlinearity of  magnetic force' */

  /* Gain: '<Root>/Gain' */
  RaspberryForceTest_B.Gain[0] = RaspberryForceTest_P.Gain_Gain * rtb_F_idx_0;
  RaspberryForceTest_B.Gain[1] = RaspberryForceTest_P.Gain_Gain * rtb_F_idx_1;

  /* MATLAB Function: '<Root>/pwm' */
  /* MATLAB Function 'pwm': '<S7>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S7>:1:3' x = max(0, min(1,x) ); */
  /*  limits */
  /* '<S7>:1:4' i = 0.18515*x + 0.069587*x.^3 + 0.19285*x.^(1/3); */
  /*  ratio to current conversion */
  /* '<S7>:1:5' pw = i/0.455/2; */
  /* '<S7>:1:6' pw(pw>0.05) = pw(pw>0.05) + 0.5; */
  /* '<S7>:1:7' pw(pw<0.5) = 0; */
  for (iy = 0; iy < 16; iy++) {
    if ((1.0 <= RaspberryForceTest_B.MagManlinearization_o1[iy]) || rtIsNaN
        (RaspberryForceTest_B.MagManlinearization_o1[iy])) {
      RaspberryForceTest_B.d = 1.0;
    } else {
      RaspberryForceTest_B.d = RaspberryForceTest_B.MagManlinearization_o1[iy];
    }

    if ((0.0 >= RaspberryForceTest_B.d) || rtIsNaN(RaspberryForceTest_B.d)) {
      RaspberryForceTest_B.pw[iy] = 0.0;
    } else {
      RaspberryForceTest_B.pw[iy] = RaspberryForceTest_B.d;
    }

    RaspberryForceTest_B.pw[iy] = ((0.18515 * RaspberryForceTest_B.pw[iy] +
      0.069587 * rt_powd_snf(RaspberryForceTest_B.pw[iy], 3.0)) + 0.19285 *
      rt_powd_snf(RaspberryForceTest_B.pw[iy], 0.33333333333333331)) / 0.455 /
      2.0;
    if (RaspberryForceTest_B.pw[iy] > 0.05) {
      RaspberryForceTest_B.pw[iy] += 0.5;
    }

    if (RaspberryForceTest_B.pw[iy] < 0.5) {
      RaspberryForceTest_B.pw[iy] = 0.0;
    }
  }

  /* '<S7>:1:8' pw=pw'; */
  for (iy = 0; iy < 4; iy++) {
    RaspberryForceTest_B.y[iy << 2] = RaspberryForceTest_B.pw[iy];
    RaspberryForceTest_B.y[1 + (iy << 2)] = RaspberryForceTest_B.pw[iy + 4];
    RaspberryForceTest_B.y[2 + (iy << 2)] = RaspberryForceTest_B.pw[iy + 8];
    RaspberryForceTest_B.y[3 + (iy << 2)] = RaspberryForceTest_B.pw[iy + 12];
  }

  for (iy = 0; iy < 4; iy++) {
    RaspberryForceTest_B.pw[iy << 2] = RaspberryForceTest_B.y[iy << 2];
    RaspberryForceTest_B.pw[1 + (iy << 2)] = RaspberryForceTest_B.y[(iy << 2) +
      1];
    RaspberryForceTest_B.pw[2 + (iy << 2)] = RaspberryForceTest_B.y[(iy << 2) +
      2];
    RaspberryForceTest_B.pw[3 + (iy << 2)] = RaspberryForceTest_B.y[(iy << 2) +
      3];
  }

  /* End of MATLAB Function: '<Root>/pwm' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&RaspberryForceTest_B.pw[0],
    &RaspberryForceTest_DW.MagManCoils_DSTATE);

  /* S-Function "sfcn_getFoilCheck_wrapper" Block: <S1>/MagMan Foil with error */
  sfcn_getFoilCheck_Update_wrapper( &RaspberryForceTest_B.MagManFoilwitherror_o1,
    &RaspberryForceTest_B.MagManFoilwitherror_o2,
    &RaspberryForceTest_B.MagManFoilwitherror_o3,
    &RaspberryForceTest_B.MagManFoilwitherror_o4,
    &RaspberryForceTest_DW.MagManFoilwitherror_DSTATE);

  /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
  sfcn_setPlatform_Update_wrapper(&RaspberryForceTest_B.pw[0],
    &RaspberryForceTest_DW.MagManCoils_DSTATE);

  /* External mode */
  rtExtModeUploadCheckTrigger(1);

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(0, RaspberryForceTest_M->Timing.taskTime0);
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.02s, 0.0s] */
    if ((rtmGetTFinal(RaspberryForceTest_M)!=-1) &&
        !((rtmGetTFinal(RaspberryForceTest_M)-
           RaspberryForceTest_M->Timing.taskTime0) >
          RaspberryForceTest_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(RaspberryForceTest_M, "Simulation finished");
    }

    if (rtmGetStopRequested(RaspberryForceTest_M)) {
      rtmSetErrorStatus(RaspberryForceTest_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++RaspberryForceTest_M->Timing.clockTick0)) {
    ++RaspberryForceTest_M->Timing.clockTickH0;
  }

  RaspberryForceTest_M->Timing.taskTime0 =
    RaspberryForceTest_M->Timing.clockTick0 *
    RaspberryForceTest_M->Timing.stepSize0 +
    RaspberryForceTest_M->Timing.clockTickH0 *
    RaspberryForceTest_M->Timing.stepSize0 * 4294967296.0;
}

/* Model initialize function */
void RaspberryForceTest_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)RaspberryForceTest_M, 0,
                sizeof(RT_MODEL_RaspberryForceTest_T));
  rtmSetTFinal(RaspberryForceTest_M, -1);
  RaspberryForceTest_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  RaspberryForceTest_M->Sizes.checksums[0] = (2020466224U);
  RaspberryForceTest_M->Sizes.checksums[1] = (796819949U);
  RaspberryForceTest_M->Sizes.checksums[2] = (1719685129U);
  RaspberryForceTest_M->Sizes.checksums[3] = (2706746111U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[8];
    RaspberryForceTest_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    systemRan[5] = &rtAlwaysEnabled;
    systemRan[6] = &rtAlwaysEnabled;
    systemRan[7] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(RaspberryForceTest_M->extModeInfo,
      &RaspberryForceTest_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(RaspberryForceTest_M->extModeInfo,
                        RaspberryForceTest_M->Sizes.checksums);
    rteiSetTPtr(RaspberryForceTest_M->extModeInfo, rtmGetTPtr
                (RaspberryForceTest_M));
  }

  /* block I/O */
  (void) memset(((void *) &RaspberryForceTest_B), 0,
                sizeof(B_RaspberryForceTest_T));

  /* states (dwork) */
  (void) memset((void *)&RaspberryForceTest_DW, 0,
                sizeof(DW_RaspberryForceTest_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    RaspberryForceTest_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* Start for Constant: '<Root>/Constant' */
  RaspberryForceTest_B.Constant[0] = RaspberryForceTest_P.Constant_Value[0];
  RaspberryForceTest_B.Constant[1] = RaspberryForceTest_P.Constant_Value[1];

  /* S-Function Block: <S1>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryForceTest_DW.MagManFoilwitherror_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryForceTest_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }
}

/* Model terminate function */
void RaspberryForceTest_terminate(void)
{
  /* (no terminate code required) */
}
