/*
 * RaspberryForceTest.h
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberryForceTest".
 *
 * Model version              : 1.4
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Tue Dec 20 10:51:32 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_RaspberryForceTest_h_
#define RTW_HEADER_RaspberryForceTest_h_
#include <math.h>
#include <string.h>
#include <float.h>
#include <stddef.h>
#ifndef RaspberryForceTest_COMMON_INCLUDES_
# define RaspberryForceTest_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_extmode.h"
#include "sysran_types.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "dt_info.h"
#include "ext_work.h"
#endif                                 /* RaspberryForceTest_COMMON_INCLUDES_ */

#include "RaspberryForceTest_types.h"

/* Shared type includes */
#include "multiword_types.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetFinalTime
# define rtmGetFinalTime(rtm)          ((rtm)->Timing.tFinal)
#endif

#ifndef rtmGetRTWExtModeInfo
# define rtmGetRTWExtModeInfo(rtm)     ((rtm)->extModeInfo)
#endif

#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
# define rtmSetStopRequested(rtm, val) ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
# define rtmGetStopRequestedPtr(rtm)   (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  ((rtm)->Timing.taskTime0)
#endif

#ifndef rtmGetTFinal
# define rtmGetTFinal(rtm)             ((rtm)->Timing.tFinal)
#endif

/* Block signals (auto storage) */
typedef struct {
  real_T Constant[2];                  /* '<Root>/Constant' */
  real_T MagManFoilwitherror_o1;       /* '<S1>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o2;       /* '<S1>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o3;       /* '<S1>/MagMan Foil with error' */
  real_T MagManlinearization_o1[16];   /* '<S6>/MagMan linearization' */
  real_T MagManlinearization_o2;       /* '<S6>/MagMan linearization' */
  real_T Gain[2];                      /* '<Root>/Gain' */
  real_T pw[16];                       /* '<Root>/pwm' */
  real_T Ao[32];                       /* '<S6>/Embedded MATLAB Function' */
  real_T u[16];
  real_T y[16];                        /* '<Root>/MATLAB Function' */
  real_T TmpSignalConversionAtsfunxyInpo[2];
  real_T TmpSignalConversionAtsfunxyIn_n[2];
  real_T X;                            /* '<S1>/Position transformation' */
  real_T Y;                            /* '<S1>/Position transformation' */
  real_T d;
  int32_T MagManFoilwitherror_o4;      /* '<S1>/MagMan Foil with error' */
} B_RaspberryForceTest_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T MagManFoilwitherror_DSTATE;   /* '<S1>/MagMan Foil with error' */
  real_T MagManCoils_DSTATE;           /* '<Root>/MagMan Coils' */
  struct {
    void *LoggedData[2];
  } ForceX_PWORK;                      /* '<Root>/Force X' */

  struct {
    void *LoggedData[2];
  } ForceY_PWORK;                      /* '<Root>/Force Y' */

  struct {
    void *LoggedData[2];
  } Position_PWORK;                    /* '<Root>/Position' */

  struct {
    void *LoggedData[2];
  } Nomalizedposition_PWORK;           /* '<S1>/Nomalized position' */

  struct {
    void *LoggedData[3];
  } Scope1_PWORK;                      /* '<S1>/Scope1' */
} DW_RaspberryForceTest_T;

/* Parameters (auto storage) */
struct P_RaspberryForceTest_T_ {
  real_T km4pi[9];                     /* Variable: km4pi
                                        * Referenced by: '<S1>/Sentinel Calibration matrix'
                                        */
  real_T Constant_Value[2];            /* Expression: [0.05, -0.05]
                                        * Referenced by: '<Root>/Constant'
                                        */
  real_T Gain_Gain;                    /* Expression: 1/68
                                        * Referenced by: '<Root>/Gain'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_RaspberryForceTest_T {
  const char_T *errorStatus;
  RTWExtModeInfo *extModeInfo;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    uint32_T checksums[4];
  } Sizes;

  /*
   * SpecialInfo:
   * The following substructure contains special information
   * related to other components that are dependent on RTW.
   */
  struct {
    const void *mappingInfo;
  } SpecialInfo;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    time_T taskTime0;
    uint32_T clockTick0;
    uint32_T clockTickH0;
    time_T stepSize0;
    time_T tFinal;
    boolean_T stopRequestedFlag;
  } Timing;
};

/* Block parameters (auto storage) */
extern P_RaspberryForceTest_T RaspberryForceTest_P;

/* Block signals (auto storage) */
extern B_RaspberryForceTest_T RaspberryForceTest_B;

/* Block states (auto storage) */
extern DW_RaspberryForceTest_T RaspberryForceTest_DW;

/* Model entry point functions */
extern void RaspberryForceTest_initialize(void);
extern void RaspberryForceTest_step(void);
extern void RaspberryForceTest_terminate(void);

/* Real-time Model object */
extern RT_MODEL_RaspberryForceTest_T *const RaspberryForceTest_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'RaspberryForceTest'
 * '<S1>'   : 'RaspberryForceTest/Foil position '
 * '<S2>'   : 'RaspberryForceTest/MATLAB Function'
 * '<S3>'   : 'RaspberryForceTest/Nonlinearity of  magnetic force'
 * '<S4>'   : 'RaspberryForceTest/XY Graph'
 * '<S5>'   : 'RaspberryForceTest/XY Graph1'
 * '<S6>'   : 'RaspberryForceTest/linearization'
 * '<S7>'   : 'RaspberryForceTest/pwm'
 * '<S8>'   : 'RaspberryForceTest/Foil position /Position transformation'
 * '<S9>'   : 'RaspberryForceTest/linearization/Embedded MATLAB Function'
 */
#endif                                 /* RTW_HEADER_RaspberryForceTest_h_ */
