/*
 * RaspberryMagmanControl.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberryMagmanControl".
 *
 * Model version              : 1.38
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Thu Dec 22 16:38:00 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "RaspberryMagmanControl.h"
#include "RaspberryMagmanControl_private.h"
#include "RaspberryMagmanControl_dt.h"

/* Block signals (auto storage) */
B_RaspberryMagmanControl_T RaspberryMagmanControl_B;

/* Block states (auto storage) */
DW_RaspberryMagmanControl_T RaspberryMagmanControl_DW;

/* Real-time model */
RT_MODEL_RaspberryMagmanControl_T RaspberryMagmanControl_M_;
RT_MODEL_RaspberryMagmanControl_T *const RaspberryMagmanControl_M =
  &RaspberryMagmanControl_M_;

/*
 * Output and update for atomic system:
 *    '<S1>/Position transformation1'
 *    '<S4>/Position transformation'
 */
void Raspber_Positiontransformation1(real_T rtu_x, real_T rtu_y, const real_T
  rtu_km4[9], B_Positiontransformation1_Ras_T *localB)
{
  /* MATLAB Function 'Camera position/Position transformation1': '<S11>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S11>:1:4' xa = [x,y]; */
  /* '<S11>:1:5' H = km4(:); */
  /* '<S11>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S11>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S11>:1:9' X=out(1); */
  localB->X = ((rtu_x * rtu_km4[0] + rtu_y * rtu_km4[1]) + rtu_km4[2]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);

  /* '<S11>:1:10' Y=out(2); */
  localB->Y = ((rtu_x * rtu_km4[3] + rtu_y * rtu_km4[4]) + rtu_km4[5]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);
}

real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void RaspberryMagmanControl_step(void)
{
  int32_T i;
  int32_T xoffset;
  real_T Fv_idx_0;
  real_T Fv_idx_1;
  real_T rtb_Sum_idx_0;
  real_T rtb_F_idx_0;
  real_T rtb_F_idx_1;

  /* S-Function (sfcn_getFoilCheck): '<S4>/MagMan Foil with error' */
  sfcn_getFoilCheck_Outputs_wrapper
    ( &RaspberryMagmanControl_B.MagManFoilwitherror_o1,
     &RaspberryMagmanControl_B.MagManFoilwitherror_o2,
     &RaspberryMagmanControl_B.MagManFoilwitherror_o3,
     &RaspberryMagmanControl_B.MagManFoilwitherror_o4,
     &RaspberryMagmanControl_DW.MagManFoilwitherror_DSTATE);

  /* MATLAB Function: '<S4>/Position transformation' incorporates:
   *  Constant: '<S4>/Sentinel Calibration matrix'
   */
  Raspber_Positiontransformation1
    (RaspberryMagmanControl_B.MagManFoilwitherror_o1,
     RaspberryMagmanControl_B.MagManFoilwitherror_o2,
     RaspberryMagmanControl_P.km4pi,
     &RaspberryMagmanControl_B.sf_Positiontransformation);

  /* S-Function (sfcn_posread_shm): '<S10>/Shared memory camera position' */
  sfcn_posread_shm_Outputs_wrapper
    ( &RaspberryMagmanControl_B.Sharedmemorycameraposition_o1,
     &RaspberryMagmanControl_B.Sharedmemorycameraposition_o2,
     &RaspberryMagmanControl_DW.Sharedmemorycameraposition_DSTA);

  /* DataTypeConversion: '<S10>/Data Type Conversion1' */
  RaspberryMagmanControl_B.DataTypeConversion1 =
    RaspberryMagmanControl_B.Sharedmemorycameraposition_o1;

  /* DataTypeConversion: '<S10>/Data Type Conversion2' */
  RaspberryMagmanControl_B.DataTypeConversion2 =
    RaspberryMagmanControl_B.Sharedmemorycameraposition_o2;

  /* MATLAB Function: '<S1>/Position transformation1' incorporates:
   *  Constant: '<S1>/Sentinel Calibration matrix1'
   */
  Raspber_Positiontransformation1(RaspberryMagmanControl_B.DataTypeConversion1,
    RaspberryMagmanControl_B.DataTypeConversion2,
    RaspberryMagmanControl_P.km4piCam,
    &RaspberryMagmanControl_B.sf_Positiontransformation1);

  /* ManualSwitch: '<Root>/Manual Switch' */
  if (RaspberryMagmanControl_P.ManualSwitch_CurrentSetting == 1) {
    RaspberryMagmanControl_B.ManualSwitch[0] =
      RaspberryMagmanControl_B.sf_Positiontransformation.X;
    RaspberryMagmanControl_B.ManualSwitch[1] =
      RaspberryMagmanControl_B.sf_Positiontransformation.Y;
  } else {
    RaspberryMagmanControl_B.ManualSwitch[0] =
      RaspberryMagmanControl_B.sf_Positiontransformation1.X;
    RaspberryMagmanControl_B.ManualSwitch[1] =
      RaspberryMagmanControl_B.sf_Positiontransformation1.Y;
  }

  /* End of ManualSwitch: '<Root>/Manual Switch' */

  /* MATLAB Function: '<S5>/Embedded MATLAB Function' */
  /* MATLAB Function 'Force to Currents/Embedded MATLAB Function': '<S14>:1' */
  /* '<S14>:1:2' Ao=zeros(2,16); */
  memset(&RaspberryMagmanControl_B.Ao[0], 0, sizeof(real_T) << 5U);

  /* '<S14>:1:4' for iy=1:4 */
  for (xoffset = 0; xoffset < 4; xoffset++) {
    /* '<S14>:1:5' for ix=1:4 */
    for (i = 0; i < 4; i++) {
      /* '<S14>:1:6' [cFx, cFy] = fForce(x, y, ix, iy); */
      /* '<S14>:1:14' d=dist(x,y, ix, iy); */
      /* '<S14>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
      RaspberryMagmanControl_B.lim = RaspberryMagmanControl_B.ManualSwitch[0] -
        (1.0 + (real_T)i);
      Fv_idx_1 = RaspberryMagmanControl_B.ManualSwitch[1] - (1.0 + (real_T)
        xoffset);
      RaspberryMagmanControl_B.lim = sqrt(RaspberryMagmanControl_B.lim *
        RaspberryMagmanControl_B.lim + Fv_idx_1 * Fv_idx_1);

      /* '<S14>:1:15' if d~=0 */
      if (RaspberryMagmanControl_B.lim != 0.0) {
        /* '<S14>:1:16' F=gForce(d); */
        /* '<S14>:1:43' a = 622.06; */
        /* '<S14>:1:44' b = 9.5032; */
        /* '<S14>:1:45' c = 3.1884; */
        /* '<S14>:1:46' F = x.*a./(b.*x.^2+ c).^3; */
        RaspberryMagmanControl_B.lim = RaspberryMagmanControl_B.lim * 622.06 /
          rt_powd_snf(RaspberryMagmanControl_B.lim *
                      RaspberryMagmanControl_B.lim * 9.5032 + 3.1884, 3.0);

        /* '<S14>:1:17' Fv=F*vector(x,y,ix,iy); */
        /* '<S14>:1:32' vx=ix-x; */
        Fv_idx_1 = (1.0 + (real_T)i) - RaspberryMagmanControl_B.ManualSwitch[0];

        /* '<S14>:1:33' vy=iy-y; */
        RaspberryMagmanControl_B.vy = (1.0 + (real_T)xoffset) -
          RaspberryMagmanControl_B.ManualSwitch[1];

        /* '<S14>:1:35' if(vx==0 && vy ==0) */
        if ((Fv_idx_1 == 0.0) && (RaspberryMagmanControl_B.vy == 0.0)) {
          /* '<S14>:1:36' v=[0 0]; */
          Fv_idx_0 = 0.0;
          Fv_idx_1 = 0.0;
        } else {
          /* '<S14>:1:37' else */
          /* '<S14>:1:38' v = [vx vy]/dist(vx, vy, 0 ,0); */
          /* '<S14>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
          RaspberryMagmanControl_B.d_a = sqrt(Fv_idx_1 * Fv_idx_1 +
            RaspberryMagmanControl_B.vy * RaspberryMagmanControl_B.vy);
          Fv_idx_0 = Fv_idx_1 / RaspberryMagmanControl_B.d_a;
          Fv_idx_1 = RaspberryMagmanControl_B.vy / RaspberryMagmanControl_B.d_a;
        }

        Fv_idx_0 *= RaspberryMagmanControl_B.lim;
        Fv_idx_1 *= RaspberryMagmanControl_B.lim;

        /* '<S14>:1:18' Fx=Fv(1); */
        RaspberryMagmanControl_B.lim = Fv_idx_0;

        /* '<S14>:1:19' Fy=Fv(2); */
      } else {
        /* '<S14>:1:20' else */
        /* '<S14>:1:21' Fx=0; */
        RaspberryMagmanControl_B.lim = 0.0;

        /* '<S14>:1:22' Fy=0; */
        Fv_idx_1 = 0.0;
      }

      /* '<S14>:1:7' Ao(1,(iy-1)*4+ix) = cFx; */
      RaspberryMagmanControl_B.Ao[((xoffset << 2) + i) << 1] =
        RaspberryMagmanControl_B.lim;

      /* '<S14>:1:8' Ao(2,(iy-1)*4+ix) = cFy; */
      RaspberryMagmanControl_B.Ao[1 + (((xoffset << 2) + i) << 1)] = Fv_idx_1;
    }
  }

  /* End of MATLAB Function: '<S5>/Embedded MATLAB Function' */

  /* Sin: '<Root>/Sine Wave' */
  RaspberryMagmanControl_B.SineWave = sin(RaspberryMagmanControl_P.SineWave_Freq
    * RaspberryMagmanControl_M->Timing.t[0] +
    RaspberryMagmanControl_P.SineWave_Phase) *
    RaspberryMagmanControl_P.SineWave_Amp +
    RaspberryMagmanControl_P.SineWave_Bias;

  /* Sin: '<Root>/Sine Wave1' */
  RaspberryMagmanControl_B.SineWave1 = sin
    (RaspberryMagmanControl_P.SineWave1_Freq *
     RaspberryMagmanControl_M->Timing.t[0] +
     RaspberryMagmanControl_P.SineWave1_Phase) *
    RaspberryMagmanControl_P.SineWave1_Amp +
    RaspberryMagmanControl_P.SineWave1_Bias;

  /* ManualSwitch: '<Root>/Manual Switch1' incorporates:
   *  Constant: '<Root>/Referece position'
   */
  if (RaspberryMagmanControl_P.ManualSwitch1_CurrentSetting == 1) {
    RaspberryMagmanControl_B.ManualSwitch1[0] =
      RaspberryMagmanControl_B.SineWave;
    RaspberryMagmanControl_B.ManualSwitch1[1] =
      RaspberryMagmanControl_B.SineWave1;
  } else {
    RaspberryMagmanControl_B.ManualSwitch1[0] =
      RaspberryMagmanControl_P.Refereceposition_Value[0];
    RaspberryMagmanControl_B.ManualSwitch1[1] =
      RaspberryMagmanControl_P.Refereceposition_Value[1];
  }

  /* End of ManualSwitch: '<Root>/Manual Switch1' */

  /* DiscreteIntegrator: '<S6>/Integrator' */
  RaspberryMagmanControl_B.Integrator[0] =
    RaspberryMagmanControl_DW.Integrator_DSTATE[0];

  /* DiscreteIntegrator: '<S6>/Filter' */
  RaspberryMagmanControl_B.Filter[0] = RaspberryMagmanControl_DW.Filter_DSTATE[0];

  /* Gain: '<S6>/Filter Coefficient' incorporates:
   *  Gain: '<S6>/Derivative Gain'
   *  Gain: '<S6>/Setpoint Weighting (Derivative)'
   *  Sum: '<S6>/Sum3'
   *  Sum: '<S6>/SumD'
   */
  RaspberryMagmanControl_B.FilterCoefficient[0] =
    ((RaspberryMagmanControl_P.PIDController2DOF_c *
      RaspberryMagmanControl_B.ManualSwitch1[0] -
      RaspberryMagmanControl_B.ManualSwitch[0]) *
     RaspberryMagmanControl_P.PIDController2DOF_D -
     RaspberryMagmanControl_B.Filter[0]) *
    RaspberryMagmanControl_P.PIDController2DOF_N;

  /* Sum: '<S6>/Sum' incorporates:
   *  Gain: '<S6>/Proportional Gain'
   *  Gain: '<S6>/Setpoint Weighting (Proportional)'
   *  Sum: '<S6>/Sum1'
   */
  Fv_idx_0 = ((RaspberryMagmanControl_P.PIDController2DOF_b *
               RaspberryMagmanControl_B.ManualSwitch1[0] -
               RaspberryMagmanControl_B.ManualSwitch[0]) *
              RaspberryMagmanControl_P.PIDController2DOF_P +
              RaspberryMagmanControl_B.Integrator[0]) +
    RaspberryMagmanControl_B.FilterCoefficient[0];

  /* Saturate: '<S6>/Saturate' */
  if (Fv_idx_0 > RaspberryMagmanControl_P.PIDController2DOF_UpperSaturati) {
    RaspberryMagmanControl_B.Saturate[0] =
      RaspberryMagmanControl_P.PIDController2DOF_UpperSaturati;
  } else if (Fv_idx_0 < RaspberryMagmanControl_P.PIDController2DOF_LowerSaturati)
  {
    RaspberryMagmanControl_B.Saturate[0] =
      RaspberryMagmanControl_P.PIDController2DOF_LowerSaturati;
  } else {
    RaspberryMagmanControl_B.Saturate[0] = Fv_idx_0;
  }

  /* Sum: '<S6>/Sum' */
  rtb_Sum_idx_0 = Fv_idx_0;

  /* DiscreteIntegrator: '<S6>/Integrator' */
  RaspberryMagmanControl_B.Integrator[1] =
    RaspberryMagmanControl_DW.Integrator_DSTATE[1];

  /* DiscreteIntegrator: '<S6>/Filter' */
  RaspberryMagmanControl_B.Filter[1] = RaspberryMagmanControl_DW.Filter_DSTATE[1];

  /* Gain: '<S6>/Filter Coefficient' incorporates:
   *  Gain: '<S6>/Derivative Gain'
   *  Gain: '<S6>/Setpoint Weighting (Derivative)'
   *  Sum: '<S6>/Sum3'
   *  Sum: '<S6>/SumD'
   */
  RaspberryMagmanControl_B.FilterCoefficient[1] =
    ((RaspberryMagmanControl_P.PIDController2DOF_c *
      RaspberryMagmanControl_B.ManualSwitch1[1] -
      RaspberryMagmanControl_B.ManualSwitch[1]) *
     RaspberryMagmanControl_P.PIDController2DOF_D -
     RaspberryMagmanControl_B.Filter[1]) *
    RaspberryMagmanControl_P.PIDController2DOF_N;

  /* Sum: '<S6>/Sum' incorporates:
   *  Gain: '<S6>/Proportional Gain'
   *  Gain: '<S6>/Setpoint Weighting (Proportional)'
   *  Sum: '<S6>/Sum1'
   */
  Fv_idx_0 = ((RaspberryMagmanControl_P.PIDController2DOF_b *
               RaspberryMagmanControl_B.ManualSwitch1[1] -
               RaspberryMagmanControl_B.ManualSwitch[1]) *
              RaspberryMagmanControl_P.PIDController2DOF_P +
              RaspberryMagmanControl_B.Integrator[1]) +
    RaspberryMagmanControl_B.FilterCoefficient[1];

  /* Saturate: '<S6>/Saturate' */
  if (Fv_idx_0 > RaspberryMagmanControl_P.PIDController2DOF_UpperSaturati) {
    RaspberryMagmanControl_B.Saturate[1] =
      RaspberryMagmanControl_P.PIDController2DOF_UpperSaturati;
  } else if (Fv_idx_0 < RaspberryMagmanControl_P.PIDController2DOF_LowerSaturati)
  {
    RaspberryMagmanControl_B.Saturate[1] =
      RaspberryMagmanControl_P.PIDController2DOF_LowerSaturati;
  } else {
    RaspberryMagmanControl_B.Saturate[1] = Fv_idx_0;
  }

  /* S-Function (cvxfasd): '<S5>/MagMan linearization1' */
  cvxfasd_Outputs_wrapper(&RaspberryMagmanControl_B.Ao[0],
    &RaspberryMagmanControl_B.Saturate[0], &RaspberryMagmanControl_B.Saturate[1],
    &RaspberryMagmanControl_B.MagManlinearization1_o1[0],
    &RaspberryMagmanControl_B.MagManlinearization1_o2 );

  /* Math: '<S5>/Math Function' */
  for (i = 0; i < 4; i++) {
    RaspberryMagmanControl_B.MathFunction[i << 2] =
      RaspberryMagmanControl_B.MagManlinearization1_o1[i];
    RaspberryMagmanControl_B.MathFunction[1 + (i << 2)] =
      RaspberryMagmanControl_B.MagManlinearization1_o1[i + 4];
    RaspberryMagmanControl_B.MathFunction[2 + (i << 2)] =
      RaspberryMagmanControl_B.MagManlinearization1_o1[i + 8];
    RaspberryMagmanControl_B.MathFunction[3 + (i << 2)] =
      RaspberryMagmanControl_B.MagManlinearization1_o1[i + 12];
  }

  /* End of Math: '<S5>/Math Function' */

  /* MATLAB Function: '<Root>/Currents to PWM' */
  /* MATLAB Function 'Currents to PWM': '<S3>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S3>:1:3' Currents = max(0, min(1,Currents) ); */
  /*  limits */
  /* '<S3>:1:4' i = 0.18515*Currents + 0.069587*Currents.^3 + 0.19285*Currents.^(1/3); */
  /*  ratio to current conversion */
  /* '<S3>:1:5' PWM = i/0.455/2; */
  /* '<S3>:1:6' PWM(PWM>0.05) = PWM(PWM>0.05) + 0.5; */
  /* '<S3>:1:7' PWM(PWM<0.5) = 0; */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    if ((1.0 <= RaspberryMagmanControl_B.MathFunction[xoffset]) || rtIsNaN
        (RaspberryMagmanControl_B.MathFunction[xoffset])) {
      RaspberryMagmanControl_B.lim = 1.0;
    } else {
      RaspberryMagmanControl_B.lim =
        RaspberryMagmanControl_B.MathFunction[xoffset];
    }

    if ((0.0 >= RaspberryMagmanControl_B.lim) || rtIsNaN
        (RaspberryMagmanControl_B.lim)) {
      RaspberryMagmanControl_B.PWM[xoffset] = 0.0;
    } else {
      RaspberryMagmanControl_B.PWM[xoffset] = RaspberryMagmanControl_B.lim;
    }

    RaspberryMagmanControl_B.PWM[xoffset] = ((0.18515 *
      RaspberryMagmanControl_B.PWM[xoffset] + 0.069587 * rt_powd_snf
      (RaspberryMagmanControl_B.PWM[xoffset], 3.0)) + 0.19285 * rt_powd_snf
      (RaspberryMagmanControl_B.PWM[xoffset], 0.33333333333333331)) / 0.455 /
      2.0;
    if (RaspberryMagmanControl_B.PWM[xoffset] > 0.05) {
      RaspberryMagmanControl_B.PWM[xoffset] += 0.5;
    }

    if (RaspberryMagmanControl_B.PWM[xoffset] < 0.5) {
      RaspberryMagmanControl_B.PWM[xoffset] = 0.0;
    }
  }

  /* End of MATLAB Function: '<Root>/Currents to PWM' */

  /* MATLAB Function: '<S2>/Nonlinearity of  magnetic force' */
  /* MATLAB Function 'Currents to Force/Nonlinearity of  magnetic force': '<S12>:1' */
  /*  function F = fcn(u,xmes) */
  /*  Computes vector of magnetic force exerted on the ball in x- and */
  /*  y-direction. Input arguments are excitation factors of coils and measured */
  /*  position of the ball. Contributions of the coils are superposed to get */
  /*  the overall force. */
  /*  Note, that this function only models nonlinearity of the magnetic force, */
  /*  it is not any kind of feedback control. */
  /* '<S12>:1:10' umin = 1; */
  /*  index of the 1st actuator in one dim */
  /* '<S12>:1:11' umax = 4; */
  /*  index of tohe last actuator in one dim */
  /* '<S12>:1:13' F = [0;0]; */
  rtb_F_idx_0 = 0.0;
  rtb_F_idx_1 = 0.0;

  /* '<S12>:1:15' u = abs(u); */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    RaspberryMagmanControl_B.minval[xoffset] = fabs
      (RaspberryMagmanControl_B.MathFunction[xoffset]);
  }

  /* '<S12>:1:16' for cnt = umin:umax */
  for (xoffset = 0; xoffset < 4; xoffset++) {
    /* '<S12>:1:17' for cnt2 = umin:umax */
    for (i = 0; i < 4; i++) {
      /* '<S12>:1:18' F = F + [dxfce(cnt,cnt2,xmes(1),xmes(2));... */
      /* '<S12>:1:19'             dyfce(cnt,cnt2,xmes(1),xmes(2))] * u(cnt2-umin+1,cnt-umin+1); */
      /*  Compute x-component of force from coil [m,n] exerted on the ball at */
      /*  position [x,y] */
      /* '<S12>:1:27' out = -48.282*(x-m)./( (x-m).^2 + (y-n).^2 + 0.3303).^3; */
      RaspberryMagmanControl_B.lim = RaspberryMagmanControl_B.ManualSwitch[0] -
        (1.0 + (real_T)xoffset);
      Fv_idx_1 = RaspberryMagmanControl_B.ManualSwitch[1] - (1.0 + (real_T)i);

      /*  Compute y-component of force from coil [m,n] exerted on the ball at */
      /*  position [x,y] */
      /* '<S12>:1:33' out = -48.282*(y-n)./( (x-m).^2 + (y-n).^2 + 0.3303).^3; */
      RaspberryMagmanControl_B.vy = RaspberryMagmanControl_B.ManualSwitch[0] -
        (1.0 + (real_T)xoffset);
      RaspberryMagmanControl_B.d_a = RaspberryMagmanControl_B.ManualSwitch[1] -
        (1.0 + (real_T)i);
      rtb_F_idx_0 += (RaspberryMagmanControl_B.ManualSwitch[0] - (1.0 + (real_T)
        xoffset)) * -48.282 / rt_powd_snf((RaspberryMagmanControl_B.lim *
        RaspberryMagmanControl_B.lim + Fv_idx_1 * Fv_idx_1) + 0.3303, 3.0) *
        RaspberryMagmanControl_B.minval[(xoffset << 2) + i];
      rtb_F_idx_1 += (RaspberryMagmanControl_B.ManualSwitch[1] - (1.0 + (real_T)
        i)) * -48.282 / rt_powd_snf((RaspberryMagmanControl_B.vy *
        RaspberryMagmanControl_B.vy + RaspberryMagmanControl_B.d_a *
        RaspberryMagmanControl_B.d_a) + 0.3303, 3.0) *
        RaspberryMagmanControl_B.minval[(xoffset << 2) + i];
    }
  }

  /* End of MATLAB Function: '<S2>/Nonlinearity of  magnetic force' */

  /* Gain: '<S2>/Gain' */
  RaspberryMagmanControl_B.Gain[0] = RaspberryMagmanControl_P.Gain_Gain *
    rtb_F_idx_0;
  RaspberryMagmanControl_B.Gain[1] = RaspberryMagmanControl_P.Gain_Gain *
    rtb_F_idx_1;

  /* MATLAB Function: '<Root>/proud' */
  /* MATLAB Function 'proud': '<S9>:1' */
  /* '<S9>:1:2' i = (max(0, pw-0.5).*(0.455*2))'; */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    if ((0.0 >= RaspberryMagmanControl_B.PWM[xoffset] - 0.5) || rtIsNaN
        (RaspberryMagmanControl_B.PWM[xoffset] - 0.5)) {
      RaspberryMagmanControl_B.minval[xoffset] = 0.0;
    } else {
      RaspberryMagmanControl_B.minval[xoffset] =
        RaspberryMagmanControl_B.PWM[xoffset] - 0.5;
    }
  }

  for (i = 0; i < 4; i++) {
    RaspberryMagmanControl_B.i[i << 2] = RaspberryMagmanControl_B.minval[i] *
      0.91;
    RaspberryMagmanControl_B.i[1 + (i << 2)] = RaspberryMagmanControl_B.minval[i
      + 4] * 0.91;
    RaspberryMagmanControl_B.i[2 + (i << 2)] = RaspberryMagmanControl_B.minval[i
      + 8] * 0.91;
    RaspberryMagmanControl_B.i[3 + (i << 2)] = RaspberryMagmanControl_B.minval[i
      + 12] * 0.91;
  }

  /* '<S9>:1:3' lim = 0; */
  RaspberryMagmanControl_B.lim = 0.0;

  /* '<S9>:1:4' if sum(sum(abs(i))) < 4 */
  memcpy(&RaspberryMagmanControl_B.minval[0], &RaspberryMagmanControl_B.i[0],
         sizeof(real_T) << 4U);
  for (i = 0; i < 4; i++) {
    xoffset = i << 2;
    RaspberryMagmanControl_B.y[i] = ((RaspberryMagmanControl_B.minval[xoffset +
      1] + RaspberryMagmanControl_B.minval[xoffset]) +
      RaspberryMagmanControl_B.minval[xoffset + 2]) +
      RaspberryMagmanControl_B.minval[xoffset + 3];
  }

  if (((RaspberryMagmanControl_B.y[0] + RaspberryMagmanControl_B.y[1]) +
       RaspberryMagmanControl_B.y[2]) + RaspberryMagmanControl_B.y[3] < 4.0) {
    /* '<S9>:1:5' lim = 1; */
    RaspberryMagmanControl_B.lim = 1.0;
  }

  /* End of MATLAB Function: '<Root>/proud' */

  /* Switch: '<Root>/Switch1' incorporates:
   *  Constant: '<Root>/Constant2'
   */
  if (RaspberryMagmanControl_B.lim != 0.0) {
    memcpy(&RaspberryMagmanControl_B.Switch1[0], &RaspberryMagmanControl_B.PWM[0],
           sizeof(real_T) << 4U);
  } else {
    memcpy(&RaspberryMagmanControl_B.Switch1[0],
           &RaspberryMagmanControl_P.Constant2_Value[0], sizeof(real_T) << 4U);
  }

  /* End of Switch: '<Root>/Switch1' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&RaspberryMagmanControl_B.Switch1[0],
    &RaspberryMagmanControl_DW.MagManCoils_DSTATE);

  /* Sum: '<S6>/SumI1' incorporates:
   *  Gain: '<S6>/Integral Gain'
   *  Gain: '<S6>/Kb'
   *  Sum: '<S6>/Sum2'
   *  Sum: '<S6>/SumI2'
   */
  RaspberryMagmanControl_B.SumI1[0] = (RaspberryMagmanControl_B.ManualSwitch1[0]
    - RaspberryMagmanControl_B.ManualSwitch[0]) *
    RaspberryMagmanControl_P.PIDController2DOF_I +
    (RaspberryMagmanControl_B.Saturate[0] - rtb_Sum_idx_0) *
    RaspberryMagmanControl_P.PIDController2DOF_Kb;
  RaspberryMagmanControl_B.SumI1[1] = (RaspberryMagmanControl_B.ManualSwitch1[1]
    - RaspberryMagmanControl_B.ManualSwitch[1]) *
    RaspberryMagmanControl_P.PIDController2DOF_I +
    (RaspberryMagmanControl_B.Saturate[1] - Fv_idx_0) *
    RaspberryMagmanControl_P.PIDController2DOF_Kb;

  /* S-Function "sfcn_getFoilCheck_wrapper" Block: <S4>/MagMan Foil with error */
  sfcn_getFoilCheck_Update_wrapper
    ( &RaspberryMagmanControl_B.MagManFoilwitherror_o1,
     &RaspberryMagmanControl_B.MagManFoilwitherror_o2,
     &RaspberryMagmanControl_B.MagManFoilwitherror_o3,
     &RaspberryMagmanControl_B.MagManFoilwitherror_o4,
     &RaspberryMagmanControl_DW.MagManFoilwitherror_DSTATE);

  /* S-Function "sfcn_posread_shm_wrapper" Block: <S10>/Shared memory camera position */
  sfcn_posread_shm_Update_wrapper
    ( &RaspberryMagmanControl_B.Sharedmemorycameraposition_o1,
     &RaspberryMagmanControl_B.Sharedmemorycameraposition_o2,
     &RaspberryMagmanControl_DW.Sharedmemorycameraposition_DSTA);

  /* Update for DiscreteIntegrator: '<S6>/Integrator' */
  RaspberryMagmanControl_DW.Integrator_DSTATE[0] +=
    RaspberryMagmanControl_P.Integrator_gainval *
    RaspberryMagmanControl_B.SumI1[0];

  /* Update for DiscreteIntegrator: '<S6>/Filter' */
  RaspberryMagmanControl_DW.Filter_DSTATE[0] +=
    RaspberryMagmanControl_P.Filter_gainval *
    RaspberryMagmanControl_B.FilterCoefficient[0];

  /* Update for DiscreteIntegrator: '<S6>/Integrator' */
  RaspberryMagmanControl_DW.Integrator_DSTATE[1] +=
    RaspberryMagmanControl_P.Integrator_gainval *
    RaspberryMagmanControl_B.SumI1[1];

  /* Update for DiscreteIntegrator: '<S6>/Filter' */
  RaspberryMagmanControl_DW.Filter_DSTATE[1] +=
    RaspberryMagmanControl_P.Filter_gainval *
    RaspberryMagmanControl_B.FilterCoefficient[1];

  /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
  sfcn_setPlatform_Update_wrapper(&RaspberryMagmanControl_B.Switch1[0],
    &RaspberryMagmanControl_DW.MagManCoils_DSTATE);

  /* External mode */
  rtExtModeUploadCheckTrigger(2);

  {                                    /* Sample time: [0.0s, 0.0s] */
    rtExtModeUpload(0, RaspberryMagmanControl_M->Timing.t[0]);
  }

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(1, (((RaspberryMagmanControl_M->Timing.clockTick1+
                          RaspberryMagmanControl_M->Timing.clockTickH1*
                          4294967296.0)) * 0.02));
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.0s, 0.0s] */
    if ((rtmGetTFinal(RaspberryMagmanControl_M)!=-1) &&
        !((rtmGetTFinal(RaspberryMagmanControl_M)-
           RaspberryMagmanControl_M->Timing.t[0]) >
          RaspberryMagmanControl_M->Timing.t[0] * (DBL_EPSILON))) {
      rtmSetErrorStatus(RaspberryMagmanControl_M, "Simulation finished");
    }

    if (rtmGetStopRequested(RaspberryMagmanControl_M)) {
      rtmSetErrorStatus(RaspberryMagmanControl_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++RaspberryMagmanControl_M->Timing.clockTick0)) {
    ++RaspberryMagmanControl_M->Timing.clockTickH0;
  }

  RaspberryMagmanControl_M->Timing.t[0] =
    RaspberryMagmanControl_M->Timing.clockTick0 *
    RaspberryMagmanControl_M->Timing.stepSize0 +
    RaspberryMagmanControl_M->Timing.clockTickH0 *
    RaspberryMagmanControl_M->Timing.stepSize0 * 4294967296.0;

  {
    /* Update absolute timer for sample time: [0.02s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 0.02, which is the step size
     * of the task. Size of "clockTick1" ensures timer will not overflow during the
     * application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    RaspberryMagmanControl_M->Timing.clockTick1++;
    if (!RaspberryMagmanControl_M->Timing.clockTick1) {
      RaspberryMagmanControl_M->Timing.clockTickH1++;
    }
  }
}

/* Model initialize function */
void RaspberryMagmanControl_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)RaspberryMagmanControl_M, 0,
                sizeof(RT_MODEL_RaspberryMagmanControl_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&RaspberryMagmanControl_M->solverInfo,
                          &RaspberryMagmanControl_M->Timing.simTimeStep);
    rtsiSetTPtr(&RaspberryMagmanControl_M->solverInfo, &rtmGetTPtr
                (RaspberryMagmanControl_M));
    rtsiSetStepSizePtr(&RaspberryMagmanControl_M->solverInfo,
                       &RaspberryMagmanControl_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&RaspberryMagmanControl_M->solverInfo,
                          (&rtmGetErrorStatus(RaspberryMagmanControl_M)));
    rtsiSetRTModelPtr(&RaspberryMagmanControl_M->solverInfo,
                      RaspberryMagmanControl_M);
  }

  rtsiSetSimTimeStep(&RaspberryMagmanControl_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&RaspberryMagmanControl_M->solverInfo,"FixedStepDiscrete");
  rtmSetTPtr(RaspberryMagmanControl_M, &RaspberryMagmanControl_M->Timing.tArray
             [0]);
  rtmSetTFinal(RaspberryMagmanControl_M, -1);
  RaspberryMagmanControl_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  RaspberryMagmanControl_M->Sizes.checksums[0] = (893511741U);
  RaspberryMagmanControl_M->Sizes.checksums[1] = (1882834996U);
  RaspberryMagmanControl_M->Sizes.checksums[2] = (4203255061U);
  RaspberryMagmanControl_M->Sizes.checksums[3] = (1017532924U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[9];
    RaspberryMagmanControl_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    systemRan[5] = &rtAlwaysEnabled;
    systemRan[6] = &rtAlwaysEnabled;
    systemRan[7] = &rtAlwaysEnabled;
    systemRan[8] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(RaspberryMagmanControl_M->extModeInfo,
      &RaspberryMagmanControl_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(RaspberryMagmanControl_M->extModeInfo,
                        RaspberryMagmanControl_M->Sizes.checksums);
    rteiSetTPtr(RaspberryMagmanControl_M->extModeInfo, rtmGetTPtr
                (RaspberryMagmanControl_M));
  }

  /* block I/O */
  (void) memset(((void *) &RaspberryMagmanControl_B), 0,
                sizeof(B_RaspberryMagmanControl_T));

  /* states (dwork) */
  (void) memset((void *)&RaspberryMagmanControl_DW, 0,
                sizeof(DW_RaspberryMagmanControl_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    RaspberryMagmanControl_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* S-Function Block: <S4>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryMagmanControl_DW.MagManFoilwitherror_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <S10>/Shared memory camera position */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryMagmanControl_DW.Sharedmemorycameraposition_DSTA = initVector[0];
      }
    }
  }

  /* InitializeConditions for DiscreteIntegrator: '<S6>/Integrator' */
  RaspberryMagmanControl_DW.Integrator_DSTATE[0] =
    RaspberryMagmanControl_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S6>/Filter' */
  RaspberryMagmanControl_DW.Filter_DSTATE[0] =
    RaspberryMagmanControl_P.Filter_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S6>/Integrator' */
  RaspberryMagmanControl_DW.Integrator_DSTATE[1] =
    RaspberryMagmanControl_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S6>/Filter' */
  RaspberryMagmanControl_DW.Filter_DSTATE[1] =
    RaspberryMagmanControl_P.Filter_IC;

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryMagmanControl_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }
}

/* Model terminate function */
void RaspberryMagmanControl_terminate(void)
{
  /* (no terminate code required) */
}
