/*
 * RaspberryMagmanModelTest.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberryMagmanModelTest".
 *
 * Model version              : 1.19
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Wed Dec 21 17:46:56 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "RaspberryMagmanModelTest.h"
#include "RaspberryMagmanModelTest_private.h"
#include "RaspberryMagmanModelTest_dt.h"

/* Block signals (auto storage) */
B_RaspberryMagmanModelTest_T RaspberryMagmanModelTest_B;

/* Block states (auto storage) */
DW_RaspberryMagmanModelTest_T RaspberryMagmanModelTest_DW;

/* Real-time model */
RT_MODEL_RaspberryMagmanModel_T RaspberryMagmanModelTest_M_;
RT_MODEL_RaspberryMagmanModel_T *const RaspberryMagmanModelTest_M =
  &RaspberryMagmanModelTest_M_;

/*
 * Output and update for atomic system:
 *    '<S1>/Position transformation1'
 *    '<S4>/Position transformation'
 */
void Raspber_Positiontransformation1(real_T rtu_x, real_T rtu_y, const real_T
  rtu_km4[9], B_Positiontransformation1_Ras_T *localB)
{
  /* MATLAB Function 'Camera position/Position transformation1': '<S6>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S6>:1:4' xa = [x,y]; */
  /* '<S6>:1:5' H = km4(:); */
  /* '<S6>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S6>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S6>:1:9' X=out(1); */
  localB->X = ((rtu_x * rtu_km4[0] + rtu_y * rtu_km4[1]) + rtu_km4[2]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);

  /* '<S6>:1:10' Y=out(2); */
  localB->Y = ((rtu_x * rtu_km4[3] + rtu_y * rtu_km4[4]) + rtu_km4[5]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);
}

real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void RaspberryMagmanModelTest_step(void)
{
  int32_T k;
  int32_T cnt2;
  real_T c_a;
  real_T d_a;
  real_T rtb_Step;
  real_T rtb_F_idx_0;
  real_T rtb_F_idx_1;

  /* Step: '<Root>/Step' */
  if (RaspberryMagmanModelTest_M->Timing.t[0] <
      RaspberryMagmanModelTest_P.Step_Time) {
    rtb_Step = RaspberryMagmanModelTest_P.Step_Y0;
  } else {
    rtb_Step = RaspberryMagmanModelTest_P.Step_YFinal;
  }

  /* End of Step: '<Root>/Step' */

  /* Switch: '<Root>/Switch' incorporates:
   *  Constant: '<Root>/Coil excitation factors'
   *  Constant: '<Root>/Coil excitation factors1'
   */
  if (rtb_Step > RaspberryMagmanModelTest_P.Switch_Threshold) {
    memcpy(&RaspberryMagmanModelTest_B.Switch[0],
           &RaspberryMagmanModelTest_P.Coilexcitationfactors_Value[0], sizeof
           (real_T) << 4U);
  } else {
    memcpy(&RaspberryMagmanModelTest_B.Switch[0],
           &RaspberryMagmanModelTest_P.Coilexcitationfactors1_Value[0], sizeof
           (real_T) << 4U);
  }

  /* End of Switch: '<Root>/Switch' */

  /* S-Function (sfcn_getFoilCheck): '<S4>/MagMan Foil with error' */
  sfcn_getFoilCheck_Outputs_wrapper
    ( &RaspberryMagmanModelTest_B.MagManFoilwitherror_o1,
     &RaspberryMagmanModelTest_B.MagManFoilwitherror_o2,
     &RaspberryMagmanModelTest_B.MagManFoilwitherror_o3,
     &RaspberryMagmanModelTest_B.MagManFoilwitherror_o4,
     &RaspberryMagmanModelTest_DW.MagManFoilwitherror_DSTATE);

  /* MATLAB Function: '<S4>/Position transformation' incorporates:
   *  Constant: '<S4>/Sentinel Calibration matrix'
   */
  Raspber_Positiontransformation1
    (RaspberryMagmanModelTest_B.MagManFoilwitherror_o1,
     RaspberryMagmanModelTest_B.MagManFoilwitherror_o2,
     RaspberryMagmanModelTest_P.km4pi,
     &RaspberryMagmanModelTest_B.sf_Positiontransformation);

  /* S-Function (sfcn_posread_shm): '<S5>/Shared memory camera position' */
  sfcn_posread_shm_Outputs_wrapper
    ( &RaspberryMagmanModelTest_B.Sharedmemorycameraposition_o1,
     &RaspberryMagmanModelTest_B.Sharedmemorycameraposition_o2,
     &RaspberryMagmanModelTest_DW.Sharedmemorycameraposition_DSTA);

  /* DataTypeConversion: '<S5>/Data Type Conversion1' */
  RaspberryMagmanModelTest_B.DataTypeConversion1 =
    RaspberryMagmanModelTest_B.Sharedmemorycameraposition_o1;

  /* DataTypeConversion: '<S5>/Data Type Conversion2' */
  RaspberryMagmanModelTest_B.DataTypeConversion2 =
    RaspberryMagmanModelTest_B.Sharedmemorycameraposition_o2;

  /* MATLAB Function: '<S1>/Position transformation1' incorporates:
   *  Constant: '<S1>/Sentinel Calibration matrix1'
   */
  Raspber_Positiontransformation1(RaspberryMagmanModelTest_B.DataTypeConversion1,
    RaspberryMagmanModelTest_B.DataTypeConversion2,
    RaspberryMagmanModelTest_P.km4piCam,
    &RaspberryMagmanModelTest_B.sf_Positiontransformation1);

  /* DiscreteStateSpace: '<Root>/Discrete State-Space' */
  {
    RaspberryMagmanModelTest_B.DiscreteStateSpace[0] =
      (RaspberryMagmanModelTest_P.DiscreteStateSpace_C[0])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[1];
    RaspberryMagmanModelTest_B.DiscreteStateSpace[1] =
      (RaspberryMagmanModelTest_P.DiscreteStateSpace_C[1])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[3];
  }

  /* MATLAB Function: '<Root>/Currents to PWM' */
  /* MATLAB Function 'Currents to PWM': '<S3>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S3>:1:3' Currents = max(0, min(1,Currents) ); */
  /*  limits */
  /* '<S3>:1:4' i = 0.18515*Currents + 0.069587*Currents.^3 + 0.19285*Currents.^(1/3); */
  /*  ratio to current conversion */
  /* '<S3>:1:5' PWM = i/0.455/2; */
  /* '<S3>:1:6' PWM(PWM>0.05) = PWM(PWM>0.05) + 0.5; */
  /* '<S3>:1:7' PWM(PWM<0.5) = 0; */
  for (k = 0; k < 16; k++) {
    if ((1.0 <= RaspberryMagmanModelTest_B.Switch[k]) || rtIsNaN
        (RaspberryMagmanModelTest_B.Switch[k])) {
      rtb_Step = 1.0;
    } else {
      rtb_Step = RaspberryMagmanModelTest_B.Switch[k];
    }

    if ((0.0 >= rtb_Step) || rtIsNaN(rtb_Step)) {
      RaspberryMagmanModelTest_B.PWM[k] = 0.0;
    } else {
      RaspberryMagmanModelTest_B.PWM[k] = rtb_Step;
    }

    RaspberryMagmanModelTest_B.PWM[k] = ((0.18515 *
      RaspberryMagmanModelTest_B.PWM[k] + 0.069587 * rt_powd_snf
      (RaspberryMagmanModelTest_B.PWM[k], 3.0)) + 0.19285 * rt_powd_snf
      (RaspberryMagmanModelTest_B.PWM[k], 0.33333333333333331)) / 0.455 / 2.0;
    if (RaspberryMagmanModelTest_B.PWM[k] > 0.05) {
      RaspberryMagmanModelTest_B.PWM[k] += 0.5;
    }

    if (RaspberryMagmanModelTest_B.PWM[k] < 0.5) {
      RaspberryMagmanModelTest_B.PWM[k] = 0.0;
    }
  }

  /* End of MATLAB Function: '<Root>/Currents to PWM' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&RaspberryMagmanModelTest_B.PWM[0],
    &RaspberryMagmanModelTest_DW.MagManCoils_DSTATE);

  /* MATLAB Function: '<S2>/Nonlinearity of  magnetic force' */
  /* MATLAB Function 'Currents to Force/Nonlinearity of  magnetic force': '<S7>:1' */
  /*  function F = fcn(u,xmes) */
  /*  Computes vector of magnetic force exerted on the ball in x- and */
  /*  y-direction. Input arguments are excitation factors of coils and measured */
  /*  position of the ball. Contributions of the coils are superposed to get */
  /*  the overall force. */
  /*  Note, that this function only models nonlinearity of the magnetic force, */
  /*  it is not any kind of feedback control. */
  /* '<S7>:1:10' umin = 1; */
  /*  index of the 1st actuator in one dim */
  /* '<S7>:1:11' umax = 4; */
  /*  index of tohe last actuator in one dim */
  /* '<S7>:1:13' F = [0;0]; */
  rtb_F_idx_0 = 0.0;
  rtb_F_idx_1 = 0.0;

  /* '<S7>:1:15' u = abs(u); */
  for (k = 0; k < 16; k++) {
    RaspberryMagmanModelTest_B.minval[k] = fabs
      (RaspberryMagmanModelTest_B.Switch[k]);
  }

  /* '<S7>:1:16' for cnt = umin:umax */
  for (k = 0; k < 4; k++) {
    /* '<S7>:1:17' for cnt2 = umin:umax */
    for (cnt2 = 0; cnt2 < 4; cnt2++) {
      /* '<S7>:1:18' F = F + [dxfce(cnt,cnt2,xmes(1),xmes(2));... */
      /* '<S7>:1:19'             dyfce(cnt,cnt2,xmes(1),xmes(2))] * u(cnt2-umin+1,cnt-umin+1); */
      /*  Compute x-component of force from coil [m,n] exerted on the ball at */
      /*  position [x,y] */
      /* '<S7>:1:27' out = -48.282*(x-m)./( (x-m).^2 + (y-n).^2 + 0.3303).^3; */
      rtb_Step = RaspberryMagmanModelTest_B.DiscreteStateSpace[0] - (1.0 +
        (real_T)k);
      RaspberryMagmanModelTest_B.b_a =
        RaspberryMagmanModelTest_B.DiscreteStateSpace[1] - (1.0 + (real_T)cnt2);

      /*  Compute y-component of force from coil [m,n] exerted on the ball at */
      /*  position [x,y] */
      /* '<S7>:1:33' out = -48.282*(y-n)./( (x-m).^2 + (y-n).^2 + 0.3303).^3; */
      c_a = RaspberryMagmanModelTest_B.DiscreteStateSpace[0] - (1.0 + (real_T)k);
      d_a = RaspberryMagmanModelTest_B.DiscreteStateSpace[1] - (1.0 + (real_T)
        cnt2);
      rtb_F_idx_0 += (RaspberryMagmanModelTest_B.DiscreteStateSpace[0] - (1.0 +
        (real_T)k)) * -48.282 / rt_powd_snf((rtb_Step * rtb_Step +
        RaspberryMagmanModelTest_B.b_a * RaspberryMagmanModelTest_B.b_a) +
        0.3303, 3.0) * RaspberryMagmanModelTest_B.minval[(k << 2) + cnt2];
      rtb_F_idx_1 += (RaspberryMagmanModelTest_B.DiscreteStateSpace[1] - (1.0 +
        (real_T)cnt2)) * -48.282 / rt_powd_snf((c_a * c_a + d_a * d_a) + 0.3303,
        3.0) * RaspberryMagmanModelTest_B.minval[(k << 2) + cnt2];
    }
  }

  /* End of MATLAB Function: '<S2>/Nonlinearity of  magnetic force' */

  /* Gain: '<S2>/Gain' */
  RaspberryMagmanModelTest_B.Gain[0] = RaspberryMagmanModelTest_P.Gain_Gain *
    rtb_F_idx_0;
  RaspberryMagmanModelTest_B.Gain[1] = RaspberryMagmanModelTest_P.Gain_Gain *
    rtb_F_idx_1;

  /* S-Function "sfcn_getFoilCheck_wrapper" Block: <S4>/MagMan Foil with error */
  sfcn_getFoilCheck_Update_wrapper
    ( &RaspberryMagmanModelTest_B.MagManFoilwitherror_o1,
     &RaspberryMagmanModelTest_B.MagManFoilwitherror_o2,
     &RaspberryMagmanModelTest_B.MagManFoilwitherror_o3,
     &RaspberryMagmanModelTest_B.MagManFoilwitherror_o4,
     &RaspberryMagmanModelTest_DW.MagManFoilwitherror_DSTATE);

  /* S-Function "sfcn_posread_shm_wrapper" Block: <S5>/Shared memory camera position */
  sfcn_posread_shm_Update_wrapper
    ( &RaspberryMagmanModelTest_B.Sharedmemorycameraposition_o1,
     &RaspberryMagmanModelTest_B.Sharedmemorycameraposition_o2,
     &RaspberryMagmanModelTest_DW.Sharedmemorycameraposition_DSTA);

  /* Update for DiscreteStateSpace: '<Root>/Discrete State-Space' */
  {
    real_T xnew[4];
    xnew[0] = (RaspberryMagmanModelTest_P.DiscreteStateSpace_A[0])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[0];
    xnew[0] += (RaspberryMagmanModelTest_P.DiscreteStateSpace_B[0])*
      RaspberryMagmanModelTest_B.Gain[0];
    xnew[1] = (RaspberryMagmanModelTest_P.DiscreteStateSpace_A[1])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[0]
      + (RaspberryMagmanModelTest_P.DiscreteStateSpace_A[2])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[1];
    xnew[1] += (RaspberryMagmanModelTest_P.DiscreteStateSpace_B[1])*
      RaspberryMagmanModelTest_B.Gain[0];
    xnew[2] = (RaspberryMagmanModelTest_P.DiscreteStateSpace_A[3])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[2];
    xnew[2] += (RaspberryMagmanModelTest_P.DiscreteStateSpace_B[2])*
      RaspberryMagmanModelTest_B.Gain[1];
    xnew[3] = (RaspberryMagmanModelTest_P.DiscreteStateSpace_A[4])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[2]
      + (RaspberryMagmanModelTest_P.DiscreteStateSpace_A[5])*
      RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[3];
    xnew[3] += (RaspberryMagmanModelTest_P.DiscreteStateSpace_B[3])*
      RaspberryMagmanModelTest_B.Gain[1];
    (void) memcpy(&RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[0],
                  xnew,
                  sizeof(real_T)*4);
  }

  /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
  sfcn_setPlatform_Update_wrapper(&RaspberryMagmanModelTest_B.PWM[0],
    &RaspberryMagmanModelTest_DW.MagManCoils_DSTATE);

  /* External mode */
  rtExtModeUploadCheckTrigger(2);

  {                                    /* Sample time: [0.0s, 0.0s] */
    rtExtModeUpload(0, RaspberryMagmanModelTest_M->Timing.t[0]);
  }

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(1, (((RaspberryMagmanModelTest_M->Timing.clockTick1+
                          RaspberryMagmanModelTest_M->Timing.clockTickH1*
                          4294967296.0)) * 0.02));
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.0s, 0.0s] */
    if ((rtmGetTFinal(RaspberryMagmanModelTest_M)!=-1) &&
        !((rtmGetTFinal(RaspberryMagmanModelTest_M)-
           RaspberryMagmanModelTest_M->Timing.t[0]) >
          RaspberryMagmanModelTest_M->Timing.t[0] * (DBL_EPSILON))) {
      rtmSetErrorStatus(RaspberryMagmanModelTest_M, "Simulation finished");
    }

    if (rtmGetStopRequested(RaspberryMagmanModelTest_M)) {
      rtmSetErrorStatus(RaspberryMagmanModelTest_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++RaspberryMagmanModelTest_M->Timing.clockTick0)) {
    ++RaspberryMagmanModelTest_M->Timing.clockTickH0;
  }

  RaspberryMagmanModelTest_M->Timing.t[0] =
    RaspberryMagmanModelTest_M->Timing.clockTick0 *
    RaspberryMagmanModelTest_M->Timing.stepSize0 +
    RaspberryMagmanModelTest_M->Timing.clockTickH0 *
    RaspberryMagmanModelTest_M->Timing.stepSize0 * 4294967296.0;

  {
    /* Update absolute timer for sample time: [0.02s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 0.02, which is the step size
     * of the task. Size of "clockTick1" ensures timer will not overflow during the
     * application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    RaspberryMagmanModelTest_M->Timing.clockTick1++;
    if (!RaspberryMagmanModelTest_M->Timing.clockTick1) {
      RaspberryMagmanModelTest_M->Timing.clockTickH1++;
    }
  }
}

/* Model initialize function */
void RaspberryMagmanModelTest_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)RaspberryMagmanModelTest_M, 0,
                sizeof(RT_MODEL_RaspberryMagmanModel_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&RaspberryMagmanModelTest_M->solverInfo,
                          &RaspberryMagmanModelTest_M->Timing.simTimeStep);
    rtsiSetTPtr(&RaspberryMagmanModelTest_M->solverInfo, &rtmGetTPtr
                (RaspberryMagmanModelTest_M));
    rtsiSetStepSizePtr(&RaspberryMagmanModelTest_M->solverInfo,
                       &RaspberryMagmanModelTest_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&RaspberryMagmanModelTest_M->solverInfo,
                          (&rtmGetErrorStatus(RaspberryMagmanModelTest_M)));
    rtsiSetRTModelPtr(&RaspberryMagmanModelTest_M->solverInfo,
                      RaspberryMagmanModelTest_M);
  }

  rtsiSetSimTimeStep(&RaspberryMagmanModelTest_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&RaspberryMagmanModelTest_M->solverInfo,"FixedStepDiscrete");
  rtmSetTPtr(RaspberryMagmanModelTest_M,
             &RaspberryMagmanModelTest_M->Timing.tArray[0]);
  rtmSetTFinal(RaspberryMagmanModelTest_M, 5.0);
  RaspberryMagmanModelTest_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  RaspberryMagmanModelTest_M->Sizes.checksums[0] = (4954737U);
  RaspberryMagmanModelTest_M->Sizes.checksums[1] = (1382723365U);
  RaspberryMagmanModelTest_M->Sizes.checksums[2] = (2628527957U);
  RaspberryMagmanModelTest_M->Sizes.checksums[3] = (259820833U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[5];
    RaspberryMagmanModelTest_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(RaspberryMagmanModelTest_M->extModeInfo,
      &RaspberryMagmanModelTest_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(RaspberryMagmanModelTest_M->extModeInfo,
                        RaspberryMagmanModelTest_M->Sizes.checksums);
    rteiSetTPtr(RaspberryMagmanModelTest_M->extModeInfo, rtmGetTPtr
                (RaspberryMagmanModelTest_M));
  }

  /* block I/O */
  (void) memset(((void *) &RaspberryMagmanModelTest_B), 0,
                sizeof(B_RaspberryMagmanModelTest_T));

  /* states (dwork) */
  (void) memset((void *)&RaspberryMagmanModelTest_DW, 0,
                sizeof(DW_RaspberryMagmanModelTest_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    RaspberryMagmanModelTest_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* S-Function Block: <S4>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryMagmanModelTest_DW.MagManFoilwitherror_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <S5>/Shared memory camera position */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryMagmanModelTest_DW.Sharedmemorycameraposition_DSTA =
          initVector[0];
      }
    }
  }

  /* InitializeConditions for DiscreteStateSpace: '<Root>/Discrete State-Space' */
  RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[0] =
    (RaspberryMagmanModelTest_P.DiscreteStateSpace_X0[0]);
  RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[1] =
    (RaspberryMagmanModelTest_P.DiscreteStateSpace_X0[1]);
  RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[2] =
    (RaspberryMagmanModelTest_P.DiscreteStateSpace_X0[2]);
  RaspberryMagmanModelTest_DW.DiscreteStateSpace_DSTATE[3] =
    (RaspberryMagmanModelTest_P.DiscreteStateSpace_X0[3]);

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryMagmanModelTest_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }
}

/* Model terminate function */
void RaspberryMagmanModelTest_terminate(void)
{
  /* (no terminate code required) */
}
