/*
 * RaspberryMagmanModelTest.h
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberryMagmanModelTest".
 *
 * Model version              : 1.19
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Wed Dec 21 17:46:56 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_RaspberryMagmanModelTest_h_
#define RTW_HEADER_RaspberryMagmanModelTest_h_
#include <string.h>
#include <math.h>
#include <float.h>
#include <stddef.h>
#ifndef RaspberryMagmanModelTest_COMMON_INCLUDES_
# define RaspberryMagmanModelTest_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_extmode.h"
#include "sysran_types.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "dt_info.h"
#include "ext_work.h"
#endif                                 /* RaspberryMagmanModelTest_COMMON_INCLUDES_ */

#include "RaspberryMagmanModelTest_types.h"

/* Shared type includes */
#include "multiword_types.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetFinalTime
# define rtmGetFinalTime(rtm)          ((rtm)->Timing.tFinal)
#endif

#ifndef rtmGetRTWExtModeInfo
# define rtmGetRTWExtModeInfo(rtm)     ((rtm)->extModeInfo)
#endif

#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
# define rtmSetStopRequested(rtm, val) ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
# define rtmGetStopRequestedPtr(rtm)   (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  (rtmGetTPtr((rtm))[0])
#endif

#ifndef rtmGetTFinal
# define rtmGetTFinal(rtm)             ((rtm)->Timing.tFinal)
#endif

/* Block signals for system '<S1>/Position transformation1' */
typedef struct {
  real_T X;                            /* '<S1>/Position transformation1' */
  real_T Y;                            /* '<S1>/Position transformation1' */
} B_Positiontransformation1_Ras_T;

/* Block signals (auto storage) */
typedef struct {
  real_T Switch[16];                   /* '<Root>/Switch' */
  real_T MagManFoilwitherror_o1;       /* '<S4>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o2;       /* '<S4>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o3;       /* '<S4>/MagMan Foil with error' */
  real_T DataTypeConversion1;          /* '<S5>/Data Type Conversion1' */
  real_T DataTypeConversion2;          /* '<S5>/Data Type Conversion2' */
  real_T DiscreteStateSpace[2];        /* '<Root>/Discrete State-Space' */
  real_T Gain[2];                      /* '<S2>/Gain' */
  real_T PWM[16];                      /* '<Root>/Currents to PWM' */
  real_T minval[16];
  real_T b_a;
  int32_T MagManFoilwitherror_o4;      /* '<S4>/MagMan Foil with error' */
  int32_T Sharedmemorycameraposition_o1;/* '<S5>/Shared memory camera position' */
  int32_T Sharedmemorycameraposition_o2;/* '<S5>/Shared memory camera position' */
  B_Positiontransformation1_Ras_T sf_Positiontransformation;/* '<S4>/Position transformation' */
  B_Positiontransformation1_Ras_T sf_Positiontransformation1;/* '<S1>/Position transformation1' */
} B_RaspberryMagmanModelTest_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T MagManFoilwitherror_DSTATE;   /* '<S4>/MagMan Foil with error' */
  real_T Sharedmemorycameraposition_DSTA;/* '<S5>/Shared memory camera position' */
  real_T DiscreteStateSpace_DSTATE[4]; /* '<Root>/Discrete State-Space' */
  real_T MagManCoils_DSTATE;           /* '<Root>/MagMan Coils' */
  struct {
    void *LoggedData[3];
  } Position_PWORK;                    /* '<Root>/Position' */

  struct {
    void *LoggedData[2];
  } Nomalizedposition1_PWORK;          /* '<S1>/Nomalized position1' */

  struct {
    void *LoggedData[2];
  } Rawposition_PWORK;                 /* '<S1>/Raw position' */

  struct {
    void *LoggedData[2];
  } Nomalizedposition_PWORK;           /* '<S4>/Nomalized position' */

  struct {
    void *LoggedData[3];
  } Scope1_PWORK;                      /* '<S4>/Scope1' */
} DW_RaspberryMagmanModelTest_T;

/* Parameters (auto storage) */
struct P_RaspberryMagmanModelTest_T_ {
  real_T km4pi[9];                     /* Variable: km4pi
                                        * Referenced by: '<S4>/Sentinel Calibration matrix'
                                        */
  real_T km4piCam[9];                  /* Variable: km4piCam
                                        * Referenced by: '<S1>/Sentinel Calibration matrix1'
                                        */
  real_T Coilexcitationfactors_Value[16];/* Expression: [0 0 0 0;0 0 0 0;0 1 0 0;0 0 0 0]
                                          * Referenced by: '<Root>/Coil excitation factors'
                                          */
  real_T Step_Time;                    /* Expression: 3
                                        * Referenced by: '<Root>/Step'
                                        */
  real_T Step_Y0;                      /* Expression: 0
                                        * Referenced by: '<Root>/Step'
                                        */
  real_T Step_YFinal;                  /* Expression: 1
                                        * Referenced by: '<Root>/Step'
                                        */
  real_T Coilexcitationfactors1_Value[16];/* Expression: [0 0 0 0;0 1 0 0;0 0 0 0;0 0 0 0]
                                           * Referenced by: '<Root>/Coil excitation factors1'
                                           */
  real_T Switch_Threshold;             /* Expression: 0
                                        * Referenced by: '<Root>/Switch'
                                        */
  real_T DiscreteStateSpace_A[6];      /* Computed Parameter: DiscreteStateSpace_A
                                        * Referenced by: '<Root>/Discrete State-Space'
                                        */
  real_T DiscreteStateSpace_B[4];      /* Computed Parameter: DiscreteStateSpace_B
                                        * Referenced by: '<Root>/Discrete State-Space'
                                        */
  real_T DiscreteStateSpace_C[2];      /* Computed Parameter: DiscreteStateSpace_C
                                        * Referenced by: '<Root>/Discrete State-Space'
                                        */
  real_T DiscreteStateSpace_X0[4];     /* Expression: [0,2,0,2]
                                        * Referenced by: '<Root>/Discrete State-Space'
                                        */
  real_T Gain_Gain;                    /* Expression: 1/68
                                        * Referenced by: '<S2>/Gain'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_RaspberryMagmanModelT_T {
  const char_T *errorStatus;
  RTWExtModeInfo *extModeInfo;
  RTWSolverInfo solverInfo;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    uint32_T checksums[4];
  } Sizes;

  /*
   * SpecialInfo:
   * The following substructure contains special information
   * related to other components that are dependent on RTW.
   */
  struct {
    const void *mappingInfo;
  } SpecialInfo;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    uint32_T clockTick0;
    uint32_T clockTickH0;
    time_T stepSize0;
    uint32_T clockTick1;
    uint32_T clockTickH1;
    time_T tFinal;
    SimTimeStep simTimeStep;
    boolean_T stopRequestedFlag;
    time_T *t;
    time_T tArray[2];
  } Timing;
};

/* Block parameters (auto storage) */
extern P_RaspberryMagmanModelTest_T RaspberryMagmanModelTest_P;

/* Block signals (auto storage) */
extern B_RaspberryMagmanModelTest_T RaspberryMagmanModelTest_B;

/* Block states (auto storage) */
extern DW_RaspberryMagmanModelTest_T RaspberryMagmanModelTest_DW;

/* Model entry point functions */
extern void RaspberryMagmanModelTest_initialize(void);
extern void RaspberryMagmanModelTest_step(void);
extern void RaspberryMagmanModelTest_terminate(void);

/* Real-time Model object */
extern RT_MODEL_RaspberryMagmanModel_T *const RaspberryMagmanModelTest_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'RaspberryMagmanModelTest'
 * '<S1>'   : 'RaspberryMagmanModelTest/Camera position'
 * '<S2>'   : 'RaspberryMagmanModelTest/Currents to Force1'
 * '<S3>'   : 'RaspberryMagmanModelTest/Currents to PWM'
 * '<S4>'   : 'RaspberryMagmanModelTest/Foil position '
 * '<S5>'   : 'RaspberryMagmanModelTest/Camera position/Camera position from shared memory'
 * '<S6>'   : 'RaspberryMagmanModelTest/Camera position/Position transformation1'
 * '<S7>'   : 'RaspberryMagmanModelTest/Currents to Force1/Nonlinearity of  magnetic force'
 * '<S8>'   : 'RaspberryMagmanModelTest/Foil position /Position transformation'
 */
#endif                                 /* RTW_HEADER_RaspberryMagmanModelTest_h_ */
