/*
 * RaspberryPrediction.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberryPrediction".
 *
 * Model version              : 1.13
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Tue Dec 20 13:49:58 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "RaspberryPrediction.h"
#include "RaspberryPrediction_private.h"
#include "RaspberryPrediction_dt.h"

/* Block signals (auto storage) */
B_RaspberryPrediction_T RaspberryPrediction_B;

/* Continuous states */
X_RaspberryPrediction_T RaspberryPrediction_X;

/* Block states (auto storage) */
DW_RaspberryPrediction_T RaspberryPrediction_DW;

/* Real-time model */
RT_MODEL_RaspberryPrediction_T RaspberryPrediction_M_;
RT_MODEL_RaspberryPrediction_T *const RaspberryPrediction_M =
  &RaspberryPrediction_M_;

/*
 * This function updates continuous states using the ODE1 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE1_IntgData *id = (ODE1_IntgData *)rtsiGetSolverData(si);
  real_T *f0 = id->f[0];
  int_T i;
  int_T nXc = 4;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);
  rtsiSetdX(si, f0);
  RaspberryPrediction_derivatives();
  rtsiSetT(si, tnew);
  for (i = 0; i < nXc; ++i) {
    x[i] += h * f0[i];
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/*
 * Output and update for atomic system:
 *    '<S1>/Position transformation1'
 *    '<S4>/Position transformation'
 */
void Raspber_Positiontransformation1(real_T rtu_x, real_T rtu_y, const real_T
  rtu_km4[9], B_Positiontransformation1_Ras_T *localB)
{
  /* MATLAB Function 'Camera position/Position transformation1': '<S7>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S7>:1:4' xa = [x,y]; */
  /* '<S7>:1:5' H = km4(:); */
  /* '<S7>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S7>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S7>:1:9' X=out(1); */
  localB->X = ((rtu_x * rtu_km4[0] + rtu_y * rtu_km4[1]) + rtu_km4[2]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);

  /* '<S7>:1:10' Y=out(2); */
  localB->Y = ((rtu_x * rtu_km4[3] + rtu_y * rtu_km4[4]) + rtu_km4[5]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);
}

real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void RaspberryPrediction_step(void)
{
  int_T iy;
  int32_T ix;
  real_T d;
  real_T vy;
  real_T b_d;
  real_T Fv_idx_0;
  real_T Fv_idx_1;
  if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
    /* set solver stop time */
    if (!(RaspberryPrediction_M->Timing.clockTick0+1)) {
      rtsiSetSolverStopTime(&RaspberryPrediction_M->solverInfo,
                            ((RaspberryPrediction_M->Timing.clockTickH0 + 1) *
        RaspberryPrediction_M->Timing.stepSize0 * 4294967296.0));
    } else {
      rtsiSetSolverStopTime(&RaspberryPrediction_M->solverInfo,
                            ((RaspberryPrediction_M->Timing.clockTick0 + 1) *
        RaspberryPrediction_M->Timing.stepSize0 +
        RaspberryPrediction_M->Timing.clockTickH0 *
        RaspberryPrediction_M->Timing.stepSize0 * 4294967296.0));
    }
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(RaspberryPrediction_M)) {
    RaspberryPrediction_M->Timing.t[0] = rtsiGetT
      (&RaspberryPrediction_M->solverInfo);
  }

  /* StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  RaspberryPrediction_B.Linearmodeloftherollingball2ind[0] = 0.0;
  RaspberryPrediction_B.Linearmodeloftherollingball2ind[1] = 0.0;
  RaspberryPrediction_B.Linearmodeloftherollingball2ind[0] +=
    RaspberryPrediction_P.Linearmodeloftherollingball2i_h[0] *
    RaspberryPrediction_X.Linearmodeloftherollingball2ind[1];
  RaspberryPrediction_B.Linearmodeloftherollingball2ind[1] +=
    RaspberryPrediction_P.Linearmodeloftherollingball2i_h[1] *
    RaspberryPrediction_X.Linearmodeloftherollingball2ind[3];

  /* MATLAB Function: '<S5>/Embedded MATLAB Function' */
  /* MATLAB Function 'Force to Currents/Embedded MATLAB Function': '<S10>:1' */
  /* '<S10>:1:2' Ao=zeros(2,16); */
  memset(&RaspberryPrediction_B.Ao[0], 0, sizeof(real_T) << 5U);

  /* '<S10>:1:4' for iy=1:4 */
  for (iy = 0; iy < 4; iy++) {
    /* '<S10>:1:5' for ix=1:4 */
    for (ix = 0; ix < 4; ix++) {
      /* '<S10>:1:6' [cFx, cFy] = fForce(x, y, ix, iy); */
      /* '<S10>:1:14' d=dist(x,y, ix, iy); */
      /* '<S10>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
      d = RaspberryPrediction_B.Linearmodeloftherollingball2ind[0] - (1.0 +
        (real_T)ix);
      Fv_idx_1 = RaspberryPrediction_B.Linearmodeloftherollingball2ind[1] - (1.0
        + (real_T)iy);
      d = sqrt(d * d + Fv_idx_1 * Fv_idx_1);

      /* '<S10>:1:15' if d~=0 */
      if (d != 0.0) {
        /* '<S10>:1:16' F=gForce(d); */
        /* '<S10>:1:43' a = 622.06; */
        /* '<S10>:1:44' b = 9.5032; */
        /* '<S10>:1:45' c = 3.1884; */
        /* '<S10>:1:46' F = x.*a./(b.*x.^2+ c).^3; */
        d = d * 622.06 / rt_powd_snf(d * d * 9.5032 + 3.1884, 3.0);

        /* '<S10>:1:17' Fv=F*vector(x,y,ix,iy); */
        /* '<S10>:1:32' vx=ix-x; */
        Fv_idx_1 = (1.0 + (real_T)ix) -
          RaspberryPrediction_B.Linearmodeloftherollingball2ind[0];

        /* '<S10>:1:33' vy=iy-y; */
        vy = (1.0 + (real_T)iy) -
          RaspberryPrediction_B.Linearmodeloftherollingball2ind[1];

        /* '<S10>:1:35' if(vx==0 && vy ==0) */
        if ((Fv_idx_1 == 0.0) && (vy == 0.0)) {
          /* '<S10>:1:36' v=[0 0]; */
          Fv_idx_0 = 0.0;
          Fv_idx_1 = 0.0;
        } else {
          /* '<S10>:1:37' else */
          /* '<S10>:1:38' v = [vx vy]/dist(vx, vy, 0 ,0); */
          /* '<S10>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
          b_d = sqrt(Fv_idx_1 * Fv_idx_1 + vy * vy);
          Fv_idx_0 = Fv_idx_1 / b_d;
          Fv_idx_1 = vy / b_d;
        }

        Fv_idx_0 *= d;
        Fv_idx_1 *= d;

        /* '<S10>:1:18' Fx=Fv(1); */
        d = Fv_idx_0;

        /* '<S10>:1:19' Fy=Fv(2); */
      } else {
        /* '<S10>:1:20' else */
        /* '<S10>:1:21' Fx=0; */
        d = 0.0;

        /* '<S10>:1:22' Fy=0; */
        Fv_idx_1 = 0.0;
      }

      /* '<S10>:1:7' Ao(1,(iy-1)*4+ix) = cFx; */
      RaspberryPrediction_B.Ao[((iy << 2) + ix) << 1] = d;

      /* '<S10>:1:8' Ao(2,(iy-1)*4+ix) = cFy; */
      RaspberryPrediction_B.Ao[1 + (((iy << 2) + ix) << 1)] = Fv_idx_1;
    }
  }

  /* End of MATLAB Function: '<S5>/Embedded MATLAB Function' */

  /* S-Function (cvxfasd): '<S5>/MagMan linearization1' */
  cvxfasd_Outputs_wrapper(&RaspberryPrediction_B.Ao[0],
    &RaspberryPrediction_P.ReferenceForce_Value[0],
    &RaspberryPrediction_P.ReferenceForce_Value[1],
    &RaspberryPrediction_B.MagManlinearization1_o1[0],
    &RaspberryPrediction_B.MagManlinearization1_o2 );

  /* Math: '<S5>/Math Function' */
  for (iy = 0; iy < 4; iy++) {
    RaspberryPrediction_B.MathFunction[iy << 2] =
      RaspberryPrediction_B.MagManlinearization1_o1[iy];
    RaspberryPrediction_B.MathFunction[1 + (iy << 2)] =
      RaspberryPrediction_B.MagManlinearization1_o1[iy + 4];
    RaspberryPrediction_B.MathFunction[2 + (iy << 2)] =
      RaspberryPrediction_B.MagManlinearization1_o1[iy + 8];
    RaspberryPrediction_B.MathFunction[3 + (iy << 2)] =
      RaspberryPrediction_B.MagManlinearization1_o1[iy + 12];
  }

  /* End of Math: '<S5>/Math Function' */

  /* MATLAB Function: '<Root>/Currents to PWM1' */
  /* MATLAB Function 'Currents to PWM': '<S3>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S3>:1:3' Currents = max(0, min(1,Currents) ); */
  /*  limits */
  /* '<S3>:1:4' i = 0.18515*Currents + 0.069587*Currents.^3 + 0.19285*Currents.^(1/3); */
  /*  ratio to current conversion */
  /* '<S3>:1:5' PWM = i/0.455/2; */
  /* '<S3>:1:6' PWM(PWM>0.05) = PWM(PWM>0.05) + 0.5; */
  /* '<S3>:1:7' PWM(PWM<0.5) = 0; */
  for (iy = 0; iy < 16; iy++) {
    if ((1.0 <= RaspberryPrediction_B.MathFunction[iy]) || rtIsNaN
        (RaspberryPrediction_B.MathFunction[iy])) {
      d = 1.0;
    } else {
      d = RaspberryPrediction_B.MathFunction[iy];
    }

    if ((0.0 >= d) || rtIsNaN(d)) {
      RaspberryPrediction_B.PWM[iy] = 0.0;
    } else {
      RaspberryPrediction_B.PWM[iy] = d;
    }

    RaspberryPrediction_B.PWM[iy] = ((0.18515 * RaspberryPrediction_B.PWM[iy] +
      0.069587 * rt_powd_snf(RaspberryPrediction_B.PWM[iy], 3.0)) + 0.19285 *
      rt_powd_snf(RaspberryPrediction_B.PWM[iy], 0.33333333333333331)) / 0.455 /
      2.0;
    if (RaspberryPrediction_B.PWM[iy] > 0.05) {
      RaspberryPrediction_B.PWM[iy] += 0.5;
    }

    if (RaspberryPrediction_B.PWM[iy] < 0.5) {
      RaspberryPrediction_B.PWM[iy] = 0.0;
    }
  }

  /* End of MATLAB Function: '<Root>/Currents to PWM1' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&RaspberryPrediction_B.PWM[0],
    &RaspberryPrediction_DW.MagManCoils_DSTATE);
  if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
    /* S-Function (sfcn_getFoilCheck): '<S4>/MagMan Foil with error' */
    sfcn_getFoilCheck_Outputs_wrapper
      ( &RaspberryPrediction_B.MagManFoilwitherror_o1,
       &RaspberryPrediction_B.MagManFoilwitherror_o2,
       &RaspberryPrediction_B.MagManFoilwitherror_o3,
       &RaspberryPrediction_B.MagManFoilwitherror_o4,
       &RaspberryPrediction_DW.MagManFoilwitherror_DSTATE);

    /* MATLAB Function: '<S4>/Position transformation' incorporates:
     *  Constant: '<S4>/Sentinel Calibration matrix'
     */
    Raspber_Positiontransformation1(RaspberryPrediction_B.MagManFoilwitherror_o1,
      RaspberryPrediction_B.MagManFoilwitherror_o2, RaspberryPrediction_P.km4pi,
      &RaspberryPrediction_B.sf_Positiontransformation);
  }

  /* S-Function (sfcn_posread_shm): '<S6>/Shared memory camera position' */
  sfcn_posread_shm_Outputs_wrapper
    ( &RaspberryPrediction_B.Sharedmemorycameraposition_o1,
     &RaspberryPrediction_B.Sharedmemorycameraposition_o2,
     &RaspberryPrediction_DW.Sharedmemorycameraposition_DSTA);

  /* DataTypeConversion: '<S6>/Data Type Conversion1' */
  RaspberryPrediction_B.DataTypeConversion1 =
    RaspberryPrediction_B.Sharedmemorycameraposition_o1;

  /* DataTypeConversion: '<S6>/Data Type Conversion2' */
  RaspberryPrediction_B.DataTypeConversion2 =
    RaspberryPrediction_B.Sharedmemorycameraposition_o2;

  /* MATLAB Function: '<S1>/Position transformation1' incorporates:
   *  Constant: '<S1>/Sentinel Calibration matrix1'
   */
  Raspber_Positiontransformation1(RaspberryPrediction_B.DataTypeConversion1,
    RaspberryPrediction_B.DataTypeConversion2, RaspberryPrediction_P.km4piCam,
    &RaspberryPrediction_B.sf_Positiontransformation1);
  if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
    /* Delay: '<Root>/Delay' */
    RaspberryPrediction_B.Delay[0] = RaspberryPrediction_DW.Delay_DSTATE[0];
    RaspberryPrediction_B.Delay[1] = RaspberryPrediction_DW.Delay_DSTATE[1];
  }

  /* Sum: '<Root>/Sum1' incorporates:
   *  Constant: '<Root>/Reference Force'
   *  Gain: '<Root>/L'
   *  Sum: '<Root>/Sum'
   */
  RaspberryPrediction_B.Sum1[0] = RaspberryPrediction_P.ReferenceForce_Value[0]
    - (RaspberryPrediction_B.Delay[0] -
       RaspberryPrediction_B.sf_Positiontransformation1.X) *
    RaspberryPrediction_P.L_Gain;
  RaspberryPrediction_B.Sum1[1] = RaspberryPrediction_P.ReferenceForce_Value[1]
    - (RaspberryPrediction_B.Delay[1] -
       RaspberryPrediction_B.sf_Positiontransformation1.Y) *
    RaspberryPrediction_P.L_Gain;
  if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
    /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
    sfcn_setPlatform_Update_wrapper(&RaspberryPrediction_B.PWM[0],
      &RaspberryPrediction_DW.MagManCoils_DSTATE);
    if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
      /* S-Function "sfcn_getFoilCheck_wrapper" Block: <S4>/MagMan Foil with error */
      sfcn_getFoilCheck_Update_wrapper
        ( &RaspberryPrediction_B.MagManFoilwitherror_o1,
         &RaspberryPrediction_B.MagManFoilwitherror_o2,
         &RaspberryPrediction_B.MagManFoilwitherror_o3,
         &RaspberryPrediction_B.MagManFoilwitherror_o4,
         &RaspberryPrediction_DW.MagManFoilwitherror_DSTATE);
    }

    /* S-Function "sfcn_posread_shm_wrapper" Block: <S6>/Shared memory camera position */
    sfcn_posread_shm_Update_wrapper
      ( &RaspberryPrediction_B.Sharedmemorycameraposition_o1,
       &RaspberryPrediction_B.Sharedmemorycameraposition_o2,
       &RaspberryPrediction_DW.Sharedmemorycameraposition_DSTA);
    if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
      /* Update for Delay: '<Root>/Delay' */
      RaspberryPrediction_DW.Delay_DSTATE[0] =
        RaspberryPrediction_DW.Delay_DSTATE[2];
      RaspberryPrediction_DW.Delay_DSTATE[1] =
        RaspberryPrediction_DW.Delay_DSTATE[3];
      RaspberryPrediction_DW.Delay_DSTATE[2] =
        RaspberryPrediction_B.Linearmodeloftherollingball2ind[0];
      RaspberryPrediction_DW.Delay_DSTATE[3] =
        RaspberryPrediction_B.Linearmodeloftherollingball2ind[1];
    }

    /* External mode */
    rtExtModeUploadCheckTrigger(2);

    {                                  /* Sample time: [0.0s, 0.0s] */
      rtExtModeUpload(0, RaspberryPrediction_M->Timing.t[0]);
    }

    if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {/* Sample time: [0.02s, 0.0s] */
      rtExtModeUpload(1, (((RaspberryPrediction_M->Timing.clockTick1+
                            RaspberryPrediction_M->Timing.clockTickH1*
                            4294967296.0)) * 0.02));
    }
  }                                    /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(RaspberryPrediction_M)) {
    /* signal main to stop simulation */
    {                                  /* Sample time: [0.0s, 0.0s] */
      if ((rtmGetTFinal(RaspberryPrediction_M)!=-1) &&
          !((rtmGetTFinal(RaspberryPrediction_M)-
             (((RaspberryPrediction_M->Timing.clockTick1+
                RaspberryPrediction_M->Timing.clockTickH1* 4294967296.0)) * 0.02))
            > (((RaspberryPrediction_M->Timing.clockTick1+
                 RaspberryPrediction_M->Timing.clockTickH1* 4294967296.0)) *
               0.02) * (DBL_EPSILON))) {
        rtmSetErrorStatus(RaspberryPrediction_M, "Simulation finished");
      }

      if (rtmGetStopRequested(RaspberryPrediction_M)) {
        rtmSetErrorStatus(RaspberryPrediction_M, "Simulation finished");
      }
    }

    rt_ertODEUpdateContinuousStates(&RaspberryPrediction_M->solverInfo);

    /* Update absolute time for base rate */
    /* The "clockTick0" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick0"
     * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick0 and the high bits
     * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++RaspberryPrediction_M->Timing.clockTick0)) {
      ++RaspberryPrediction_M->Timing.clockTickH0;
    }

    RaspberryPrediction_M->Timing.t[0] = rtsiGetSolverStopTime
      (&RaspberryPrediction_M->solverInfo);

    {
      /* Update absolute timer for sample time: [0.02s, 0.0s] */
      /* The "clockTick1" counts the number of times the code of this task has
       * been executed. The resolution of this integer timer is 0.02, which is the step size
       * of the task. Size of "clockTick1" ensures timer will not overflow during the
       * application lifespan selected.
       * Timer of this task consists of two 32 bit unsigned integers.
       * The two integers represent the low bits Timing.clockTick1 and the high bits
       * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
       */
      RaspberryPrediction_M->Timing.clockTick1++;
      if (!RaspberryPrediction_M->Timing.clockTick1) {
        RaspberryPrediction_M->Timing.clockTickH1++;
      }
    }
  }                                    /* end MajorTimeStep */
}

/* Derivatives for root system: '<Root>' */
void RaspberryPrediction_derivatives(void)
{
  XDot_RaspberryPrediction_T *_rtXdot;
  _rtXdot = ((XDot_RaspberryPrediction_T *) RaspberryPrediction_M->derivs);

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  _rtXdot->Linearmodeloftherollingball2ind[0] = 0.0;
  _rtXdot->Linearmodeloftherollingball2ind[1] = 0.0;
  _rtXdot->Linearmodeloftherollingball2ind[2] = 0.0;
  _rtXdot->Linearmodeloftherollingball2ind[3] = 0.0;
  _rtXdot->Linearmodeloftherollingball2ind[1] +=
    RaspberryPrediction_P.Linearmodeloftherollingball2ind[0] *
    RaspberryPrediction_X.Linearmodeloftherollingball2ind[0];
  _rtXdot->Linearmodeloftherollingball2ind[3] +=
    RaspberryPrediction_P.Linearmodeloftherollingball2ind[1] *
    RaspberryPrediction_X.Linearmodeloftherollingball2ind[2];
  _rtXdot->Linearmodeloftherollingball2ind[0] +=
    RaspberryPrediction_P.Linearmodeloftherollingball2i_l[0] *
    RaspberryPrediction_B.Sum1[0];
  _rtXdot->Linearmodeloftherollingball2ind[2] +=
    RaspberryPrediction_P.Linearmodeloftherollingball2i_l[1] *
    RaspberryPrediction_B.Sum1[1];
}

/* Model initialize function */
void RaspberryPrediction_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)RaspberryPrediction_M, 0,
                sizeof(RT_MODEL_RaspberryPrediction_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&RaspberryPrediction_M->solverInfo,
                          &RaspberryPrediction_M->Timing.simTimeStep);
    rtsiSetTPtr(&RaspberryPrediction_M->solverInfo, &rtmGetTPtr
                (RaspberryPrediction_M));
    rtsiSetStepSizePtr(&RaspberryPrediction_M->solverInfo,
                       &RaspberryPrediction_M->Timing.stepSize0);
    rtsiSetdXPtr(&RaspberryPrediction_M->solverInfo,
                 &RaspberryPrediction_M->derivs);
    rtsiSetContStatesPtr(&RaspberryPrediction_M->solverInfo, (real_T **)
                         &RaspberryPrediction_M->contStates);
    rtsiSetNumContStatesPtr(&RaspberryPrediction_M->solverInfo,
      &RaspberryPrediction_M->Sizes.numContStates);
    rtsiSetNumPeriodicContStatesPtr(&RaspberryPrediction_M->solverInfo,
      &RaspberryPrediction_M->Sizes.numPeriodicContStates);
    rtsiSetPeriodicContStateIndicesPtr(&RaspberryPrediction_M->solverInfo,
      &RaspberryPrediction_M->periodicContStateIndices);
    rtsiSetPeriodicContStateRangesPtr(&RaspberryPrediction_M->solverInfo,
      &RaspberryPrediction_M->periodicContStateRanges);
    rtsiSetErrorStatusPtr(&RaspberryPrediction_M->solverInfo,
                          (&rtmGetErrorStatus(RaspberryPrediction_M)));
    rtsiSetRTModelPtr(&RaspberryPrediction_M->solverInfo, RaspberryPrediction_M);
  }

  rtsiSetSimTimeStep(&RaspberryPrediction_M->solverInfo, MAJOR_TIME_STEP);
  RaspberryPrediction_M->intgData.f[0] = RaspberryPrediction_M->odeF[0];
  RaspberryPrediction_M->contStates = ((X_RaspberryPrediction_T *)
    &RaspberryPrediction_X);
  rtsiSetSolverData(&RaspberryPrediction_M->solverInfo, (void *)
                    &RaspberryPrediction_M->intgData);
  rtsiSetSolverName(&RaspberryPrediction_M->solverInfo,"ode1");
  rtmSetTPtr(RaspberryPrediction_M, &RaspberryPrediction_M->Timing.tArray[0]);
  rtmSetTFinal(RaspberryPrediction_M, -1);
  RaspberryPrediction_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  RaspberryPrediction_M->Sizes.checksums[0] = (3595132348U);
  RaspberryPrediction_M->Sizes.checksums[1] = (4069635331U);
  RaspberryPrediction_M->Sizes.checksums[2] = (3308004464U);
  RaspberryPrediction_M->Sizes.checksums[3] = (2480287856U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[5];
    RaspberryPrediction_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(RaspberryPrediction_M->extModeInfo,
      &RaspberryPrediction_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(RaspberryPrediction_M->extModeInfo,
                        RaspberryPrediction_M->Sizes.checksums);
    rteiSetTPtr(RaspberryPrediction_M->extModeInfo, rtmGetTPtr
                (RaspberryPrediction_M));
  }

  /* block I/O */
  (void) memset(((void *) &RaspberryPrediction_B), 0,
                sizeof(B_RaspberryPrediction_T));

  /* states (continuous) */
  {
    (void) memset((void *)&RaspberryPrediction_X, 0,
                  sizeof(X_RaspberryPrediction_T));
  }

  /* states (dwork) */
  (void) memset((void *)&RaspberryPrediction_DW, 0,
                sizeof(DW_RaspberryPrediction_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    RaspberryPrediction_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* InitializeConditions for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  RaspberryPrediction_X.Linearmodeloftherollingball2ind[0] =
    RaspberryPrediction_P.Linearmodeloftherollingball2i_a[0];
  RaspberryPrediction_X.Linearmodeloftherollingball2ind[1] =
    RaspberryPrediction_P.Linearmodeloftherollingball2i_a[1];
  RaspberryPrediction_X.Linearmodeloftherollingball2ind[2] =
    RaspberryPrediction_P.Linearmodeloftherollingball2i_a[2];
  RaspberryPrediction_X.Linearmodeloftherollingball2ind[3] =
    RaspberryPrediction_P.Linearmodeloftherollingball2i_a[3];

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryPrediction_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <S4>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryPrediction_DW.MagManFoilwitherror_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <S6>/Shared memory camera position */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberryPrediction_DW.Sharedmemorycameraposition_DSTA = initVector[0];
      }
    }
  }

  /* InitializeConditions for Delay: '<Root>/Delay' */
  RaspberryPrediction_DW.Delay_DSTATE[0] =
    RaspberryPrediction_P.Delay_InitialCondition;
  RaspberryPrediction_DW.Delay_DSTATE[1] =
    RaspberryPrediction_P.Delay_InitialCondition;
  RaspberryPrediction_DW.Delay_DSTATE[2] =
    RaspberryPrediction_P.Delay_InitialCondition;
  RaspberryPrediction_DW.Delay_DSTATE[3] =
    RaspberryPrediction_P.Delay_InitialCondition;
}

/* Model terminate function */
void RaspberryPrediction_terminate(void)
{
  /* (no terminate code required) */
}
