/*
 * RaspberrySmithPredictor.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "RaspberrySmithPredictor".
 *
 * Model version              : 1.1
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Tue Dec 20 14:52:06 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "RaspberrySmithPredictor.h"
#include "RaspberrySmithPredictor_private.h"
#include "RaspberrySmithPredictor_dt.h"

/* Block signals (auto storage) */
B_RaspberrySmithPredictor_T RaspberrySmithPredictor_B;

/* Continuous states */
X_RaspberrySmithPredictor_T RaspberrySmithPredictor_X;

/* Block states (auto storage) */
DW_RaspberrySmithPredictor_T RaspberrySmithPredictor_DW;

/* Real-time model */
RT_MODEL_RaspberrySmithPredic_T RaspberrySmithPredictor_M_;
RT_MODEL_RaspberrySmithPredic_T *const RaspberrySmithPredictor_M =
  &RaspberrySmithPredictor_M_;

/*
 * This function updates continuous states using the ODE1 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE1_IntgData *id = (ODE1_IntgData *)rtsiGetSolverData(si);
  real_T *f0 = id->f[0];
  int_T i;
  int_T nXc = 8;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);
  rtsiSetdX(si, f0);
  RaspberrySmithPredictor_derivatives();
  rtsiSetT(si, tnew);
  for (i = 0; i < nXc; ++i) {
    x[i] += h * f0[i];
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/*
 * Output and update for atomic system:
 *    '<S1>/Position transformation1'
 *    '<S3>/Position transformation'
 */
void Raspber_Positiontransformation1(real_T rtu_x, real_T rtu_y, const real_T
  rtu_km4[9], B_Positiontransformation1_Ras_T *localB)
{
  /* MATLAB Function 'Camera position/Position transformation1': '<S7>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S7>:1:4' xa = [x,y]; */
  /* '<S7>:1:5' H = km4(:); */
  /* '<S7>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S7>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S7>:1:9' X=out(1); */
  localB->X = ((rtu_x * rtu_km4[0] + rtu_y * rtu_km4[1]) + rtu_km4[2]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);

  /* '<S7>:1:10' Y=out(2); */
  localB->Y = ((rtu_x * rtu_km4[3] + rtu_y * rtu_km4[4]) + rtu_km4[5]) / ((rtu_x
    * rtu_km4[6] + rtu_y * rtu_km4[7]) + rtu_km4[8]);
}

real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void RaspberrySmithPredictor_step(void)
{
  int32_T iy;
  int32_T ix;
  real_T rtb_Sum_l_idx_0;
  real_T rtb_Sum_l_idx_1;
  real_T rtb_Saturate_idx_0;
  real_T rtb_Saturate_idx_1;
  real_T Fv_idx_1;
  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
    /* set solver stop time */
    if (!(RaspberrySmithPredictor_M->Timing.clockTick0+1)) {
      rtsiSetSolverStopTime(&RaspberrySmithPredictor_M->solverInfo,
                            ((RaspberrySmithPredictor_M->Timing.clockTickH0 + 1)
        * RaspberrySmithPredictor_M->Timing.stepSize0 * 4294967296.0));
    } else {
      rtsiSetSolverStopTime(&RaspberrySmithPredictor_M->solverInfo,
                            ((RaspberrySmithPredictor_M->Timing.clockTick0 + 1) *
        RaspberrySmithPredictor_M->Timing.stepSize0 +
        RaspberrySmithPredictor_M->Timing.clockTickH0 *
        RaspberrySmithPredictor_M->Timing.stepSize0 * 4294967296.0));
    }
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(RaspberrySmithPredictor_M)) {
    RaspberrySmithPredictor_M->Timing.t[0] = rtsiGetT
      (&RaspberrySmithPredictor_M->solverInfo);
  }

  /* S-Function (sfcn_getFoilCheck): '<S3>/MagMan Foil with error' */
  sfcn_getFoilCheck_Outputs_wrapper
    ( &RaspberrySmithPredictor_B.MagManFoilwitherror_o1,
     &RaspberrySmithPredictor_B.MagManFoilwitherror_o2,
     &RaspberrySmithPredictor_B.MagManFoilwitherror_o3,
     &RaspberrySmithPredictor_B.MagManFoilwitherror_o4,
     &RaspberrySmithPredictor_DW.MagManFoilwitherror_DSTATE);

  /* MATLAB Function: '<S3>/Position transformation' incorporates:
   *  Constant: '<S3>/Sentinel Calibration matrix'
   */
  Raspber_Positiontransformation1
    (RaspberrySmithPredictor_B.MagManFoilwitherror_o1,
     RaspberrySmithPredictor_B.MagManFoilwitherror_o2,
     RaspberrySmithPredictor_P.km4pi,
     &RaspberrySmithPredictor_B.sf_Positiontransformation);

  /* MATLAB Function: '<S4>/Embedded MATLAB Function' */
  /* MATLAB Function 'Force to Currents/Embedded MATLAB Function': '<S9>:1' */
  /* '<S9>:1:2' Ao=zeros(2,16); */
  memset(&RaspberrySmithPredictor_B.Ao[0], 0, sizeof(real_T) << 5U);

  /* '<S9>:1:4' for iy=1:4 */
  for (iy = 0; iy < 4; iy++) {
    /* '<S9>:1:5' for ix=1:4 */
    for (ix = 0; ix < 4; ix++) {
      /* '<S9>:1:6' [cFx, cFy] = fForce(x, y, ix, iy); */
      /* '<S9>:1:14' d=dist(x,y, ix, iy); */
      /* '<S9>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
      rtb_Sum_l_idx_0 = RaspberrySmithPredictor_B.sf_Positiontransformation.X -
        (1.0 + (real_T)ix);
      Fv_idx_1 = RaspberrySmithPredictor_B.sf_Positiontransformation.Y - (1.0 +
        (real_T)iy);
      rtb_Sum_l_idx_0 = sqrt(rtb_Sum_l_idx_0 * rtb_Sum_l_idx_0 + Fv_idx_1 *
        Fv_idx_1);

      /* '<S9>:1:15' if d~=0 */
      if (rtb_Sum_l_idx_0 != 0.0) {
        /* '<S9>:1:16' F=gForce(d); */
        /* '<S9>:1:43' a = 622.06; */
        /* '<S9>:1:44' b = 9.5032; */
        /* '<S9>:1:45' c = 3.1884; */
        /* '<S9>:1:46' F = x.*a./(b.*x.^2+ c).^3; */
        rtb_Sum_l_idx_0 = rtb_Sum_l_idx_0 * 622.06 / rt_powd_snf(rtb_Sum_l_idx_0
          * rtb_Sum_l_idx_0 * 9.5032 + 3.1884, 3.0);

        /* '<S9>:1:17' Fv=F*vector(x,y,ix,iy); */
        /* '<S9>:1:32' vx=ix-x; */
        Fv_idx_1 = (1.0 + (real_T)ix) -
          RaspberrySmithPredictor_B.sf_Positiontransformation.X;

        /* '<S9>:1:33' vy=iy-y; */
        rtb_Sum_l_idx_1 = (1.0 + (real_T)iy) -
          RaspberrySmithPredictor_B.sf_Positiontransformation.Y;

        /* '<S9>:1:35' if(vx==0 && vy ==0) */
        if ((Fv_idx_1 == 0.0) && (rtb_Sum_l_idx_1 == 0.0)) {
          /* '<S9>:1:36' v=[0 0]; */
          rtb_Saturate_idx_1 = 0.0;
          Fv_idx_1 = 0.0;
        } else {
          /* '<S9>:1:37' else */
          /* '<S9>:1:38' v = [vx vy]/dist(vx, vy, 0 ,0); */
          /* '<S9>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
          rtb_Saturate_idx_0 = sqrt(Fv_idx_1 * Fv_idx_1 + rtb_Sum_l_idx_1 *
            rtb_Sum_l_idx_1);
          rtb_Saturate_idx_1 = Fv_idx_1 / rtb_Saturate_idx_0;
          Fv_idx_1 = rtb_Sum_l_idx_1 / rtb_Saturate_idx_0;
        }

        rtb_Saturate_idx_1 *= rtb_Sum_l_idx_0;
        Fv_idx_1 *= rtb_Sum_l_idx_0;

        /* '<S9>:1:18' Fx=Fv(1); */
        rtb_Sum_l_idx_0 = rtb_Saturate_idx_1;

        /* '<S9>:1:19' Fy=Fv(2); */
      } else {
        /* '<S9>:1:20' else */
        /* '<S9>:1:21' Fx=0; */
        rtb_Sum_l_idx_0 = 0.0;

        /* '<S9>:1:22' Fy=0; */
        Fv_idx_1 = 0.0;
      }

      /* '<S9>:1:7' Ao(1,(iy-1)*4+ix) = cFx; */
      RaspberrySmithPredictor_B.Ao[((iy << 2) + ix) << 1] = rtb_Sum_l_idx_0;

      /* '<S9>:1:8' Ao(2,(iy-1)*4+ix) = cFy; */
      RaspberrySmithPredictor_B.Ao[1 + (((iy << 2) + ix) << 1)] = Fv_idx_1;
    }
  }

  /* End of MATLAB Function: '<S4>/Embedded MATLAB Function' */
  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
    /* Gain: '<S5>/Setpoint Weighting (Proportional)' incorporates:
     *  Constant: '<Root>/Referece position'
     */
    RaspberrySmithPredictor_B.SetpointWeightingProportional[0] =
      RaspberrySmithPredictor_P.PIDController2DOF_b *
      RaspberrySmithPredictor_P.Refereceposition_Value[0];
    RaspberrySmithPredictor_B.SetpointWeightingProportional[1] =
      RaspberrySmithPredictor_P.PIDController2DOF_b *
      RaspberrySmithPredictor_P.Refereceposition_Value[1];
  }

  /* S-Function (sfcn_posread_shm): '<S6>/Shared memory camera position' */
  sfcn_posread_shm_Outputs_wrapper
    ( &RaspberrySmithPredictor_B.Sharedmemorycameraposition_o1,
     &RaspberrySmithPredictor_B.Sharedmemorycameraposition_o2,
     &RaspberrySmithPredictor_DW.Sharedmemorycameraposition_DSTA);

  /* DataTypeConversion: '<S6>/Data Type Conversion1' */
  RaspberrySmithPredictor_B.DataTypeConversion1 =
    RaspberrySmithPredictor_B.Sharedmemorycameraposition_o1;

  /* DataTypeConversion: '<S6>/Data Type Conversion2' */
  RaspberrySmithPredictor_B.DataTypeConversion2 =
    RaspberrySmithPredictor_B.Sharedmemorycameraposition_o2;

  /* MATLAB Function: '<S1>/Position transformation1' incorporates:
   *  Constant: '<S1>/Sentinel Calibration matrix1'
   */
  Raspber_Positiontransformation1(RaspberrySmithPredictor_B.DataTypeConversion1,
    RaspberrySmithPredictor_B.DataTypeConversion2,
    RaspberrySmithPredictor_P.km4piCam,
    &RaspberrySmithPredictor_B.sf_Positiontransformation1);
  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
    /* DiscreteIntegrator: '<S5>/Integrator' */
    RaspberrySmithPredictor_B.Integrator[0] =
      RaspberrySmithPredictor_DW.Integrator_DSTATE[0];

    /* Gain: '<S5>/Setpoint Weighting (Derivative)' incorporates:
     *  Constant: '<Root>/Referece position'
     */
    RaspberrySmithPredictor_B.SetpointWeightingDerivative[0] =
      RaspberrySmithPredictor_P.PIDController2DOF_c *
      RaspberrySmithPredictor_P.Refereceposition_Value[0];

    /* DiscreteIntegrator: '<S5>/Filter' */
    RaspberrySmithPredictor_B.Filter[0] =
      RaspberrySmithPredictor_DW.Filter_DSTATE[0];

    /* DiscreteIntegrator: '<S5>/Integrator' */
    RaspberrySmithPredictor_B.Integrator[1] =
      RaspberrySmithPredictor_DW.Integrator_DSTATE[1];

    /* Gain: '<S5>/Setpoint Weighting (Derivative)' incorporates:
     *  Constant: '<Root>/Referece position'
     */
    RaspberrySmithPredictor_B.SetpointWeightingDerivative[1] =
      RaspberrySmithPredictor_P.PIDController2DOF_c *
      RaspberrySmithPredictor_P.Refereceposition_Value[1];

    /* DiscreteIntegrator: '<S5>/Filter' */
    RaspberrySmithPredictor_B.Filter[1] =
      RaspberrySmithPredictor_DW.Filter_DSTATE[1];
  }

  /* Gain: '<S5>/Filter Coefficient' incorporates:
   *  Gain: '<S5>/Derivative Gain'
   *  Sum: '<S5>/Sum3'
   *  Sum: '<S5>/SumD'
   */
  RaspberrySmithPredictor_B.FilterCoefficient[0] =
    ((RaspberrySmithPredictor_B.SetpointWeightingDerivative[0] -
      RaspberrySmithPredictor_B.sf_Positiontransformation1.X) *
     RaspberrySmithPredictor_P.PIDController2DOF_D -
     RaspberrySmithPredictor_B.Filter[0]) *
    RaspberrySmithPredictor_P.PIDController2DOF_N;
  RaspberrySmithPredictor_B.FilterCoefficient[1] =
    ((RaspberrySmithPredictor_B.SetpointWeightingDerivative[1] -
      RaspberrySmithPredictor_B.sf_Positiontransformation1.Y) *
     RaspberrySmithPredictor_P.PIDController2DOF_D -
     RaspberrySmithPredictor_B.Filter[1]) *
    RaspberrySmithPredictor_P.PIDController2DOF_N;

  /* Sum: '<S5>/Sum' incorporates:
   *  Gain: '<S5>/Proportional Gain'
   *  Sum: '<S5>/Sum1'
   */
  rtb_Sum_l_idx_0 = ((RaspberrySmithPredictor_B.SetpointWeightingProportional[0]
                      - RaspberrySmithPredictor_B.sf_Positiontransformation1.X) *
                     RaspberrySmithPredictor_P.PIDController2DOF_P +
                     RaspberrySmithPredictor_B.Integrator[0]) +
    RaspberrySmithPredictor_B.FilterCoefficient[0];
  rtb_Sum_l_idx_1 = ((RaspberrySmithPredictor_B.SetpointWeightingProportional[1]
                      - RaspberrySmithPredictor_B.sf_Positiontransformation1.Y) *
                     RaspberrySmithPredictor_P.PIDController2DOF_P +
                     RaspberrySmithPredictor_B.Integrator[1]) +
    RaspberrySmithPredictor_B.FilterCoefficient[1];

  /* Saturate: '<S5>/Saturate' */
  if (rtb_Sum_l_idx_0 >
      RaspberrySmithPredictor_P.PIDController2DOF_UpperSaturati) {
    rtb_Saturate_idx_0 =
      RaspberrySmithPredictor_P.PIDController2DOF_UpperSaturati;
  } else if (rtb_Sum_l_idx_0 <
             RaspberrySmithPredictor_P.PIDController2DOF_LowerSaturati) {
    rtb_Saturate_idx_0 =
      RaspberrySmithPredictor_P.PIDController2DOF_LowerSaturati;
  } else {
    rtb_Saturate_idx_0 = rtb_Sum_l_idx_0;
  }

  if (rtb_Sum_l_idx_1 >
      RaspberrySmithPredictor_P.PIDController2DOF_UpperSaturati) {
    rtb_Saturate_idx_1 =
      RaspberrySmithPredictor_P.PIDController2DOF_UpperSaturati;
  } else if (rtb_Sum_l_idx_1 <
             RaspberrySmithPredictor_P.PIDController2DOF_LowerSaturati) {
    rtb_Saturate_idx_1 =
      RaspberrySmithPredictor_P.PIDController2DOF_LowerSaturati;
  } else {
    rtb_Saturate_idx_1 = rtb_Sum_l_idx_1;
  }

  /* End of Saturate: '<S5>/Saturate' */
  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
    /* Delay: '<Root>/Delay' */
    RaspberrySmithPredictor_B.Delay[0] =
      RaspberrySmithPredictor_DW.Delay_DSTATE[0];
    RaspberrySmithPredictor_B.Delay[1] =
      RaspberrySmithPredictor_DW.Delay_DSTATE[1];
  }

  /* Sum: '<Root>/Sum1' incorporates:
   *  StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)'
   *  Sum: '<Root>/Sum'
   */
  RaspberrySmithPredictor_B.Sum1[0] = rtb_Saturate_idx_0 -
    (RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_d[0] *
     RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[1] -
     RaspberrySmithPredictor_B.Delay[0]);
  RaspberrySmithPredictor_B.Sum1[1] = rtb_Saturate_idx_1 -
    (RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_d[1] *
     RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[3] -
     RaspberrySmithPredictor_B.Delay[1]);

  /* S-Function (cvxfasd): '<S4>/MagMan linearization1' */
  cvxfasd_Outputs_wrapper(&RaspberrySmithPredictor_B.Ao[0],
    &RaspberrySmithPredictor_B.Sum1[0], &RaspberrySmithPredictor_B.Sum1[1],
    &RaspberrySmithPredictor_B.MagManlinearization1_o1[0],
    &RaspberrySmithPredictor_B.MagManlinearization1_o2 );

  /* Math: '<S4>/Math Function' */
  for (iy = 0; iy < 4; iy++) {
    RaspberrySmithPredictor_B.MathFunction[iy << 2] =
      RaspberrySmithPredictor_B.MagManlinearization1_o1[iy];
    RaspberrySmithPredictor_B.MathFunction[1 + (iy << 2)] =
      RaspberrySmithPredictor_B.MagManlinearization1_o1[iy + 4];
    RaspberrySmithPredictor_B.MathFunction[2 + (iy << 2)] =
      RaspberrySmithPredictor_B.MagManlinearization1_o1[iy + 8];
    RaspberrySmithPredictor_B.MathFunction[3 + (iy << 2)] =
      RaspberrySmithPredictor_B.MagManlinearization1_o1[iy + 12];
  }

  /* End of Math: '<S4>/Math Function' */

  /* MATLAB Function: '<Root>/Currents to PWM' */
  /* MATLAB Function 'Currents to PWM': '<S2>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S2>:1:3' Currents = max(0, min(1,Currents) ); */
  /*  limits */
  /* '<S2>:1:4' i = 0.18515*Currents + 0.069587*Currents.^3 + 0.19285*Currents.^(1/3); */
  /*  ratio to current conversion */
  /* '<S2>:1:5' PWM = i/0.455/2; */
  /* '<S2>:1:6' PWM(PWM>0.05) = PWM(PWM>0.05) + 0.5; */
  /* '<S2>:1:7' PWM(PWM<0.5) = 0; */
  for (iy = 0; iy < 16; iy++) {
    if ((1.0 <= RaspberrySmithPredictor_B.MathFunction[iy]) || rtIsNaN
        (RaspberrySmithPredictor_B.MathFunction[iy])) {
      Fv_idx_1 = 1.0;
    } else {
      Fv_idx_1 = RaspberrySmithPredictor_B.MathFunction[iy];
    }

    if ((0.0 >= Fv_idx_1) || rtIsNaN(Fv_idx_1)) {
      RaspberrySmithPredictor_B.PWM[iy] = 0.0;
    } else {
      RaspberrySmithPredictor_B.PWM[iy] = Fv_idx_1;
    }

    RaspberrySmithPredictor_B.PWM[iy] = ((0.18515 *
      RaspberrySmithPredictor_B.PWM[iy] + 0.069587 * rt_powd_snf
      (RaspberrySmithPredictor_B.PWM[iy], 3.0)) + 0.19285 * rt_powd_snf
      (RaspberrySmithPredictor_B.PWM[iy], 0.33333333333333331)) / 0.455 / 2.0;
    if (RaspberrySmithPredictor_B.PWM[iy] > 0.05) {
      RaspberrySmithPredictor_B.PWM[iy] += 0.5;
    }

    if (RaspberrySmithPredictor_B.PWM[iy] < 0.5) {
      RaspberrySmithPredictor_B.PWM[iy] = 0.0;
    }
  }

  /* End of MATLAB Function: '<Root>/Currents to PWM' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&RaspberrySmithPredictor_B.PWM[0],
    &RaspberrySmithPredictor_DW.MagManCoils_DSTATE);
  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
  }

  /* StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  RaspberrySmithPredictor_B.Linearmodeloftherollingball2ind[0] = 0.0;
  RaspberrySmithPredictor_B.Linearmodeloftherollingball2ind[1] = 0.0;
  RaspberrySmithPredictor_B.Linearmodeloftherollingball2ind[0] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_k[0] *
    RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[1];
  RaspberrySmithPredictor_B.Linearmodeloftherollingball2ind[1] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_k[1] *
    RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[3];

  /* Sum: '<S5>/SumI1' incorporates:
   *  Constant: '<Root>/Referece position'
   *  Gain: '<S5>/Integral Gain'
   *  Gain: '<S5>/Kb'
   *  Sum: '<S5>/Sum2'
   *  Sum: '<S5>/SumI2'
   */
  RaspberrySmithPredictor_B.SumI1[0] =
    (RaspberrySmithPredictor_P.Refereceposition_Value[0] -
     RaspberrySmithPredictor_B.sf_Positiontransformation1.X) *
    RaspberrySmithPredictor_P.PIDController2DOF_I + (rtb_Saturate_idx_0 -
    rtb_Sum_l_idx_0) * RaspberrySmithPredictor_P.PIDController2DOF_Kb;
  RaspberrySmithPredictor_B.SumI1[1] =
    (RaspberrySmithPredictor_P.Refereceposition_Value[1] -
     RaspberrySmithPredictor_B.sf_Positiontransformation1.Y) *
    RaspberrySmithPredictor_P.PIDController2DOF_I + (rtb_Saturate_idx_1 -
    rtb_Sum_l_idx_1) * RaspberrySmithPredictor_P.PIDController2DOF_Kb;
  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
    /* S-Function "sfcn_getFoilCheck_wrapper" Block: <S3>/MagMan Foil with error */
    sfcn_getFoilCheck_Update_wrapper
      ( &RaspberrySmithPredictor_B.MagManFoilwitherror_o1,
       &RaspberrySmithPredictor_B.MagManFoilwitherror_o2,
       &RaspberrySmithPredictor_B.MagManFoilwitherror_o3,
       &RaspberrySmithPredictor_B.MagManFoilwitherror_o4,
       &RaspberrySmithPredictor_DW.MagManFoilwitherror_DSTATE);

    /* S-Function "sfcn_posread_shm_wrapper" Block: <S6>/Shared memory camera position */
    sfcn_posread_shm_Update_wrapper
      ( &RaspberrySmithPredictor_B.Sharedmemorycameraposition_o1,
       &RaspberrySmithPredictor_B.Sharedmemorycameraposition_o2,
       &RaspberrySmithPredictor_DW.Sharedmemorycameraposition_DSTA);
    if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
      /* Update for DiscreteIntegrator: '<S5>/Integrator' */
      RaspberrySmithPredictor_DW.Integrator_DSTATE[0] +=
        RaspberrySmithPredictor_P.Integrator_gainval *
        RaspberrySmithPredictor_B.SumI1[0];

      /* Update for DiscreteIntegrator: '<S5>/Filter' */
      RaspberrySmithPredictor_DW.Filter_DSTATE[0] +=
        RaspberrySmithPredictor_P.Filter_gainval *
        RaspberrySmithPredictor_B.FilterCoefficient[0];

      /* Update for Delay: '<Root>/Delay' */
      RaspberrySmithPredictor_DW.Delay_DSTATE[0] =
        RaspberrySmithPredictor_DW.Delay_DSTATE[2];

      /* Update for DiscreteIntegrator: '<S5>/Integrator' */
      RaspberrySmithPredictor_DW.Integrator_DSTATE[1] +=
        RaspberrySmithPredictor_P.Integrator_gainval *
        RaspberrySmithPredictor_B.SumI1[1];

      /* Update for DiscreteIntegrator: '<S5>/Filter' */
      RaspberrySmithPredictor_DW.Filter_DSTATE[1] +=
        RaspberrySmithPredictor_P.Filter_gainval *
        RaspberrySmithPredictor_B.FilterCoefficient[1];

      /* Update for Delay: '<Root>/Delay' */
      RaspberrySmithPredictor_DW.Delay_DSTATE[1] =
        RaspberrySmithPredictor_DW.Delay_DSTATE[3];
      RaspberrySmithPredictor_DW.Delay_DSTATE[2] =
        RaspberrySmithPredictor_B.Linearmodeloftherollingball2ind[0];
      RaspberrySmithPredictor_DW.Delay_DSTATE[3] =
        RaspberrySmithPredictor_B.Linearmodeloftherollingball2ind[1];
    }

    /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
    sfcn_setPlatform_Update_wrapper(&RaspberrySmithPredictor_B.PWM[0],
      &RaspberrySmithPredictor_DW.MagManCoils_DSTATE);

    /* External mode */
    rtExtModeUploadCheckTrigger(2);

    {                                  /* Sample time: [0.0s, 0.0s] */
      rtExtModeUpload(0, RaspberrySmithPredictor_M->Timing.t[0]);
    }

    if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {/* Sample time: [0.02s, 0.0s] */
      rtExtModeUpload(1, (((RaspberrySmithPredictor_M->Timing.clockTick1+
                            RaspberrySmithPredictor_M->Timing.clockTickH1*
                            4294967296.0)) * 0.02));
    }
  }                                    /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(RaspberrySmithPredictor_M)) {
    /* signal main to stop simulation */
    {                                  /* Sample time: [0.0s, 0.0s] */
      if ((rtmGetTFinal(RaspberrySmithPredictor_M)!=-1) &&
          !((rtmGetTFinal(RaspberrySmithPredictor_M)-
             (((RaspberrySmithPredictor_M->Timing.clockTick1+
                RaspberrySmithPredictor_M->Timing.clockTickH1* 4294967296.0)) *
              0.02)) > (((RaspberrySmithPredictor_M->Timing.clockTick1+
                          RaspberrySmithPredictor_M->Timing.clockTickH1*
                          4294967296.0)) * 0.02) * (DBL_EPSILON))) {
        rtmSetErrorStatus(RaspberrySmithPredictor_M, "Simulation finished");
      }

      if (rtmGetStopRequested(RaspberrySmithPredictor_M)) {
        rtmSetErrorStatus(RaspberrySmithPredictor_M, "Simulation finished");
      }
    }

    rt_ertODEUpdateContinuousStates(&RaspberrySmithPredictor_M->solverInfo);

    /* Update absolute time for base rate */
    /* The "clockTick0" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick0"
     * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick0 and the high bits
     * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++RaspberrySmithPredictor_M->Timing.clockTick0)) {
      ++RaspberrySmithPredictor_M->Timing.clockTickH0;
    }

    RaspberrySmithPredictor_M->Timing.t[0] = rtsiGetSolverStopTime
      (&RaspberrySmithPredictor_M->solverInfo);

    {
      /* Update absolute timer for sample time: [0.02s, 0.0s] */
      /* The "clockTick1" counts the number of times the code of this task has
       * been executed. The resolution of this integer timer is 0.02, which is the step size
       * of the task. Size of "clockTick1" ensures timer will not overflow during the
       * application lifespan selected.
       * Timer of this task consists of two 32 bit unsigned integers.
       * The two integers represent the low bits Timing.clockTick1 and the high bits
       * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
       */
      RaspberrySmithPredictor_M->Timing.clockTick1++;
      if (!RaspberrySmithPredictor_M->Timing.clockTick1) {
        RaspberrySmithPredictor_M->Timing.clockTickH1++;
      }
    }
  }                                    /* end MajorTimeStep */
}

/* Derivatives for root system: '<Root>' */
void RaspberrySmithPredictor_derivatives(void)
{
  XDot_RaspberrySmithPredictor_T *_rtXdot;
  _rtXdot = ((XDot_RaspberrySmithPredictor_T *)
             RaspberrySmithPredictor_M->derivs);

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  _rtXdot->Linearmodeloftherollingball2ind[0] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  _rtXdot->Linearmodeloftherollingball2i_n[0] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  _rtXdot->Linearmodeloftherollingball2ind[1] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  _rtXdot->Linearmodeloftherollingball2i_n[1] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  _rtXdot->Linearmodeloftherollingball2ind[2] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  _rtXdot->Linearmodeloftherollingball2i_n[2] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  _rtXdot->Linearmodeloftherollingball2ind[3] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  _rtXdot->Linearmodeloftherollingball2i_n[3] = 0.0;

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  _rtXdot->Linearmodeloftherollingball2ind[1] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2ind[0] *
    RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[0];
  _rtXdot->Linearmodeloftherollingball2ind[3] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2ind[1] *
    RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[2];
  _rtXdot->Linearmodeloftherollingball2ind[0] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_c[0] *
    RaspberrySmithPredictor_B.Sum1[0];
  _rtXdot->Linearmodeloftherollingball2ind[2] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_c[1] *
    RaspberrySmithPredictor_B.Sum1[1];

  /* Derivatives for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  _rtXdot->Linearmodeloftherollingball2i_n[1] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_o[0] *
    RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[0];
  _rtXdot->Linearmodeloftherollingball2i_n[3] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_o[1] *
    RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[2];
  _rtXdot->Linearmodeloftherollingball2i_n[0] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_g[0] *
    RaspberrySmithPredictor_B.Sum1[0];
  _rtXdot->Linearmodeloftherollingball2i_n[2] +=
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_g[1] *
    RaspberrySmithPredictor_B.Sum1[1];
}

/* Model initialize function */
void RaspberrySmithPredictor_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)RaspberrySmithPredictor_M, 0,
                sizeof(RT_MODEL_RaspberrySmithPredic_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&RaspberrySmithPredictor_M->solverInfo,
                          &RaspberrySmithPredictor_M->Timing.simTimeStep);
    rtsiSetTPtr(&RaspberrySmithPredictor_M->solverInfo, &rtmGetTPtr
                (RaspberrySmithPredictor_M));
    rtsiSetStepSizePtr(&RaspberrySmithPredictor_M->solverInfo,
                       &RaspberrySmithPredictor_M->Timing.stepSize0);
    rtsiSetdXPtr(&RaspberrySmithPredictor_M->solverInfo,
                 &RaspberrySmithPredictor_M->derivs);
    rtsiSetContStatesPtr(&RaspberrySmithPredictor_M->solverInfo, (real_T **)
                         &RaspberrySmithPredictor_M->contStates);
    rtsiSetNumContStatesPtr(&RaspberrySmithPredictor_M->solverInfo,
      &RaspberrySmithPredictor_M->Sizes.numContStates);
    rtsiSetNumPeriodicContStatesPtr(&RaspberrySmithPredictor_M->solverInfo,
      &RaspberrySmithPredictor_M->Sizes.numPeriodicContStates);
    rtsiSetPeriodicContStateIndicesPtr(&RaspberrySmithPredictor_M->solverInfo,
      &RaspberrySmithPredictor_M->periodicContStateIndices);
    rtsiSetPeriodicContStateRangesPtr(&RaspberrySmithPredictor_M->solverInfo,
      &RaspberrySmithPredictor_M->periodicContStateRanges);
    rtsiSetErrorStatusPtr(&RaspberrySmithPredictor_M->solverInfo,
                          (&rtmGetErrorStatus(RaspberrySmithPredictor_M)));
    rtsiSetRTModelPtr(&RaspberrySmithPredictor_M->solverInfo,
                      RaspberrySmithPredictor_M);
  }

  rtsiSetSimTimeStep(&RaspberrySmithPredictor_M->solverInfo, MAJOR_TIME_STEP);
  RaspberrySmithPredictor_M->intgData.f[0] = RaspberrySmithPredictor_M->odeF[0];
  RaspberrySmithPredictor_M->contStates = ((X_RaspberrySmithPredictor_T *)
    &RaspberrySmithPredictor_X);
  rtsiSetSolverData(&RaspberrySmithPredictor_M->solverInfo, (void *)
                    &RaspberrySmithPredictor_M->intgData);
  rtsiSetSolverName(&RaspberrySmithPredictor_M->solverInfo,"ode1");
  rtmSetTPtr(RaspberrySmithPredictor_M,
             &RaspberrySmithPredictor_M->Timing.tArray[0]);
  rtmSetTFinal(RaspberrySmithPredictor_M, 200.0);
  RaspberrySmithPredictor_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  RaspberrySmithPredictor_M->Sizes.checksums[0] = (1572438744U);
  RaspberrySmithPredictor_M->Sizes.checksums[1] = (1708337573U);
  RaspberrySmithPredictor_M->Sizes.checksums[2] = (3258557356U);
  RaspberrySmithPredictor_M->Sizes.checksums[3] = (2585635U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[5];
    RaspberrySmithPredictor_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(RaspberrySmithPredictor_M->extModeInfo,
      &RaspberrySmithPredictor_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(RaspberrySmithPredictor_M->extModeInfo,
                        RaspberrySmithPredictor_M->Sizes.checksums);
    rteiSetTPtr(RaspberrySmithPredictor_M->extModeInfo, rtmGetTPtr
                (RaspberrySmithPredictor_M));
  }

  /* block I/O */
  (void) memset(((void *) &RaspberrySmithPredictor_B), 0,
                sizeof(B_RaspberrySmithPredictor_T));

  /* states (continuous) */
  {
    (void) memset((void *)&RaspberrySmithPredictor_X, 0,
                  sizeof(X_RaspberrySmithPredictor_T));
  }

  /* states (dwork) */
  (void) memset((void *)&RaspberrySmithPredictor_DW, 0,
                sizeof(DW_RaspberrySmithPredictor_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    RaspberrySmithPredictor_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* S-Function Block: <S3>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberrySmithPredictor_DW.MagManFoilwitherror_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <S6>/Shared memory camera position */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberrySmithPredictor_DW.Sharedmemorycameraposition_DSTA = initVector
          [0];
      }
    }
  }

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Integrator' */
  RaspberrySmithPredictor_DW.Integrator_DSTATE[0] =
    RaspberrySmithPredictor_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Filter' */
  RaspberrySmithPredictor_DW.Filter_DSTATE[0] =
    RaspberrySmithPredictor_P.Filter_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Integrator' */
  RaspberrySmithPredictor_DW.Integrator_DSTATE[1] =
    RaspberrySmithPredictor_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Filter' */
  RaspberrySmithPredictor_DW.Filter_DSTATE[1] =
    RaspberrySmithPredictor_P.Filter_IC;

  /* InitializeConditions for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[0] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_l[0];

  /* InitializeConditions for Delay: '<Root>/Delay' */
  RaspberrySmithPredictor_DW.Delay_DSTATE[0] =
    RaspberrySmithPredictor_P.Delay_InitialCondition;

  /* InitializeConditions for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[1] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_l[1];

  /* InitializeConditions for Delay: '<Root>/Delay' */
  RaspberrySmithPredictor_DW.Delay_DSTATE[1] =
    RaspberrySmithPredictor_P.Delay_InitialCondition;

  /* InitializeConditions for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[2] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_l[2];

  /* InitializeConditions for Delay: '<Root>/Delay' */
  RaspberrySmithPredictor_DW.Delay_DSTATE[2] =
    RaspberrySmithPredictor_P.Delay_InitialCondition;

  /* InitializeConditions for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)' */
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2ind[3] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_l[3];

  /* InitializeConditions for Delay: '<Root>/Delay' */
  RaspberrySmithPredictor_DW.Delay_DSTATE[3] =
    RaspberrySmithPredictor_P.Delay_InitialCondition;

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        RaspberrySmithPredictor_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }

  /* InitializeConditions for StateSpace: '<Root>/Linear model of the rolling ball (2 independent double integrators)1' */
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[0] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_a[0];
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[1] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_a[1];
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[2] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_a[2];
  RaspberrySmithPredictor_X.Linearmodeloftherollingball2i_n[3] =
    RaspberrySmithPredictor_P.Linearmodeloftherollingball2i_a[3];
}

/* Model terminate function */
void RaspberrySmithPredictor_terminate(void)
{
  /* (no terminate code required) */
}
