/*
 * FoilControlRaspberrySentinel.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "FoilControlRaspberrySentinel".
 *
 * Model version              : 1.24
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Wed Nov 23 14:06:32 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "FoilControlRaspberrySentinel.h"
#include "FoilControlRaspberrySentinel_private.h"
#include "FoilControlRaspberrySentinel_dt.h"
#define FoilControlRaspberryS_PinNumber (17.0)

/* Block signals (auto storage) */
B_FoilControlRaspberrySentine_T FoilControlRaspberrySentinel_B;

/* Block states (auto storage) */
DW_FoilControlRaspberrySentin_T FoilControlRaspberrySentinel_DW;

/* Real-time model */
RT_MODEL_FoilControlRaspberry_T FoilControlRaspberrySentinel_M_;
RT_MODEL_FoilControlRaspberry_T *const FoilControlRaspberrySentinel_M =
  &FoilControlRaspberrySentinel_M_;
real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void FoilControlRaspberrySentinel_step(void)
{
  int32_T i;
  int32_T xoffset;
  uint8_T rtb_FixPtSum1;
  real_T rtb_FilterCoefficient_idx_0;
  real_T rtb_FilterCoefficient_idx_1;
  real_T rtb_Sum_idx_0;
  real_T rtb_Sum_idx_1;

  /* S-Function (sfcn_getFoilCheck): '<Root>/MagMan Foil with error' */
  sfcn_getFoilCheck_Outputs_wrapper
    ( &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o1,
     &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2,
     &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o3,
     &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o4,
     &FoilControlRaspberrySentinel_DW.MagManFoilwitherror_DSTATE);

  /* MATLAB Function: '<Root>/ht1' incorporates:
   *  Constant: '<Root>/Sentinel Calibration matrix'
   */
  /* MATLAB Function 'ht1': '<S6>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S6>:1:4' xa = [x,y]; */
  /* '<S6>:1:5' H = km4(:); */
  /* '<S6>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S6>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S6>:1:9' X=out(1); */
  FoilControlRaspberrySentinel_B.X =
    ((FoilControlRaspberrySentinel_B.MagManFoilwitherror_o1 *
      FoilControlRaspberrySentinel_P.km4pi[0] +
      FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2 *
      FoilControlRaspberrySentinel_P.km4pi[1]) +
     FoilControlRaspberrySentinel_P.km4pi[2]) /
    ((FoilControlRaspberrySentinel_B.MagManFoilwitherror_o1 *
      FoilControlRaspberrySentinel_P.km4pi[6] +
      FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2 *
      FoilControlRaspberrySentinel_P.km4pi[7]) +
     FoilControlRaspberrySentinel_P.km4pi[8]);

  /* '<S6>:1:10' Y=out(2); */
  FoilControlRaspberrySentinel_B.Y =
    ((FoilControlRaspberrySentinel_B.MagManFoilwitherror_o1 *
      FoilControlRaspberrySentinel_P.km4pi[3] +
      FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2 *
      FoilControlRaspberrySentinel_P.km4pi[4]) +
     FoilControlRaspberrySentinel_P.km4pi[5]) /
    ((FoilControlRaspberrySentinel_B.MagManFoilwitherror_o1 *
      FoilControlRaspberrySentinel_P.km4pi[6] +
      FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2 *
      FoilControlRaspberrySentinel_P.km4pi[7]) +
     FoilControlRaspberrySentinel_P.km4pi[8]);

  /* MATLAB Function: '<S7>/Embedded MATLAB Function' */
  /* MATLAB Function 'linearization/Embedded MATLAB Function': '<S12>:1' */
  /* '<S12>:1:2' Ao=zeros(2,16); */
  memset(&FoilControlRaspberrySentinel_B.Ao[0], 0, sizeof(real_T) << 5U);

  /* '<S12>:1:4' for iy=1:4 */
  for (xoffset = 0; xoffset < 4; xoffset++) {
    /* '<S12>:1:5' for ix=1:4 */
    for (i = 0; i < 4; i++) {
      /* '<S12>:1:6' [cFx, cFy] = fForce(x, y, ix, iy); */
      /* '<S12>:1:14' d=dist(x,y, ix, iy); */
      /* '<S12>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
      FoilControlRaspberrySentinel_B.lim = FoilControlRaspberrySentinel_B.X -
        (1.0 + (real_T)i);
      rtb_Sum_idx_1 = FoilControlRaspberrySentinel_B.Y - (1.0 + (real_T)xoffset);
      FoilControlRaspberrySentinel_B.lim = sqrt
        (FoilControlRaspberrySentinel_B.lim * FoilControlRaspberrySentinel_B.lim
         + rtb_Sum_idx_1 * rtb_Sum_idx_1);

      /* '<S12>:1:15' if d~=0 */
      if (FoilControlRaspberrySentinel_B.lim != 0.0) {
        /* '<S12>:1:16' F=gForce(d); */
        /* '<S12>:1:43' a = 622.06; */
        /* '<S12>:1:44' b = 9.5032; */
        /* '<S12>:1:45' c = 3.1884; */
        /* '<S12>:1:46' F = x.*a./(b.*x.^2+ c).^3; */
        FoilControlRaspberrySentinel_B.lim = FoilControlRaspberrySentinel_B.lim *
          622.06 / rt_powd_snf(FoilControlRaspberrySentinel_B.lim *
          FoilControlRaspberrySentinel_B.lim * 9.5032 + 3.1884, 3.0);

        /* '<S12>:1:17' Fv=F*vector(x,y,ix,iy); */
        /* '<S12>:1:32' vx=ix-x; */
        rtb_Sum_idx_1 = (1.0 + (real_T)i) - FoilControlRaspberrySentinel_B.X;

        /* '<S12>:1:33' vy=iy-y; */
        rtb_FilterCoefficient_idx_0 = (1.0 + (real_T)xoffset) -
          FoilControlRaspberrySentinel_B.Y;

        /* '<S12>:1:35' if(vx==0 && vy ==0) */
        if ((rtb_Sum_idx_1 == 0.0) && (rtb_FilterCoefficient_idx_0 == 0.0)) {
          /* '<S12>:1:36' v=[0 0]; */
          rtb_Sum_idx_0 = 0.0;
          rtb_Sum_idx_1 = 0.0;
        } else {
          /* '<S12>:1:37' else */
          /* '<S12>:1:38' v = [vx vy]/dist(vx, vy, 0 ,0); */
          /* '<S12>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
          rtb_FilterCoefficient_idx_1 = sqrt(rtb_Sum_idx_1 * rtb_Sum_idx_1 +
            rtb_FilterCoefficient_idx_0 * rtb_FilterCoefficient_idx_0);
          rtb_Sum_idx_0 = rtb_Sum_idx_1 / rtb_FilterCoefficient_idx_1;
          rtb_Sum_idx_1 = rtb_FilterCoefficient_idx_0 /
            rtb_FilterCoefficient_idx_1;
        }

        rtb_Sum_idx_0 *= FoilControlRaspberrySentinel_B.lim;
        rtb_Sum_idx_1 *= FoilControlRaspberrySentinel_B.lim;

        /* '<S12>:1:18' Fx=Fv(1); */
        FoilControlRaspberrySentinel_B.lim = rtb_Sum_idx_0;

        /* '<S12>:1:19' Fy=Fv(2); */
      } else {
        /* '<S12>:1:20' else */
        /* '<S12>:1:21' Fx=0; */
        FoilControlRaspberrySentinel_B.lim = 0.0;

        /* '<S12>:1:22' Fy=0; */
        rtb_Sum_idx_1 = 0.0;
      }

      /* '<S12>:1:7' Ao(1,(iy-1)*4+ix) = cFx; */
      FoilControlRaspberrySentinel_B.Ao[((xoffset << 2) + i) << 1] =
        FoilControlRaspberrySentinel_B.lim;

      /* '<S12>:1:8' Ao(2,(iy-1)*4+ix) = cFy; */
      FoilControlRaspberrySentinel_B.Ao[1 + (((xoffset << 2) + i) << 1)] =
        rtb_Sum_idx_1;
    }
  }

  /* End of MATLAB Function: '<S7>/Embedded MATLAB Function' */

  /* Gain: '<S5>/Filter Coefficient' incorporates:
   *  Constant: '<Root>/Constant'
   *  Constant: '<Root>/Constant1'
   *  DiscreteIntegrator: '<S5>/Filter'
   *  Gain: '<S5>/Derivative Gain'
   *  Gain: '<S5>/Setpoint Weighting (Derivative)'
   *  Sum: '<S5>/Sum3'
   *  Sum: '<S5>/SumD'
   */
  rtb_FilterCoefficient_idx_0 =
    ((FoilControlRaspberrySentinel_P.PIDController2DOF1_c *
      FoilControlRaspberrySentinel_P.Constant_Value -
      FoilControlRaspberrySentinel_B.X) *
     FoilControlRaspberrySentinel_P.PIDController2DOF1_D -
     FoilControlRaspberrySentinel_DW.Filter_DSTATE[0]) *
    FoilControlRaspberrySentinel_P.PIDController2DOF1_N;
  rtb_FilterCoefficient_idx_1 =
    ((FoilControlRaspberrySentinel_P.PIDController2DOF1_c *
      FoilControlRaspberrySentinel_P.Constant1_Value -
      FoilControlRaspberrySentinel_B.Y) *
     FoilControlRaspberrySentinel_P.PIDController2DOF1_D -
     FoilControlRaspberrySentinel_DW.Filter_DSTATE[1]) *
    FoilControlRaspberrySentinel_P.PIDController2DOF1_N;

  /* Sum: '<S5>/Sum' incorporates:
   *  Constant: '<Root>/Constant'
   *  Constant: '<Root>/Constant1'
   *  DiscreteIntegrator: '<S5>/Integrator'
   *  Gain: '<S5>/Proportional Gain'
   *  Gain: '<S5>/Setpoint Weighting (Proportional)'
   *  Sum: '<S5>/Sum1'
   */
  rtb_Sum_idx_0 = ((FoilControlRaspberrySentinel_P.PIDController2DOF1_b *
                    FoilControlRaspberrySentinel_P.Constant_Value -
                    FoilControlRaspberrySentinel_B.X) *
                   FoilControlRaspberrySentinel_P.PIDController2DOF1_P +
                   FoilControlRaspberrySentinel_DW.Integrator_DSTATE[0]) +
    rtb_FilterCoefficient_idx_0;
  rtb_Sum_idx_1 = ((FoilControlRaspberrySentinel_P.PIDController2DOF1_b *
                    FoilControlRaspberrySentinel_P.Constant1_Value -
                    FoilControlRaspberrySentinel_B.Y) *
                   FoilControlRaspberrySentinel_P.PIDController2DOF1_P +
                   FoilControlRaspberrySentinel_DW.Integrator_DSTATE[1]) +
    rtb_FilterCoefficient_idx_1;

  /* Saturate: '<S5>/Saturate' */
  if (rtb_Sum_idx_0 >
      FoilControlRaspberrySentinel_P.PIDController2DOF1_UpperSaturat) {
    FoilControlRaspberrySentinel_B.Saturate[0] =
      FoilControlRaspberrySentinel_P.PIDController2DOF1_UpperSaturat;
  } else if (rtb_Sum_idx_0 <
             FoilControlRaspberrySentinel_P.PIDController2DOF1_LowerSaturat) {
    FoilControlRaspberrySentinel_B.Saturate[0] =
      FoilControlRaspberrySentinel_P.PIDController2DOF1_LowerSaturat;
  } else {
    FoilControlRaspberrySentinel_B.Saturate[0] = rtb_Sum_idx_0;
  }

  if (rtb_Sum_idx_1 >
      FoilControlRaspberrySentinel_P.PIDController2DOF1_UpperSaturat) {
    FoilControlRaspberrySentinel_B.Saturate[1] =
      FoilControlRaspberrySentinel_P.PIDController2DOF1_UpperSaturat;
  } else if (rtb_Sum_idx_1 <
             FoilControlRaspberrySentinel_P.PIDController2DOF1_LowerSaturat) {
    FoilControlRaspberrySentinel_B.Saturate[1] =
      FoilControlRaspberrySentinel_P.PIDController2DOF1_LowerSaturat;
  } else {
    FoilControlRaspberrySentinel_B.Saturate[1] = rtb_Sum_idx_1;
  }

  /* End of Saturate: '<S5>/Saturate' */

  /* S-Function (cvxfasd): '<S7>/MagMan linearization' */
  cvxfasd_Outputs_wrapper(&FoilControlRaspberrySentinel_B.Ao[0],
    &FoilControlRaspberrySentinel_B.Saturate[0],
    &FoilControlRaspberrySentinel_B.Saturate[1],
    &FoilControlRaspberrySentinel_B.MagManlinearization_o1[0],
    &FoilControlRaspberrySentinel_B.MagManlinearization_o2 );

  /* MATLAB Function: '<Root>/pwm' */
  /* MATLAB Function 'pwm': '<S9>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S9>:1:3' x = max(0, min(1,x) ); */
  /*  limits */
  /* '<S9>:1:4' i = 0.18515*x + 0.069587*x.^3 + 0.19285*x.^(1/3); */
  /*  ratio to current conversion */
  /* '<S9>:1:5' pw = i/0.455/2; */
  /* '<S9>:1:6' pw(pw>0.05) = pw(pw>0.05) + 0.5; */
  /* '<S9>:1:7' pw(pw<0.5) = 0; */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    if ((1.0 <= FoilControlRaspberrySentinel_B.MagManlinearization_o1[xoffset]) ||
        rtIsNaN(FoilControlRaspberrySentinel_B.MagManlinearization_o1[xoffset]))
    {
      FoilControlRaspberrySentinel_B.lim = 1.0;
    } else {
      FoilControlRaspberrySentinel_B.lim =
        FoilControlRaspberrySentinel_B.MagManlinearization_o1[xoffset];
    }

    if ((0.0 >= FoilControlRaspberrySentinel_B.lim) || rtIsNaN
        (FoilControlRaspberrySentinel_B.lim)) {
      FoilControlRaspberrySentinel_B.pw[xoffset] = 0.0;
    } else {
      FoilControlRaspberrySentinel_B.pw[xoffset] =
        FoilControlRaspberrySentinel_B.lim;
    }

    FoilControlRaspberrySentinel_B.pw[xoffset] = ((0.18515 *
      FoilControlRaspberrySentinel_B.pw[xoffset] + 0.069587 * rt_powd_snf
      (FoilControlRaspberrySentinel_B.pw[xoffset], 3.0)) + 0.19285 * rt_powd_snf
      (FoilControlRaspberrySentinel_B.pw[xoffset], 0.33333333333333331)) / 0.455
      / 2.0;
    if (FoilControlRaspberrySentinel_B.pw[xoffset] > 0.05) {
      FoilControlRaspberrySentinel_B.pw[xoffset] += 0.5;
    }

    if (FoilControlRaspberrySentinel_B.pw[xoffset] < 0.5) {
      FoilControlRaspberrySentinel_B.pw[xoffset] = 0.0;
    }
  }

  /* '<S9>:1:8' pw=pw'; */
  for (i = 0; i < 4; i++) {
    FoilControlRaspberrySentinel_B.y[i << 2] =
      FoilControlRaspberrySentinel_B.pw[i];
    FoilControlRaspberrySentinel_B.y[1 + (i << 2)] =
      FoilControlRaspberrySentinel_B.pw[i + 4];
    FoilControlRaspberrySentinel_B.y[2 + (i << 2)] =
      FoilControlRaspberrySentinel_B.pw[i + 8];
    FoilControlRaspberrySentinel_B.y[3 + (i << 2)] =
      FoilControlRaspberrySentinel_B.pw[i + 12];
  }

  for (i = 0; i < 4; i++) {
    FoilControlRaspberrySentinel_B.pw[i << 2] =
      FoilControlRaspberrySentinel_B.y[i << 2];
    FoilControlRaspberrySentinel_B.pw[1 + (i << 2)] =
      FoilControlRaspberrySentinel_B.y[(i << 2) + 1];
    FoilControlRaspberrySentinel_B.pw[2 + (i << 2)] =
      FoilControlRaspberrySentinel_B.y[(i << 2) + 2];
    FoilControlRaspberrySentinel_B.pw[3 + (i << 2)] =
      FoilControlRaspberrySentinel_B.y[(i << 2) + 3];
  }

  /* End of MATLAB Function: '<Root>/pwm' */

  /* Start for MATLABSystem: '<S4>/Digital Write' incorporates:
   *  Constant: '<S1>/Constant'
   *  Constant: '<S2>/Constant'
   *  Logic: '<Root>/Logical Operator'
   *  MATLABSystem: '<S4>/Digital Write'
   *  RelationalOperator: '<S1>/Compare'
   *  RelationalOperator: '<S2>/Compare'
   *  UnitDelay: '<S3>/Output'
   */
  MW_gpioWrite((uint32_T)FoilControlRaspberryS_PinNumber, (uint8_T)
               ((FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2 >
                 FoilControlRaspberrySentinel_P.Constant_Value_a) &&
                (FoilControlRaspberrySentinel_DW.Output_DSTATE >
                 FoilControlRaspberrySentinel_P.Constant_Value_p)));

  /* MATLAB Function: '<Root>/proud' */
  /* MATLAB Function 'proud': '<S8>:1' */
  /* '<S8>:1:2' i = (max(0, pw-0.5).*(0.455*2))'; */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    if ((0.0 >= FoilControlRaspberrySentinel_B.pw[xoffset] - 0.5) || rtIsNaN
        (FoilControlRaspberrySentinel_B.pw[xoffset] - 0.5)) {
      FoilControlRaspberrySentinel_B.y[xoffset] = 0.0;
    } else {
      FoilControlRaspberrySentinel_B.y[xoffset] =
        FoilControlRaspberrySentinel_B.pw[xoffset] - 0.5;
    }
  }

  for (i = 0; i < 4; i++) {
    FoilControlRaspberrySentinel_B.i[i << 2] =
      FoilControlRaspberrySentinel_B.y[i] * 0.91;
    FoilControlRaspberrySentinel_B.i[1 + (i << 2)] =
      FoilControlRaspberrySentinel_B.y[i + 4] * 0.91;
    FoilControlRaspberrySentinel_B.i[2 + (i << 2)] =
      FoilControlRaspberrySentinel_B.y[i + 8] * 0.91;
    FoilControlRaspberrySentinel_B.i[3 + (i << 2)] =
      FoilControlRaspberrySentinel_B.y[i + 12] * 0.91;
  }

  /* '<S8>:1:3' lim = 0; */
  FoilControlRaspberrySentinel_B.lim = 0.0;

  /* '<S8>:1:4' if sum(sum(abs(i))) < 4 */
  memcpy(&FoilControlRaspberrySentinel_B.y[0],
         &FoilControlRaspberrySentinel_B.i[0], sizeof(real_T) << 4U);
  for (i = 0; i < 4; i++) {
    xoffset = i << 2;
    FoilControlRaspberrySentinel_B.y_m[i] =
      ((FoilControlRaspberrySentinel_B.y[xoffset + 1] +
        FoilControlRaspberrySentinel_B.y[xoffset]) +
       FoilControlRaspberrySentinel_B.y[xoffset + 2]) +
      FoilControlRaspberrySentinel_B.y[xoffset + 3];
  }

  if (((FoilControlRaspberrySentinel_B.y_m[0] +
        FoilControlRaspberrySentinel_B.y_m[1]) +
       FoilControlRaspberrySentinel_B.y_m[2]) +
      FoilControlRaspberrySentinel_B.y_m[3] < 4.0) {
    /* '<S8>:1:5' lim = 1; */
    FoilControlRaspberrySentinel_B.lim = 1.0;
  }

  /* End of MATLAB Function: '<Root>/proud' */

  /* Switch: '<Root>/Switch1' incorporates:
   *  Constant: '<Root>/Constant2'
   */
  if (FoilControlRaspberrySentinel_B.lim != 0.0) {
    memcpy(&FoilControlRaspberrySentinel_B.Switch1[0],
           &FoilControlRaspberrySentinel_B.pw[0], sizeof(real_T) << 4U);
  } else {
    memcpy(&FoilControlRaspberrySentinel_B.Switch1[0],
           &FoilControlRaspberrySentinel_P.Constant2_Value[0], sizeof(real_T) <<
           4U);
  }

  /* End of Switch: '<Root>/Switch1' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&FoilControlRaspberrySentinel_B.Switch1[0],
    &FoilControlRaspberrySentinel_DW.MagManCoils_DSTATE);

  /* Sum: '<S10>/FixPt Sum1' incorporates:
   *  Constant: '<S10>/FixPt Constant'
   *  UnitDelay: '<S3>/Output'
   */
  rtb_FixPtSum1 = (uint8_T)((uint32_T)
    FoilControlRaspberrySentinel_DW.Output_DSTATE +
    FoilControlRaspberrySentinel_P.FixPtConstant_Value);

  /* S-Function "sfcn_getFoilCheck_wrapper" Block: <Root>/MagMan Foil with error */
  sfcn_getFoilCheck_Update_wrapper
    ( &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o1,
     &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o2,
     &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o3,
     &FoilControlRaspberrySentinel_B.MagManFoilwitherror_o4,
     &FoilControlRaspberrySentinel_DW.MagManFoilwitherror_DSTATE);

  /* Update for DiscreteIntegrator: '<S5>/Integrator' incorporates:
   *  Constant: '<Root>/Constant'
   *  Gain: '<S5>/Integral Gain'
   *  Gain: '<S5>/Kb'
   *  Sum: '<S5>/Sum2'
   *  Sum: '<S5>/SumI1'
   *  Sum: '<S5>/SumI2'
   */
  FoilControlRaspberrySentinel_DW.Integrator_DSTATE[0] +=
    ((FoilControlRaspberrySentinel_P.Constant_Value -
      FoilControlRaspberrySentinel_B.X) *
     FoilControlRaspberrySentinel_P.PIDController2DOF1_I +
     (FoilControlRaspberrySentinel_B.Saturate[0] - rtb_Sum_idx_0) *
     FoilControlRaspberrySentinel_P.PIDController2DOF1_Kb) *
    FoilControlRaspberrySentinel_P.Integrator_gainval;

  /* Update for DiscreteIntegrator: '<S5>/Filter' */
  FoilControlRaspberrySentinel_DW.Filter_DSTATE[0] +=
    FoilControlRaspberrySentinel_P.Filter_gainval * rtb_FilterCoefficient_idx_0;

  /* Update for DiscreteIntegrator: '<S5>/Integrator' incorporates:
   *  Constant: '<Root>/Constant1'
   *  Gain: '<S5>/Integral Gain'
   *  Gain: '<S5>/Kb'
   *  Sum: '<S5>/Sum2'
   *  Sum: '<S5>/SumI1'
   *  Sum: '<S5>/SumI2'
   */
  FoilControlRaspberrySentinel_DW.Integrator_DSTATE[1] +=
    ((FoilControlRaspberrySentinel_P.Constant1_Value -
      FoilControlRaspberrySentinel_B.Y) *
     FoilControlRaspberrySentinel_P.PIDController2DOF1_I +
     (FoilControlRaspberrySentinel_B.Saturate[1] - rtb_Sum_idx_1) *
     FoilControlRaspberrySentinel_P.PIDController2DOF1_Kb) *
    FoilControlRaspberrySentinel_P.Integrator_gainval;

  /* Update for DiscreteIntegrator: '<S5>/Filter' */
  FoilControlRaspberrySentinel_DW.Filter_DSTATE[1] +=
    FoilControlRaspberrySentinel_P.Filter_gainval * rtb_FilterCoefficient_idx_1;

  /* Switch: '<S11>/FixPt Switch' */
  if (rtb_FixPtSum1 > FoilControlRaspberrySentinel_P.CounterLimited_uplimit) {
    /* Update for UnitDelay: '<S3>/Output' incorporates:
     *  Constant: '<S11>/Constant'
     */
    FoilControlRaspberrySentinel_DW.Output_DSTATE =
      FoilControlRaspberrySentinel_P.Constant_Value_h;
  } else {
    /* Update for UnitDelay: '<S3>/Output' */
    FoilControlRaspberrySentinel_DW.Output_DSTATE = rtb_FixPtSum1;
  }

  /* End of Switch: '<S11>/FixPt Switch' */

  /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
  sfcn_setPlatform_Update_wrapper(&FoilControlRaspberrySentinel_B.Switch1[0],
    &FoilControlRaspberrySentinel_DW.MagManCoils_DSTATE);

  /* External mode */
  rtExtModeUploadCheckTrigger(1);

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(0, FoilControlRaspberrySentinel_M->Timing.taskTime0);
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.02s, 0.0s] */
    if ((rtmGetTFinal(FoilControlRaspberrySentinel_M)!=-1) &&
        !((rtmGetTFinal(FoilControlRaspberrySentinel_M)-
           FoilControlRaspberrySentinel_M->Timing.taskTime0) >
          FoilControlRaspberrySentinel_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(FoilControlRaspberrySentinel_M, "Simulation finished");
    }

    if (rtmGetStopRequested(FoilControlRaspberrySentinel_M)) {
      rtmSetErrorStatus(FoilControlRaspberrySentinel_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++FoilControlRaspberrySentinel_M->Timing.clockTick0)) {
    ++FoilControlRaspberrySentinel_M->Timing.clockTickH0;
  }

  FoilControlRaspberrySentinel_M->Timing.taskTime0 =
    FoilControlRaspberrySentinel_M->Timing.clockTick0 *
    FoilControlRaspberrySentinel_M->Timing.stepSize0 +
    FoilControlRaspberrySentinel_M->Timing.clockTickH0 *
    FoilControlRaspberrySentinel_M->Timing.stepSize0 * 4294967296.0;
}

/* Model initialize function */
void FoilControlRaspberrySentinel_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)FoilControlRaspberrySentinel_M, 0,
                sizeof(RT_MODEL_FoilControlRaspberry_T));
  rtmSetTFinal(FoilControlRaspberrySentinel_M, -1);
  FoilControlRaspberrySentinel_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  FoilControlRaspberrySentinel_M->Sizes.checksums[0] = (495282541U);
  FoilControlRaspberrySentinel_M->Sizes.checksums[1] = (2055743715U);
  FoilControlRaspberrySentinel_M->Sizes.checksums[2] = (3829557736U);
  FoilControlRaspberrySentinel_M->Sizes.checksums[3] = (3329260777U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[8];
    FoilControlRaspberrySentinel_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    systemRan[5] = &rtAlwaysEnabled;
    systemRan[6] = &rtAlwaysEnabled;
    systemRan[7] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(FoilControlRaspberrySentinel_M->extModeInfo,
      &FoilControlRaspberrySentinel_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(FoilControlRaspberrySentinel_M->extModeInfo,
                        FoilControlRaspberrySentinel_M->Sizes.checksums);
    rteiSetTPtr(FoilControlRaspberrySentinel_M->extModeInfo, rtmGetTPtr
                (FoilControlRaspberrySentinel_M));
  }

  /* block I/O */
  (void) memset(((void *) &FoilControlRaspberrySentinel_B), 0,
                sizeof(B_FoilControlRaspberrySentine_T));

  /* states (dwork) */
  (void) memset((void *)&FoilControlRaspberrySentinel_DW, 0,
                sizeof(DW_FoilControlRaspberrySentin_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    FoilControlRaspberrySentinel_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 15;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* Start for MATLABSystem: '<S4>/Digital Write' */
  FoilControlRaspberrySentinel_DW.obj.isInitialized = 0;
  FoilControlRaspberrySentinel_DW.objisempty = true;
  FoilControlRaspberrySentinel_DW.obj.isInitialized = 1;
  MW_gpioInit((uint32_T)FoilControlRaspberryS_PinNumber, true);

  /* S-Function Block: <Root>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        FoilControlRaspberrySentinel_DW.MagManFoilwitherror_DSTATE = initVector
          [0];
      }
    }
  }

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Integrator' */
  FoilControlRaspberrySentinel_DW.Integrator_DSTATE[0] =
    FoilControlRaspberrySentinel_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Filter' */
  FoilControlRaspberrySentinel_DW.Filter_DSTATE[0] =
    FoilControlRaspberrySentinel_P.Filter_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Integrator' */
  FoilControlRaspberrySentinel_DW.Integrator_DSTATE[1] =
    FoilControlRaspberrySentinel_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S5>/Filter' */
  FoilControlRaspberrySentinel_DW.Filter_DSTATE[1] =
    FoilControlRaspberrySentinel_P.Filter_IC;

  /* InitializeConditions for UnitDelay: '<S3>/Output' */
  FoilControlRaspberrySentinel_DW.Output_DSTATE =
    FoilControlRaspberrySentinel_P.Output_InitialCondition;

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        FoilControlRaspberrySentinel_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }
}

/* Model terminate function */
void FoilControlRaspberrySentinel_terminate(void)
{
  /* Start for MATLABSystem: '<S4>/Digital Write' incorporates:
   *  Terminate for MATLABSystem: '<S4>/Digital Write'
   */
  if (FoilControlRaspberrySentinel_DW.obj.isInitialized == 1) {
    FoilControlRaspberrySentinel_DW.obj.isInitialized = 2;
    MW_gpioTerminate((uint32_T)FoilControlRaspberryS_PinNumber);
  }

  /* End of Start for MATLABSystem: '<S4>/Digital Write' */
}
