/*
 * FoilControlRaspberrySentinel.h
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "FoilControlRaspberrySentinel".
 *
 * Model version              : 1.24
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Wed Nov 23 14:06:32 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_FoilControlRaspberrySentinel_h_
#define RTW_HEADER_FoilControlRaspberrySentinel_h_
#include <math.h>
#include <string.h>
#include <float.h>
#include <stddef.h>
#ifndef FoilControlRaspberrySentinel_COMMON_INCLUDES_
# define FoilControlRaspberrySentinel_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_extmode.h"
#include "sysran_types.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "dt_info.h"
#include "ext_work.h"
#include "MW_gpio.h"
#endif                                 /* FoilControlRaspberrySentinel_COMMON_INCLUDES_ */

#include "FoilControlRaspberrySentinel_types.h"

/* Shared type includes */
#include "multiword_types.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetFinalTime
# define rtmGetFinalTime(rtm)          ((rtm)->Timing.tFinal)
#endif

#ifndef rtmGetRTWExtModeInfo
# define rtmGetRTWExtModeInfo(rtm)     ((rtm)->extModeInfo)
#endif

#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
# define rtmSetStopRequested(rtm, val) ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
# define rtmGetStopRequestedPtr(rtm)   (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  ((rtm)->Timing.taskTime0)
#endif

#ifndef rtmGetTFinal
# define rtmGetTFinal(rtm)             ((rtm)->Timing.tFinal)
#endif

/* Block signals (auto storage) */
typedef struct {
  real_T MagManFoilwitherror_o1;       /* '<Root>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o2;       /* '<Root>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o3;       /* '<Root>/MagMan Foil with error' */
  real_T Saturate[2];                  /* '<S5>/Saturate' */
  real_T MagManlinearization_o1[16];   /* '<S7>/MagMan linearization' */
  real_T MagManlinearization_o2;       /* '<S7>/MagMan linearization' */
  real_T Switch1[16];                  /* '<Root>/Switch1' */
  real_T pw[16];                       /* '<Root>/pwm' */
  real_T Ao[32];                       /* '<S7>/Embedded MATLAB Function' */
  real_T y[16];
  real_T i[16];                        /* '<Root>/proud' */
  real_T y_m[4];
  real_T X;                            /* '<Root>/ht1' */
  real_T Y;                            /* '<Root>/ht1' */
  real_T lim;                          /* '<Root>/proud' */
  int32_T MagManFoilwitherror_o4;      /* '<Root>/MagMan Foil with error' */
} B_FoilControlRaspberrySentine_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T MagManFoilwitherror_DSTATE;   /* '<Root>/MagMan Foil with error' */
  real_T Integrator_DSTATE[2];         /* '<S5>/Integrator' */
  real_T Filter_DSTATE[2];             /* '<S5>/Filter' */
  real_T MagManCoils_DSTATE;           /* '<Root>/MagMan Coils' */
  struct {
    void *LoggedData[3];
  } Scope1_PWORK;                      /* '<Root>/Scope1' */

  struct {
    void *LoggedData[2];
  } Scope2_PWORK;                      /* '<Root>/Scope2' */

  struct {
    void *LoggedData[2];
  } Scope3_PWORK;                      /* '<Root>/Scope3' */

  void *DigitalWrite_PWORK;            /* '<S4>/Digital Write' */
  codertarget_linux_blocks_Digi_T obj; /* '<S4>/Digital Write' */
  uint8_T Output_DSTATE;               /* '<S3>/Output' */
  boolean_T objisempty;                /* '<S4>/Digital Write' */
} DW_FoilControlRaspberrySentin_T;

/* Parameters (auto storage) */
struct P_FoilControlRaspberrySentine_T_ {
  real_T km4pi[9];                     /* Variable: km4pi
                                        * Referenced by: '<Root>/Sentinel Calibration matrix'
                                        */
  real_T PIDController2DOF1_D;         /* Mask Parameter: PIDController2DOF1_D
                                        * Referenced by: '<S5>/Derivative Gain'
                                        */
  real_T PIDController2DOF1_I;         /* Mask Parameter: PIDController2DOF1_I
                                        * Referenced by: '<S5>/Integral Gain'
                                        */
  real_T PIDController2DOF1_Kb;        /* Mask Parameter: PIDController2DOF1_Kb
                                        * Referenced by: '<S5>/Kb'
                                        */
  real_T PIDController2DOF1_LowerSaturat;/* Mask Parameter: PIDController2DOF1_LowerSaturat
                                          * Referenced by: '<S5>/Saturate'
                                          */
  real_T PIDController2DOF1_N;         /* Mask Parameter: PIDController2DOF1_N
                                        * Referenced by: '<S5>/Filter Coefficient'
                                        */
  real_T PIDController2DOF1_P;         /* Mask Parameter: PIDController2DOF1_P
                                        * Referenced by: '<S5>/Proportional Gain'
                                        */
  real_T PIDController2DOF1_UpperSaturat;/* Mask Parameter: PIDController2DOF1_UpperSaturat
                                          * Referenced by: '<S5>/Saturate'
                                          */
  real_T PIDController2DOF1_b;         /* Mask Parameter: PIDController2DOF1_b
                                        * Referenced by: '<S5>/Setpoint Weighting (Proportional)'
                                        */
  real_T PIDController2DOF1_c;         /* Mask Parameter: PIDController2DOF1_c
                                        * Referenced by: '<S5>/Setpoint Weighting (Derivative)'
                                        */
  uint8_T CounterLimited_uplimit;      /* Mask Parameter: CounterLimited_uplimit
                                        * Referenced by: '<S11>/FixPt Switch'
                                        */
  real_T Constant2_Value[16];          /* Expression: [0,0,0,0;0,0,0,0;0,0,0,0;0,0,0,0]
                                        * Referenced by: '<Root>/Constant2'
                                        */
  real_T Constant_Value;               /* Expression: 2.5
                                        * Referenced by: '<Root>/Constant'
                                        */
  real_T Constant1_Value;              /* Expression: 2.5
                                        * Referenced by: '<Root>/Constant1'
                                        */
  real_T Integrator_gainval;           /* Computed Parameter: Integrator_gainval
                                        * Referenced by: '<S5>/Integrator'
                                        */
  real_T Integrator_IC;                /* Expression: InitialConditionForIntegrator
                                        * Referenced by: '<S5>/Integrator'
                                        */
  real_T Filter_gainval;               /* Computed Parameter: Filter_gainval
                                        * Referenced by: '<S5>/Filter'
                                        */
  real_T Filter_IC;                    /* Expression: InitialConditionForFilter
                                        * Referenced by: '<S5>/Filter'
                                        */
  real_T Constant_Value_a;             /* Expression: 0
                                        * Referenced by: '<S2>/Constant'
                                        */
  uint8_T Constant_Value_h;            /* Computed Parameter: Constant_Value_h
                                        * Referenced by: '<S11>/Constant'
                                        */
  uint8_T Output_InitialCondition;     /* Computed Parameter: Output_InitialCondition
                                        * Referenced by: '<S3>/Output'
                                        */
  uint8_T Constant_Value_p;            /* Computed Parameter: Constant_Value_p
                                        * Referenced by: '<S1>/Constant'
                                        */
  uint8_T FixPtConstant_Value;         /* Computed Parameter: FixPtConstant_Value
                                        * Referenced by: '<S10>/FixPt Constant'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_FoilControlRaspberryS_T {
  const char_T *errorStatus;
  RTWExtModeInfo *extModeInfo;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    uint32_T checksums[4];
  } Sizes;

  /*
   * SpecialInfo:
   * The following substructure contains special information
   * related to other components that are dependent on RTW.
   */
  struct {
    const void *mappingInfo;
  } SpecialInfo;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    time_T taskTime0;
    uint32_T clockTick0;
    uint32_T clockTickH0;
    time_T stepSize0;
    time_T tFinal;
    boolean_T stopRequestedFlag;
  } Timing;
};

/* Block parameters (auto storage) */
extern P_FoilControlRaspberrySentine_T FoilControlRaspberrySentinel_P;

/* Block signals (auto storage) */
extern B_FoilControlRaspberrySentine_T FoilControlRaspberrySentinel_B;

/* Block states (auto storage) */
extern DW_FoilControlRaspberrySentin_T FoilControlRaspberrySentinel_DW;

/* Model entry point functions */
extern void FoilControlRaspberrySentinel_initialize(void);
extern void FoilControlRaspberrySentinel_step(void);
extern void FoilControlRaspberrySentinel_terminate(void);

/* Real-time Model object */
extern RT_MODEL_FoilControlRaspberry_T *const FoilControlRaspberrySentinel_M;

/*-
 * These blocks were eliminated from the model due to optimizations:
 *
 * Block '<S3>/Data Type Propagation' : Unused code path elimination
 * Block '<S10>/FixPt Data Type Duplicate' : Unused code path elimination
 * Block '<S11>/FixPt Data Type Duplicate1' : Unused code path elimination
 */

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'FoilControlRaspberrySentinel'
 * '<S1>'   : 'FoilControlRaspberrySentinel/Compare To Zero'
 * '<S2>'   : 'FoilControlRaspberrySentinel/Compare To Zero1'
 * '<S3>'   : 'FoilControlRaspberrySentinel/Counter Limited'
 * '<S4>'   : 'FoilControlRaspberrySentinel/GPIO Write'
 * '<S5>'   : 'FoilControlRaspberrySentinel/PID Controller (2DOF)1'
 * '<S6>'   : 'FoilControlRaspberrySentinel/ht1'
 * '<S7>'   : 'FoilControlRaspberrySentinel/linearization'
 * '<S8>'   : 'FoilControlRaspberrySentinel/proud'
 * '<S9>'   : 'FoilControlRaspberrySentinel/pwm'
 * '<S10>'  : 'FoilControlRaspberrySentinel/Counter Limited/Increment Real World'
 * '<S11>'  : 'FoilControlRaspberrySentinel/Counter Limited/Wrap To Zero'
 * '<S12>'  : 'FoilControlRaspberrySentinel/linearization/Embedded MATLAB Function'
 */
#endif                                 /* RTW_HEADER_FoilControlRaspberrySentinel_h_ */
