/*
 * VisionControl.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "VisionControl".
 *
 * Model version              : 1.14
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Thu Dec 01 15:18:37 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "VisionControl.h"
#include "VisionControl_private.h"
#include "VisionControl_dt.h"

/* Block signals (auto storage) */
B_VisionControl_T VisionControl_B;

/* Block states (auto storage) */
DW_VisionControl_T VisionControl_DW;

/* Real-time model */
RT_MODEL_VisionControl_T VisionControl_M_;
RT_MODEL_VisionControl_T *const VisionControl_M = &VisionControl_M_;
real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Model step function */
void VisionControl_step(void)
{
  int32_T i;
  int32_T xoffset;
  real_T rtb_lim;
  real_T rtb_FilterCoefficient_idx_0;
  real_T rtb_FilterCoefficient_idx_1;
  real_T rtb_Sum_idx_0;
  real_T rtb_Sum_idx_1;

  /* S-Function (sfcn_posread_shm): '<S1>/Shared memory camera position' */
  sfcn_posread_shm_Outputs_wrapper
    ( &VisionControl_B.Sharedmemorycameraposition_o1,
     &VisionControl_B.Sharedmemorycameraposition_o2,
     &VisionControl_DW.Sharedmemorycameraposition_DSTA);

  /* DataTypeConversion: '<S1>/Data Type Conversion1' */
  VisionControl_B.DataTypeConversion1 =
    VisionControl_B.Sharedmemorycameraposition_o1;

  /* DataTypeConversion: '<S1>/Data Type Conversion2' */
  VisionControl_B.DataTypeConversion2 =
    VisionControl_B.Sharedmemorycameraposition_o2;

  /* MATLAB Function: '<Root>/Position transformation' incorporates:
   *  Constant: '<Root>/Raspicam Calibration matrix'
   */
  /* MATLAB Function 'Position transformation': '<S6>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S6>:1:4' xa = [x,y]; */
  /* '<S6>:1:5' H = km4(:); */
  /* '<S6>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S6>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S6>:1:9' X=out(1); */
  VisionControl_B.X = ((VisionControl_B.DataTypeConversion1 *
                        VisionControl_P.km4piCam[0] +
                        VisionControl_B.DataTypeConversion2 *
                        VisionControl_P.km4piCam[1]) + VisionControl_P.km4piCam
                       [2]) / ((VisionControl_B.DataTypeConversion1 *
    VisionControl_P.km4piCam[6] + VisionControl_B.DataTypeConversion2 *
    VisionControl_P.km4piCam[7]) + VisionControl_P.km4piCam[8]);

  /* '<S6>:1:10' Y=out(2); */
  VisionControl_B.Y = ((VisionControl_B.DataTypeConversion1 *
                        VisionControl_P.km4piCam[3] +
                        VisionControl_B.DataTypeConversion2 *
                        VisionControl_P.km4piCam[4]) + VisionControl_P.km4piCam
                       [5]) / ((VisionControl_B.DataTypeConversion1 *
    VisionControl_P.km4piCam[6] + VisionControl_B.DataTypeConversion2 *
    VisionControl_P.km4piCam[7]) + VisionControl_P.km4piCam[8]);

  /* MATLAB Function: '<S3>/Embedded MATLAB Function' */
  /* MATLAB Function 'Linearization/Embedded MATLAB Function': '<S7>:1' */
  /* '<S7>:1:2' Ao=zeros(2,16); */
  memset(&VisionControl_B.Ao[0], 0, sizeof(real_T) << 5U);

  /* '<S7>:1:4' for iy=1:4 */
  for (xoffset = 0; xoffset < 4; xoffset++) {
    /* '<S7>:1:5' for ix=1:4 */
    for (i = 0; i < 4; i++) {
      /* '<S7>:1:6' [cFx, cFy] = fForce(x, y, ix, iy); */
      /* '<S7>:1:14' d=dist(x,y, ix, iy); */
      /* '<S7>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
      rtb_lim = VisionControl_B.X - (1.0 + (real_T)i);
      rtb_Sum_idx_1 = VisionControl_B.Y - (1.0 + (real_T)xoffset);
      rtb_lim = sqrt(rtb_lim * rtb_lim + rtb_Sum_idx_1 * rtb_Sum_idx_1);

      /* '<S7>:1:15' if d~=0 */
      if (rtb_lim != 0.0) {
        /* '<S7>:1:16' F=gForce(d); */
        /* '<S7>:1:43' a = 622.06; */
        /* '<S7>:1:44' b = 9.5032; */
        /* '<S7>:1:45' c = 3.1884; */
        /* '<S7>:1:46' F = x.*a./(b.*x.^2+ c).^3; */
        rtb_lim = rtb_lim * 622.06 / rt_powd_snf(rtb_lim * rtb_lim * 9.5032 +
          3.1884, 3.0);

        /* '<S7>:1:17' Fv=F*vector(x,y,ix,iy); */
        /* '<S7>:1:32' vx=ix-x; */
        rtb_Sum_idx_1 = (1.0 + (real_T)i) - VisionControl_B.X;

        /* '<S7>:1:33' vy=iy-y; */
        rtb_FilterCoefficient_idx_0 = (1.0 + (real_T)xoffset) -
          VisionControl_B.Y;

        /* '<S7>:1:35' if(vx==0 && vy ==0) */
        if ((rtb_Sum_idx_1 == 0.0) && (rtb_FilterCoefficient_idx_0 == 0.0)) {
          /* '<S7>:1:36' v=[0 0]; */
          rtb_Sum_idx_0 = 0.0;
          rtb_Sum_idx_1 = 0.0;
        } else {
          /* '<S7>:1:37' else */
          /* '<S7>:1:38' v = [vx vy]/dist(vx, vy, 0 ,0); */
          /* '<S7>:1:28' d=sqrt((x-ix).^2+(y-iy).^2); */
          rtb_FilterCoefficient_idx_1 = sqrt(rtb_Sum_idx_1 * rtb_Sum_idx_1 +
            rtb_FilterCoefficient_idx_0 * rtb_FilterCoefficient_idx_0);
          rtb_Sum_idx_0 = rtb_Sum_idx_1 / rtb_FilterCoefficient_idx_1;
          rtb_Sum_idx_1 = rtb_FilterCoefficient_idx_0 /
            rtb_FilterCoefficient_idx_1;
        }

        rtb_Sum_idx_0 *= rtb_lim;
        rtb_Sum_idx_1 *= rtb_lim;

        /* '<S7>:1:18' Fx=Fv(1); */
        rtb_lim = rtb_Sum_idx_0;

        /* '<S7>:1:19' Fy=Fv(2); */
      } else {
        /* '<S7>:1:20' else */
        /* '<S7>:1:21' Fx=0; */
        rtb_lim = 0.0;

        /* '<S7>:1:22' Fy=0; */
        rtb_Sum_idx_1 = 0.0;
      }

      /* '<S7>:1:7' Ao(1,(iy-1)*4+ix) = cFx; */
      VisionControl_B.Ao[((xoffset << 2) + i) << 1] = rtb_lim;

      /* '<S7>:1:8' Ao(2,(iy-1)*4+ix) = cFy; */
      VisionControl_B.Ao[1 + (((xoffset << 2) + i) << 1)] = rtb_Sum_idx_1;
    }
  }

  /* End of MATLAB Function: '<S3>/Embedded MATLAB Function' */

  /* Gain: '<S4>/Filter Coefficient' incorporates:
   *  Constant: '<Root>/Referece position'
   *  DiscreteIntegrator: '<S4>/Filter'
   *  Gain: '<S4>/Derivative Gain'
   *  Gain: '<S4>/Setpoint Weighting (Derivative)'
   *  Sum: '<S4>/Sum3'
   *  Sum: '<S4>/SumD'
   */
  rtb_FilterCoefficient_idx_0 = ((VisionControl_P.PIDController2DOF1_c *
    VisionControl_P.Refereceposition_Value[0] - VisionControl_B.X) *
    VisionControl_P.PIDController2DOF1_D - VisionControl_DW.Filter_DSTATE[0]) *
    VisionControl_P.PIDController2DOF1_N;
  rtb_FilterCoefficient_idx_1 = ((VisionControl_P.PIDController2DOF1_c *
    VisionControl_P.Refereceposition_Value[1] - VisionControl_B.Y) *
    VisionControl_P.PIDController2DOF1_D - VisionControl_DW.Filter_DSTATE[1]) *
    VisionControl_P.PIDController2DOF1_N;

  /* Sum: '<S4>/Sum' incorporates:
   *  Constant: '<Root>/Referece position'
   *  DiscreteIntegrator: '<S4>/Integrator'
   *  Gain: '<S4>/Proportional Gain'
   *  Gain: '<S4>/Setpoint Weighting (Proportional)'
   *  Sum: '<S4>/Sum1'
   */
  rtb_Sum_idx_0 = ((VisionControl_P.PIDController2DOF1_b *
                    VisionControl_P.Refereceposition_Value[0] -
                    VisionControl_B.X) * VisionControl_P.PIDController2DOF1_P +
                   VisionControl_DW.Integrator_DSTATE[0]) +
    rtb_FilterCoefficient_idx_0;
  rtb_Sum_idx_1 = ((VisionControl_P.PIDController2DOF1_b *
                    VisionControl_P.Refereceposition_Value[1] -
                    VisionControl_B.Y) * VisionControl_P.PIDController2DOF1_P +
                   VisionControl_DW.Integrator_DSTATE[1]) +
    rtb_FilterCoefficient_idx_1;

  /* Saturate: '<S4>/Saturate' */
  if (rtb_Sum_idx_0 > VisionControl_P.PIDController2DOF1_UpperSaturat) {
    VisionControl_B.Saturate[0] =
      VisionControl_P.PIDController2DOF1_UpperSaturat;
  } else if (rtb_Sum_idx_0 < VisionControl_P.PIDController2DOF1_LowerSaturat) {
    VisionControl_B.Saturate[0] =
      VisionControl_P.PIDController2DOF1_LowerSaturat;
  } else {
    VisionControl_B.Saturate[0] = rtb_Sum_idx_0;
  }

  if (rtb_Sum_idx_1 > VisionControl_P.PIDController2DOF1_UpperSaturat) {
    VisionControl_B.Saturate[1] =
      VisionControl_P.PIDController2DOF1_UpperSaturat;
  } else if (rtb_Sum_idx_1 < VisionControl_P.PIDController2DOF1_LowerSaturat) {
    VisionControl_B.Saturate[1] =
      VisionControl_P.PIDController2DOF1_LowerSaturat;
  } else {
    VisionControl_B.Saturate[1] = rtb_Sum_idx_1;
  }

  /* End of Saturate: '<S4>/Saturate' */

  /* S-Function (cvxfasd): '<S3>/MagMan linearization' */
  cvxfasd_Outputs_wrapper(&VisionControl_B.Ao[0], &VisionControl_B.Saturate[0],
    &VisionControl_B.Saturate[1], &VisionControl_B.MagManlinearization_o1[0],
    &VisionControl_B.MagManlinearization_o2 );

  /* MATLAB Function: '<Root>/PWM calculation' */
  /* MATLAB Function 'PWM calculation': '<S5>:1' */
  /*  conversion from scaling factor to duty cycle of PWM */
  /* '<S5>:1:3' x = max(0, min(1,x) ); */
  /*  limits */
  /* '<S5>:1:4' i = 0.18515*x + 0.069587*x.^3 + 0.19285*x.^(1/3); */
  /*  ratio to current conversion */
  /* '<S5>:1:5' pw = i/0.455/2; */
  /* '<S5>:1:6' pw(pw>0.05) = pw(pw>0.05) + 0.5; */
  /* '<S5>:1:7' pw(pw<0.5) = 0; */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    if ((1.0 <= VisionControl_B.MagManlinearization_o1[xoffset]) || rtIsNaN
        (VisionControl_B.MagManlinearization_o1[xoffset])) {
      rtb_lim = 1.0;
    } else {
      rtb_lim = VisionControl_B.MagManlinearization_o1[xoffset];
    }

    if ((0.0 >= rtb_lim) || rtIsNaN(rtb_lim)) {
      VisionControl_B.pw[xoffset] = 0.0;
    } else {
      VisionControl_B.pw[xoffset] = rtb_lim;
    }

    VisionControl_B.pw[xoffset] = ((0.18515 * VisionControl_B.pw[xoffset] +
      0.069587 * rt_powd_snf(VisionControl_B.pw[xoffset], 3.0)) + 0.19285 *
      rt_powd_snf(VisionControl_B.pw[xoffset], 0.33333333333333331)) / 0.455 /
      2.0;
    if (VisionControl_B.pw[xoffset] > 0.05) {
      VisionControl_B.pw[xoffset] += 0.5;
    }

    if (VisionControl_B.pw[xoffset] < 0.5) {
      VisionControl_B.pw[xoffset] = 0.0;
    }
  }

  /* '<S5>:1:8' pw=pw'; */
  for (i = 0; i < 4; i++) {
    VisionControl_B.y[i << 2] = VisionControl_B.pw[i];
    VisionControl_B.y[1 + (i << 2)] = VisionControl_B.pw[i + 4];
    VisionControl_B.y[2 + (i << 2)] = VisionControl_B.pw[i + 8];
    VisionControl_B.y[3 + (i << 2)] = VisionControl_B.pw[i + 12];
  }

  for (i = 0; i < 4; i++) {
    VisionControl_B.pw[i << 2] = VisionControl_B.y[i << 2];
    VisionControl_B.pw[1 + (i << 2)] = VisionControl_B.y[(i << 2) + 1];
    VisionControl_B.pw[2 + (i << 2)] = VisionControl_B.y[(i << 2) + 2];
    VisionControl_B.pw[3 + (i << 2)] = VisionControl_B.y[(i << 2) + 3];
  }

  /* End of MATLAB Function: '<Root>/PWM calculation' */

  /* MATLAB Function: '<Root>/Current' */
  /* MATLAB Function 'Current': '<S2>:1' */
  /* '<S2>:1:2' i = max(0, pw-0.5).*(0.455*2); */
  for (xoffset = 0; xoffset < 16; xoffset++) {
    if ((0.0 >= VisionControl_B.pw[xoffset] - 0.5) || rtIsNaN
        (VisionControl_B.pw[xoffset] - 0.5)) {
      VisionControl_B.y[xoffset] = 0.0;
    } else {
      VisionControl_B.y[xoffset] = VisionControl_B.pw[xoffset] - 0.5;
    }
  }

  /* '<S2>:1:3' i=i'; */
  for (i = 0; i < 4; i++) {
    VisionControl_B.i[i << 2] = VisionControl_B.y[i] * 0.91;
    VisionControl_B.i[1 + (i << 2)] = VisionControl_B.y[i + 4] * 0.91;
    VisionControl_B.i[2 + (i << 2)] = VisionControl_B.y[i + 8] * 0.91;
    VisionControl_B.i[3 + (i << 2)] = VisionControl_B.y[i + 12] * 0.91;
  }

  /* '<S2>:1:4' lim = 0; */
  rtb_lim = 0.0;

  /* '<S2>:1:5' if sum(sum(abs(i))) < 4 */
  memcpy(&VisionControl_B.y[0], &VisionControl_B.i[0], sizeof(real_T) << 4U);
  for (i = 0; i < 4; i++) {
    xoffset = i << 2;
    VisionControl_B.y_m[i] = ((VisionControl_B.y[xoffset + 1] +
      VisionControl_B.y[xoffset]) + VisionControl_B.y[xoffset + 2]) +
      VisionControl_B.y[xoffset + 3];
  }

  if (((VisionControl_B.y_m[0] + VisionControl_B.y_m[1]) + VisionControl_B.y_m[2])
      + VisionControl_B.y_m[3] < 4.0) {
    /* '<S2>:1:6' lim = 1; */
    rtb_lim = 1.0;
  }

  /* End of MATLAB Function: '<Root>/Current' */

  /* Switch: '<Root>/Safety switch' */
  for (i = 0; i < 16; i++) {
    if (rtb_lim != 0.0) {
      VisionControl_B.Safetyswitch[i] = VisionControl_B.pw[i];
    } else {
      VisionControl_B.Safetyswitch[i] = 0.0;
    }
  }

  /* End of Switch: '<Root>/Safety switch' */

  /* S-Function (sfcn_setPlatform): '<Root>/MagMan Coils' */
  sfcn_setPlatform_Outputs_wrapper(&VisionControl_B.Safetyswitch[0],
    &VisionControl_DW.MagManCoils_DSTATE);

  /* S-Function "sfcn_posread_shm_wrapper" Block: <S1>/Shared memory camera position */
  sfcn_posread_shm_Update_wrapper
    ( &VisionControl_B.Sharedmemorycameraposition_o1,
     &VisionControl_B.Sharedmemorycameraposition_o2,
     &VisionControl_DW.Sharedmemorycameraposition_DSTA);

  /* Update for DiscreteIntegrator: '<S4>/Integrator' incorporates:
   *  Constant: '<Root>/Referece position'
   *  Gain: '<S4>/Integral Gain'
   *  Gain: '<S4>/Kb'
   *  Sum: '<S4>/Sum2'
   *  Sum: '<S4>/SumI1'
   *  Sum: '<S4>/SumI2'
   */
  VisionControl_DW.Integrator_DSTATE[0] +=
    ((VisionControl_P.Refereceposition_Value[0] - VisionControl_B.X) *
     VisionControl_P.PIDController2DOF1_I + (VisionControl_B.Saturate[0] -
      rtb_Sum_idx_0) * VisionControl_P.PIDController2DOF1_Kb) *
    VisionControl_P.Integrator_gainval;

  /* Update for DiscreteIntegrator: '<S4>/Filter' */
  VisionControl_DW.Filter_DSTATE[0] += VisionControl_P.Filter_gainval *
    rtb_FilterCoefficient_idx_0;

  /* Update for DiscreteIntegrator: '<S4>/Integrator' incorporates:
   *  Constant: '<Root>/Referece position'
   *  Gain: '<S4>/Integral Gain'
   *  Gain: '<S4>/Kb'
   *  Sum: '<S4>/Sum2'
   *  Sum: '<S4>/SumI1'
   *  Sum: '<S4>/SumI2'
   */
  VisionControl_DW.Integrator_DSTATE[1] +=
    ((VisionControl_P.Refereceposition_Value[1] - VisionControl_B.Y) *
     VisionControl_P.PIDController2DOF1_I + (VisionControl_B.Saturate[1] -
      rtb_Sum_idx_1) * VisionControl_P.PIDController2DOF1_Kb) *
    VisionControl_P.Integrator_gainval;

  /* Update for DiscreteIntegrator: '<S4>/Filter' */
  VisionControl_DW.Filter_DSTATE[1] += VisionControl_P.Filter_gainval *
    rtb_FilterCoefficient_idx_1;

  /* S-Function "sfcn_setPlatform_wrapper" Block: <Root>/MagMan Coils */
  sfcn_setPlatform_Update_wrapper(&VisionControl_B.Safetyswitch[0],
    &VisionControl_DW.MagManCoils_DSTATE);

  /* External mode */
  rtExtModeUploadCheckTrigger(1);

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(0, VisionControl_M->Timing.taskTime0);
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.02s, 0.0s] */
    if ((rtmGetTFinal(VisionControl_M)!=-1) &&
        !((rtmGetTFinal(VisionControl_M)-VisionControl_M->Timing.taskTime0) >
          VisionControl_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(VisionControl_M, "Simulation finished");
    }

    if (rtmGetStopRequested(VisionControl_M)) {
      rtmSetErrorStatus(VisionControl_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++VisionControl_M->Timing.clockTick0)) {
    ++VisionControl_M->Timing.clockTickH0;
  }

  VisionControl_M->Timing.taskTime0 = VisionControl_M->Timing.clockTick0 *
    VisionControl_M->Timing.stepSize0 + VisionControl_M->Timing.clockTickH0 *
    VisionControl_M->Timing.stepSize0 * 4294967296.0;
}

/* Model initialize function */
void VisionControl_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)VisionControl_M, 0,
                sizeof(RT_MODEL_VisionControl_T));
  rtmSetTFinal(VisionControl_M, -1);
  VisionControl_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  VisionControl_M->Sizes.checksums[0] = (388049967U);
  VisionControl_M->Sizes.checksums[1] = (3898533790U);
  VisionControl_M->Sizes.checksums[2] = (952379559U);
  VisionControl_M->Sizes.checksums[3] = (2438367565U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[5];
    VisionControl_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(VisionControl_M->extModeInfo,
      &VisionControl_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(VisionControl_M->extModeInfo,
                        VisionControl_M->Sizes.checksums);
    rteiSetTPtr(VisionControl_M->extModeInfo, rtmGetTPtr(VisionControl_M));
  }

  /* block I/O */
  (void) memset(((void *) &VisionControl_B), 0,
                sizeof(B_VisionControl_T));

  /* states (dwork) */
  (void) memset((void *)&VisionControl_DW, 0,
                sizeof(DW_VisionControl_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    VisionControl_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* S-Function Block: <S1>/Shared memory camera position */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        VisionControl_DW.Sharedmemorycameraposition_DSTA = initVector[0];
      }
    }
  }

  /* InitializeConditions for DiscreteIntegrator: '<S4>/Integrator' */
  VisionControl_DW.Integrator_DSTATE[0] = VisionControl_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S4>/Filter' */
  VisionControl_DW.Filter_DSTATE[0] = VisionControl_P.Filter_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S4>/Integrator' */
  VisionControl_DW.Integrator_DSTATE[1] = VisionControl_P.Integrator_IC;

  /* InitializeConditions for DiscreteIntegrator: '<S4>/Filter' */
  VisionControl_DW.Filter_DSTATE[1] = VisionControl_P.Filter_IC;

  /* S-Function Block: <Root>/MagMan Coils */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        VisionControl_DW.MagManCoils_DSTATE = initVector[0];
      }
    }
  }
}

/* Model terminate function */
void VisionControl_terminate(void)
{
  /* (no terminate code required) */
}
