/*
 * VisionControl.h
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "VisionControl".
 *
 * Model version              : 1.14
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Thu Dec 01 15:18:37 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_VisionControl_h_
#define RTW_HEADER_VisionControl_h_
#include <math.h>
#include <string.h>
#include <float.h>
#include <stddef.h>
#ifndef VisionControl_COMMON_INCLUDES_
# define VisionControl_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_extmode.h"
#include "sysran_types.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "dt_info.h"
#include "ext_work.h"
#endif                                 /* VisionControl_COMMON_INCLUDES_ */

#include "VisionControl_types.h"

/* Shared type includes */
#include "multiword_types.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetFinalTime
# define rtmGetFinalTime(rtm)          ((rtm)->Timing.tFinal)
#endif

#ifndef rtmGetRTWExtModeInfo
# define rtmGetRTWExtModeInfo(rtm)     ((rtm)->extModeInfo)
#endif

#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
# define rtmSetStopRequested(rtm, val) ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
# define rtmGetStopRequestedPtr(rtm)   (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  ((rtm)->Timing.taskTime0)
#endif

#ifndef rtmGetTFinal
# define rtmGetTFinal(rtm)             ((rtm)->Timing.tFinal)
#endif

/* Block signals (auto storage) */
typedef struct {
  real_T DataTypeConversion1;          /* '<S1>/Data Type Conversion1' */
  real_T DataTypeConversion2;          /* '<S1>/Data Type Conversion2' */
  real_T Saturate[2];                  /* '<S4>/Saturate' */
  real_T MagManlinearization_o1[16];   /* '<S3>/MagMan linearization' */
  real_T MagManlinearization_o2;       /* '<S3>/MagMan linearization' */
  real_T Safetyswitch[16];             /* '<Root>/Safety switch' */
  real_T X;                            /* '<Root>/Position transformation' */
  real_T Y;                            /* '<Root>/Position transformation' */
  real_T pw[16];                       /* '<Root>/PWM calculation' */
  real_T Ao[32];                       /* '<S3>/Embedded MATLAB Function' */
  real_T y[16];
  real_T i[16];                        /* '<Root>/Current' */
  real_T y_m[4];
  int32_T Sharedmemorycameraposition_o1;/* '<S1>/Shared memory camera position' */
  int32_T Sharedmemorycameraposition_o2;/* '<S1>/Shared memory camera position' */
} B_VisionControl_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T Sharedmemorycameraposition_DSTA;/* '<S1>/Shared memory camera position' */
  real_T Integrator_DSTATE[2];         /* '<S4>/Integrator' */
  real_T Filter_DSTATE[2];             /* '<S4>/Filter' */
  real_T MagManCoils_DSTATE;           /* '<Root>/MagMan Coils' */
  struct {
    void *LoggedData[2];
  } Forcescope_PWORK;                  /* '<Root>/Force scope' */

  struct {
    void *LoggedData[2];
  } Normalizedposition_PWORK;          /* '<Root>/Normalized position' */

  struct {
    void *LoggedData[2];
  } Rawposition_PWORK;                 /* '<Root>/Raw position' */
} DW_VisionControl_T;

/* Parameters (auto storage) */
struct P_VisionControl_T_ {
  real_T km4piCam[9];                  /* Variable: km4piCam
                                        * Referenced by: '<Root>/Raspicam Calibration matrix'
                                        */
  real_T PIDController2DOF1_D;         /* Mask Parameter: PIDController2DOF1_D
                                        * Referenced by: '<S4>/Derivative Gain'
                                        */
  real_T PIDController2DOF1_I;         /* Mask Parameter: PIDController2DOF1_I
                                        * Referenced by: '<S4>/Integral Gain'
                                        */
  real_T PIDController2DOF1_Kb;        /* Mask Parameter: PIDController2DOF1_Kb
                                        * Referenced by: '<S4>/Kb'
                                        */
  real_T PIDController2DOF1_LowerSaturat;/* Mask Parameter: PIDController2DOF1_LowerSaturat
                                          * Referenced by: '<S4>/Saturate'
                                          */
  real_T PIDController2DOF1_N;         /* Mask Parameter: PIDController2DOF1_N
                                        * Referenced by: '<S4>/Filter Coefficient'
                                        */
  real_T PIDController2DOF1_P;         /* Mask Parameter: PIDController2DOF1_P
                                        * Referenced by: '<S4>/Proportional Gain'
                                        */
  real_T PIDController2DOF1_UpperSaturat;/* Mask Parameter: PIDController2DOF1_UpperSaturat
                                          * Referenced by: '<S4>/Saturate'
                                          */
  real_T PIDController2DOF1_b;         /* Mask Parameter: PIDController2DOF1_b
                                        * Referenced by: '<S4>/Setpoint Weighting (Proportional)'
                                        */
  real_T PIDController2DOF1_c;         /* Mask Parameter: PIDController2DOF1_c
                                        * Referenced by: '<S4>/Setpoint Weighting (Derivative)'
                                        */
  real_T Refereceposition_Value[2];    /* Expression: [3.5, 3.5]
                                        * Referenced by: '<Root>/Referece position'
                                        */
  real_T Integrator_gainval;           /* Computed Parameter: Integrator_gainval
                                        * Referenced by: '<S4>/Integrator'
                                        */
  real_T Integrator_IC;                /* Expression: InitialConditionForIntegrator
                                        * Referenced by: '<S4>/Integrator'
                                        */
  real_T Filter_gainval;               /* Computed Parameter: Filter_gainval
                                        * Referenced by: '<S4>/Filter'
                                        */
  real_T Filter_IC;                    /* Expression: InitialConditionForFilter
                                        * Referenced by: '<S4>/Filter'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_VisionControl_T {
  const char_T *errorStatus;
  RTWExtModeInfo *extModeInfo;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    uint32_T checksums[4];
  } Sizes;

  /*
   * SpecialInfo:
   * The following substructure contains special information
   * related to other components that are dependent on RTW.
   */
  struct {
    const void *mappingInfo;
  } SpecialInfo;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    time_T taskTime0;
    uint32_T clockTick0;
    uint32_T clockTickH0;
    time_T stepSize0;
    time_T tFinal;
    boolean_T stopRequestedFlag;
  } Timing;
};

/* Block parameters (auto storage) */
extern P_VisionControl_T VisionControl_P;

/* Block signals (auto storage) */
extern B_VisionControl_T VisionControl_B;

/* Block states (auto storage) */
extern DW_VisionControl_T VisionControl_DW;

/* Model entry point functions */
extern void VisionControl_initialize(void);
extern void VisionControl_step(void);
extern void VisionControl_terminate(void);

/* Real-time Model object */
extern RT_MODEL_VisionControl_T *const VisionControl_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'VisionControl'
 * '<S1>'   : 'VisionControl/Camera position from shared memory'
 * '<S2>'   : 'VisionControl/Current'
 * '<S3>'   : 'VisionControl/Linearization'
 * '<S4>'   : 'VisionControl/PID Controller (2DOF)1'
 * '<S5>'   : 'VisionControl/PWM calculation'
 * '<S6>'   : 'VisionControl/Position transformation'
 * '<S7>'   : 'VisionControl/Linearization/Embedded MATLAB Function'
 */
#endif                                 /* RTW_HEADER_VisionControl_h_ */
