/*
 * VisionTest.c
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "VisionTest".
 *
 * Model version              : 1.4
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Thu Dec 01 17:32:23 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "VisionTest.h"
#include "VisionTest_private.h"
#include "VisionTest_dt.h"

/* Block signals (auto storage) */
B_VisionTest_T VisionTest_B;

/* Block states (auto storage) */
DW_VisionTest_T VisionTest_DW;

/* Real-time model */
RT_MODEL_VisionTest_T VisionTest_M_;
RT_MODEL_VisionTest_T *const VisionTest_M = &VisionTest_M_;

/* Model step function */
void VisionTest_step(void)
{
  real_T out_idx_0;
  real_T out_idx_1;
  real_T rtb_Delay_idx_0;
  real_T rtb_Delay_idx_1;

  /* S-Function (sfcn_getFoilCheck): '<Root>/MagMan Foil with error' */
  sfcn_getFoilCheck_Outputs_wrapper( &VisionTest_B.MagManFoilwitherror_o1,
    &VisionTest_B.MagManFoilwitherror_o2, &VisionTest_B.MagManFoilwitherror_o3,
    &VisionTest_B.MagManFoilwitherror_o4,
    &VisionTest_DW.MagManFoilwitherror_DSTATE);

  /* S-Function (sfcn_posread_shm): '<S1>/Read position' */
  sfcn_posread_shm_Outputs_wrapper( &VisionTest_B.Readposition_o1,
    &VisionTest_B.Readposition_o2, &VisionTest_DW.Readposition_DSTATE);

  /* MATLAB Function: '<Root>/Position transformation' incorporates:
   *  Constant: '<Root>/Raspicam Calibration matrix'
   *  DataTypeConversion: '<S1>/Data Type Conversion1'
   *  DataTypeConversion: '<S1>/Data Type Conversion2'
   */
  /* MATLAB Function 'Position transformation': '<S2>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S2>:1:4' xa = [x,y]; */
  /* '<S2>:1:5' H = km4(:); */
  /* '<S2>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S2>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  /* '<S2>:1:9' X=out(1); */
  VisionTest_B.X = (((real_T)VisionTest_B.Readposition_o1 *
                     VisionTest_P.km4piCam[0] + (real_T)
                     VisionTest_B.Readposition_o2 * VisionTest_P.km4piCam[1]) +
                    VisionTest_P.km4piCam[2]) / (((real_T)
    VisionTest_B.Readposition_o1 * VisionTest_P.km4piCam[6] + (real_T)
    VisionTest_B.Readposition_o2 * VisionTest_P.km4piCam[7]) +
    VisionTest_P.km4piCam[8]);

  /* '<S2>:1:10' Y=out(2); */
  VisionTest_B.Y = (((real_T)VisionTest_B.Readposition_o1 *
                     VisionTest_P.km4piCam[3] + (real_T)
                     VisionTest_B.Readposition_o2 * VisionTest_P.km4piCam[4]) +
                    VisionTest_P.km4piCam[5]) / (((real_T)
    VisionTest_B.Readposition_o1 * VisionTest_P.km4piCam[6] + (real_T)
    VisionTest_B.Readposition_o2 * VisionTest_P.km4piCam[7]) +
    VisionTest_P.km4piCam[8]);

  /* MATLAB Function: '<Root>/Position transformation1' incorporates:
   *  Constant: '<Root>/Sentinel Calibration matrix'
   */
  /* MATLAB Function 'Position transformation1': '<S3>:1' */
  /*  out=km2*[x;y;x^2;y^2;x*y;1]; */
  /* '<S3>:1:4' xa = [x,y]; */
  /* '<S3>:1:5' H = km4(:); */
  /* '<S3>:1:6' xa = [xa,ones(size(xa,1),1)]; */
  /*  homogeneous coordinates */
  /* '<S3>:1:7' out = [ (xa*H(1:3))./(xa*H(7:9)), (xa*H(4:6))./(xa*H(7:9)) ]; */
  out_idx_0 = ((VisionTest_B.MagManFoilwitherror_o1 * VisionTest_P.km4pi[0] +
                VisionTest_B.MagManFoilwitherror_o2 * VisionTest_P.km4pi[1]) +
               VisionTest_P.km4pi[2]) / ((VisionTest_B.MagManFoilwitherror_o1 *
    VisionTest_P.km4pi[6] + VisionTest_B.MagManFoilwitherror_o2 *
    VisionTest_P.km4pi[7]) + VisionTest_P.km4pi[8]);
  out_idx_1 = ((VisionTest_B.MagManFoilwitherror_o1 * VisionTest_P.km4pi[3] +
                VisionTest_B.MagManFoilwitherror_o2 * VisionTest_P.km4pi[4]) +
               VisionTest_P.km4pi[5]) / ((VisionTest_B.MagManFoilwitherror_o1 *
    VisionTest_P.km4pi[6] + VisionTest_B.MagManFoilwitherror_o2 *
    VisionTest_P.km4pi[7]) + VisionTest_P.km4pi[8]);

  /* Delay: '<Root>/Delay' */
  /* '<S3>:1:9' X=out(1); */
  /* '<S3>:1:10' Y=out(2); */
  rtb_Delay_idx_0 = VisionTest_DW.Delay_DSTATE[0];
  rtb_Delay_idx_1 = VisionTest_DW.Delay_DSTATE[1];

  /* ManualSwitch: '<Root>/Manual Switch1' incorporates:
   *  Delay: '<Root>/Delay1'
   */
  if (VisionTest_P.ManualSwitch1_CurrentSetting == 1) {
    /* ManualSwitch: '<Root>/Manual Switch' incorporates:
     *  Delay: '<Root>/Delay'
     *  MATLAB Function: '<Root>/Position transformation1'
     */
    if (VisionTest_P.ManualSwitch_CurrentSetting == 1) {
      VisionTest_B.ManualSwitch1[0] = out_idx_0;
      VisionTest_B.ManualSwitch1[1] = out_idx_1;
    } else {
      VisionTest_B.ManualSwitch1[0] = VisionTest_DW.Delay_DSTATE[0];
      VisionTest_B.ManualSwitch1[1] = VisionTest_DW.Delay_DSTATE[1];
    }

    /* End of ManualSwitch: '<Root>/Manual Switch' */
  } else {
    VisionTest_B.ManualSwitch1[0] = VisionTest_DW.Delay1_DSTATE[0];
    VisionTest_B.ManualSwitch1[1] = VisionTest_DW.Delay1_DSTATE[1];
  }

  /* End of ManualSwitch: '<Root>/Manual Switch1' */

  /* Sum: '<Root>/Subtract' */
  VisionTest_B.Subtract[0] = VisionTest_B.X - VisionTest_B.ManualSwitch1[0];
  VisionTest_B.Subtract[1] = VisionTest_B.Y - VisionTest_B.ManualSwitch1[1];

  /* S-Function "sfcn_getFoilCheck_wrapper" Block: <Root>/MagMan Foil with error */
  sfcn_getFoilCheck_Update_wrapper( &VisionTest_B.MagManFoilwitherror_o1,
    &VisionTest_B.MagManFoilwitherror_o2, &VisionTest_B.MagManFoilwitherror_o3,
    &VisionTest_B.MagManFoilwitherror_o4,
    &VisionTest_DW.MagManFoilwitherror_DSTATE);

  /* S-Function "sfcn_posread_shm_wrapper" Block: <S1>/Read position */
  sfcn_posread_shm_Update_wrapper( &VisionTest_B.Readposition_o1,
    &VisionTest_B.Readposition_o2, &VisionTest_DW.Readposition_DSTATE);

  /* Update for Delay: '<Root>/Delay' incorporates:
   *  MATLAB Function: '<Root>/Position transformation1'
   */
  VisionTest_DW.Delay_DSTATE[0] = out_idx_0;

  /* Update for Delay: '<Root>/Delay1' */
  VisionTest_DW.Delay1_DSTATE[0] = rtb_Delay_idx_0;

  /* Update for Delay: '<Root>/Delay' incorporates:
   *  MATLAB Function: '<Root>/Position transformation1'
   */
  VisionTest_DW.Delay_DSTATE[1] = out_idx_1;

  /* Update for Delay: '<Root>/Delay1' */
  VisionTest_DW.Delay1_DSTATE[1] = rtb_Delay_idx_1;

  /* External mode */
  rtExtModeUploadCheckTrigger(1);

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(0, VisionTest_M->Timing.taskTime0);
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.02s, 0.0s] */
    if ((rtmGetTFinal(VisionTest_M)!=-1) &&
        !((rtmGetTFinal(VisionTest_M)-VisionTest_M->Timing.taskTime0) >
          VisionTest_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(VisionTest_M, "Simulation finished");
    }

    if (rtmGetStopRequested(VisionTest_M)) {
      rtmSetErrorStatus(VisionTest_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++VisionTest_M->Timing.clockTick0)) {
    ++VisionTest_M->Timing.clockTickH0;
  }

  VisionTest_M->Timing.taskTime0 = VisionTest_M->Timing.clockTick0 *
    VisionTest_M->Timing.stepSize0 + VisionTest_M->Timing.clockTickH0 *
    VisionTest_M->Timing.stepSize0 * 4294967296.0;
}

/* Model initialize function */
void VisionTest_initialize(void)
{
  /* Registration code */

  /* initialize real-time model */
  (void) memset((void *)VisionTest_M, 0,
                sizeof(RT_MODEL_VisionTest_T));
  rtmSetTFinal(VisionTest_M, -1);
  VisionTest_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  VisionTest_M->Sizes.checksums[0] = (2761779759U);
  VisionTest_M->Sizes.checksums[1] = (4156811726U);
  VisionTest_M->Sizes.checksums[2] = (4141850224U);
  VisionTest_M->Sizes.checksums[3] = (4278516765U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[4];
    VisionTest_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(VisionTest_M->extModeInfo,
      &VisionTest_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(VisionTest_M->extModeInfo, VisionTest_M->Sizes.checksums);
    rteiSetTPtr(VisionTest_M->extModeInfo, rtmGetTPtr(VisionTest_M));
  }

  /* block I/O */
  (void) memset(((void *) &VisionTest_B), 0,
                sizeof(B_VisionTest_T));

  /* states (dwork) */
  (void) memset((void *)&VisionTest_DW, 0,
                sizeof(DW_VisionTest_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    VisionTest_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  /* S-Function Block: <Root>/MagMan Foil with error */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        VisionTest_DW.MagManFoilwitherror_DSTATE = initVector[0];
      }
    }
  }

  /* S-Function Block: <S1>/Read position */
  {
    real_T initVector[1] = { 0 };

    {
      int_T i1;
      for (i1=0; i1 < 1; i1++) {
        VisionTest_DW.Readposition_DSTATE = initVector[0];
      }
    }
  }

  /* InitializeConditions for Delay: '<Root>/Delay' */
  VisionTest_DW.Delay_DSTATE[0] = VisionTest_P.Delay_InitialCondition;

  /* InitializeConditions for Delay: '<Root>/Delay1' */
  VisionTest_DW.Delay1_DSTATE[0] = VisionTest_P.Delay1_InitialCondition;

  /* InitializeConditions for Delay: '<Root>/Delay' */
  VisionTest_DW.Delay_DSTATE[1] = VisionTest_P.Delay_InitialCondition;

  /* InitializeConditions for Delay: '<Root>/Delay1' */
  VisionTest_DW.Delay1_DSTATE[1] = VisionTest_P.Delay1_InitialCondition;
}

/* Model terminate function */
void VisionTest_terminate(void)
{
  /* (no terminate code required) */
}
