/*
 * VisionTest.h
 *
 * Classroom License -- for classroom instructional use only.  Not for
 * government, commercial, academic research, or other organizational use.
 *
 * Code generation for model "VisionTest".
 *
 * Model version              : 1.4
 * Simulink Coder version : 8.11 (R2016b) 25-Aug-2016
 * C source code generated on : Thu Dec 01 17:32:23 2016
 *
 * Target selection: ert.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_VisionTest_h_
#define RTW_HEADER_VisionTest_h_
#include <float.h>
#include <string.h>
#include <stddef.h>
#ifndef VisionTest_COMMON_INCLUDES_
# define VisionTest_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "rtw_extmode.h"
#include "sysran_types.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "dt_info.h"
#include "ext_work.h"
#endif                                 /* VisionTest_COMMON_INCLUDES_ */

#include "VisionTest_types.h"

/* Shared type includes */
#include "multiword_types.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetFinalTime
# define rtmGetFinalTime(rtm)          ((rtm)->Timing.tFinal)
#endif

#ifndef rtmGetRTWExtModeInfo
# define rtmGetRTWExtModeInfo(rtm)     ((rtm)->extModeInfo)
#endif

#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
# define rtmSetStopRequested(rtm, val) ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
# define rtmGetStopRequestedPtr(rtm)   (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  ((rtm)->Timing.taskTime0)
#endif

#ifndef rtmGetTFinal
# define rtmGetTFinal(rtm)             ((rtm)->Timing.tFinal)
#endif

/* Block signals (auto storage) */
typedef struct {
  real_T MagManFoilwitherror_o1;       /* '<Root>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o2;       /* '<Root>/MagMan Foil with error' */
  real_T MagManFoilwitherror_o3;       /* '<Root>/MagMan Foil with error' */
  real_T ManualSwitch1[2];             /* '<Root>/Manual Switch1' */
  real_T Subtract[2];                  /* '<Root>/Subtract' */
  real_T X;                            /* '<Root>/Position transformation' */
  real_T Y;                            /* '<Root>/Position transformation' */
  int32_T MagManFoilwitherror_o4;      /* '<Root>/MagMan Foil with error' */
  int32_T Readposition_o1;             /* '<S1>/Read position' */
  int32_T Readposition_o2;             /* '<S1>/Read position' */
} B_VisionTest_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T MagManFoilwitherror_DSTATE;   /* '<Root>/MagMan Foil with error' */
  real_T Readposition_DSTATE;          /* '<S1>/Read position' */
  real_T Delay_DSTATE[2];              /* '<Root>/Delay' */
  real_T Delay1_DSTATE[2];             /* '<Root>/Delay1' */
  struct {
    void *LoggedData[3];
  } Scope1_PWORK;                      /* '<Root>/Scope1' */

  struct {
    void *LoggedData;
  } Scope2_PWORK;                      /* '<Root>/Scope2' */

  struct {
    void *LoggedData;
  } Scope3_PWORK;                      /* '<Root>/Scope3' */
} DW_VisionTest_T;

/* Parameters (auto storage) */
struct P_VisionTest_T_ {
  real_T km4pi[9];                     /* Variable: km4pi
                                        * Referenced by: '<Root>/Sentinel Calibration matrix'
                                        */
  real_T km4piCam[9];                  /* Variable: km4piCam
                                        * Referenced by: '<Root>/Raspicam Calibration matrix'
                                        */
  real_T Delay_InitialCondition;       /* Expression: 0
                                        * Referenced by: '<Root>/Delay'
                                        */
  real_T Delay1_InitialCondition;      /* Expression: 0
                                        * Referenced by: '<Root>/Delay1'
                                        */
  uint32_T Delay_DelayLength;          /* Computed Parameter: Delay_DelayLength
                                        * Referenced by: '<Root>/Delay'
                                        */
  uint32_T Delay1_DelayLength;         /* Computed Parameter: Delay1_DelayLength
                                        * Referenced by: '<Root>/Delay1'
                                        */
  uint8_T ManualSwitch_CurrentSetting; /* Computed Parameter: ManualSwitch_CurrentSetting
                                        * Referenced by: '<Root>/Manual Switch'
                                        */
  uint8_T ManualSwitch1_CurrentSetting;/* Computed Parameter: ManualSwitch1_CurrentSetting
                                        * Referenced by: '<Root>/Manual Switch1'
                                        */
};

/* Real-time Model Data Structure */
struct tag_RTM_VisionTest_T {
  const char_T *errorStatus;
  RTWExtModeInfo *extModeInfo;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    uint32_T checksums[4];
  } Sizes;

  /*
   * SpecialInfo:
   * The following substructure contains special information
   * related to other components that are dependent on RTW.
   */
  struct {
    const void *mappingInfo;
  } SpecialInfo;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    time_T taskTime0;
    uint32_T clockTick0;
    uint32_T clockTickH0;
    time_T stepSize0;
    time_T tFinal;
    boolean_T stopRequestedFlag;
  } Timing;
};

/* Block parameters (auto storage) */
extern P_VisionTest_T VisionTest_P;

/* Block signals (auto storage) */
extern B_VisionTest_T VisionTest_B;

/* Block states (auto storage) */
extern DW_VisionTest_T VisionTest_DW;

/* Model entry point functions */
extern void VisionTest_initialize(void);
extern void VisionTest_step(void);
extern void VisionTest_terminate(void);

/* Real-time Model object */
extern RT_MODEL_VisionTest_T *const VisionTest_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'VisionTest'
 * '<S1>'   : 'VisionTest/Position from Camera'
 * '<S2>'   : 'VisionTest/Position transformation'
 * '<S3>'   : 'VisionTest/Position transformation1'
 */
#endif                                 /* RTW_HEADER_VisionTest_h_ */
